package pwc.taxtech.atms.common;

public enum OperateLogType {

    /***/
    UnKnown(null, -1),
    /***/
    OperationLogOrganization("operation_log_organization", 0),
    /***/
    OperationLogUser("operation_log_user", 1),
    /***/
    OperationLogProject("operation_log_project", 2),
    /***/
    OperationLogBasicData("operation_log_basic_data", 3),
    /***/
    OperationLogReport("operation_log_report", 4),
    /***/
    OperationLogEnterPrise("operation_log_enter_prise", 5),
    /***/
    OperationLogSubject("operation_log_subject", 6),
    /***/
    OperationLogRole("operation_log_role", 7),
    /***/
    OperationLogModelConfiguration("operation_log_model_configuration", 8),
    /***/
    OperationLogRuleEngine("operation_log_rule_engine", 9),
    /***/
    OperationLogKeyvalue("operation_log_keyvalue", 10),
    /***/
    OperationLogWorkflow("operation_log_work_flow", 11),
    /***/
    OperationLogStock("operation_log_stock", 12),
    /**
     * 股权变更操作日志*/
    OperationLogEquity("operation_log_equity", 13),
    /***/
    ;
    /***/
    private Integer value;

    private String name;

    OperateLogType(String name, Integer value) {
        this.name = name;
        this.value = value;
    }

    public Integer value() {
        return value;
    }

    public String tableName(){return name;}

    public static String getTableName(Integer value) {
        for (OperateLogType type : OperateLogType.values()) {
            if (type.value().intValue() == value.intValue()) {
                return type.tableName();
            }
        }
        return null;
    }

    public static String getName(Integer value) {
        for (OperateLogType type : OperateLogType.values()) {
            if (type.value().intValue() == value.intValue()) {
                return type.name();
            }
        }
        return null;
    }

}
