package pwc.taxtech.atms.common;

import java.text.Collator;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.Locale;

import pwc.taxtech.atms.dto.VMRegionDevTreeData;
import pwc.taxtech.atms.dto.navtree.DevTreeDto;

public abstract class SortUtils {

	
    private SortUtils() {
    }
    
    /**
     * Sort DevTreeDto by text, case insensitive and support chinese pinyin
     * 
     * @param devTreeDtoList
     */
	public static void sortDevTreeDtoByText(List<DevTreeDto<VMRegionDevTreeData>> devTreeDtoList) {
		
		Collections.sort(devTreeDtoList, new Comparator<DevTreeDto<VMRegionDevTreeData>>() {
			@Override
	        public int compare(DevTreeDto<VMRegionDevTreeData> o1, DevTreeDto<VMRegionDevTreeData> o2) {
				Collator instance = Collator.getInstance(Locale.CHINA);  
				return instance.compare(o1.getText().toUpperCase(), o2.getText().toUpperCase());
	        }
		});
	}
}
