package pwc.taxtech.atms.constant.enums;

public enum EnumAnalysisImportType {
    TaxData(0,"各税种税额"),
    ReturnTaxData(1,"实际返还税额"),
    GMVSubsidy(2,"业务线"),
    EmployeeNum(3,"职工人数"),
    DriverNum(4,"司机人数"),

    InternationalBuData(100,"国际税业务数据"),
    InternationalTaxData(101,"国际税税务数据");

    private Integer code;

    private String file;

    EnumAnalysisImportType(Integer code,String file) {
        this.code = code;
        this.file = file;
    }

    public Integer getCode() {
        return code;
    }

    public String getFile() {
        return file;
    }

    public static String getNameByCode(Integer code){
        for(EnumAnalysisImportType enumImportType : EnumAnalysisImportType.values()){
            if(Integer.compare(code, enumImportType.getCode())==0){
                return enumImportType.getFile();
            }
        }
        return null;
    }
}
