package pwc.taxtech.atms.constant.enums;

public enum EnumApiCodeMsg {
    SUCCESS(0, "成功"),
    APIERROR(-1, "接口异常"),
    APIDATAEMPTY(-2, "接口输入数据为空"),

    /** ebs调用Msg**/
    CALLSUCCESS(10000, "调用成功，获取数据中![%s]"),
    CALLFAILED(-10000, "调用EBS接口失败！[%s]"),
    BUSY(-10001, "接口调用失败,系统正忙!"),

    ;

    private Integer code;

    private String msg;

    EnumApiCodeMsg(Integer code, String msg) {
        this.code = code;
        this.msg = msg;
    }

    public Integer getCode() {
        return code;
    }

    public String getMsg() {
        return msg;
    }

    public static EnumApiCodeMsg fromCode(Integer code){
        for(EnumApiCodeMsg error: EnumApiCodeMsg.values()){
            if(error.getCode().intValue()==code.intValue())return error;
        }
        // 超出范围值默认返回异常
        return EnumApiCodeMsg.APIERROR;
    }

    public static String getMsg(Integer code){
        for(EnumApiCodeMsg error: EnumApiCodeMsg.values()){
            if(error.getCode().intValue()==code.intValue())return error.msg;
        }
        // 超出范围值默认返回异常
        return EnumApiCodeMsg.APIERROR.msg;
    }
}
