package pwc.taxtech.atms.constant.enums;

public enum EnumEbsExtractType {
    TB(100,"月度科目余额表"),
    JE(101,"日记账"),
    BSPRC(102,"资产负债表PRC"),
    PLPRC(103,"利润表PRC"),
    BS(104,"资产负债表"),
    PL(105,"利润表"),
    CF(106,"直接法现金流量表"),
    OCTB(107,"所有者权益变动表"),
    RATE(108,"汇率表");

    private int code;

    private String file;

    EnumEbsExtractType(int code, String file) {
        this.code = code;
        this.file = file;
    }

    public int getCode() {
        return code;
    }

    public String getFile() {
        return file;
    }

    public static String getNameByCode(int code){
        for(EnumEbsExtractType enumImportType : EnumEbsExtractType.values()){
            if(Integer.compare(code, enumImportType.getCode())==0){
                return enumImportType.getFile();
            }
        }
        return null;
    }
}
