package pwc.taxtech.atms.constant.enums;

import java.util.HashMap;
import java.util.Map;

public enum EnumInvoiceType {
    VATInvoice(1, "增值税专票"),
    FreightTransport(2, "货运发票"),
    MotorVehicle(3, "机动车发票"),
    AgriculturalProduct(4, "农产品发票"),
    Other(5, "其他发票");

    private int code;
    private String name;
    public static final Map<Integer, String> MAPPING = new HashMap<>();
    public static final Map<String, Integer> NAME_MAPPING = new HashMap<>();
    EnumInvoiceType(int code, String name) {
        this.code = code;
        this.name = name;
    }

    public int getCode() {
        return code;
    }

    public String getName() {
        return name;
    }

    static {
        for (EnumInvoiceType invoiceType : EnumInvoiceType.values()) {
            MAPPING.put(invoiceType.getCode(), invoiceType.getName());
            NAME_MAPPING.put(invoiceType.getName(), invoiceType.getCode());
        }
    }
}
