package pwc.taxtech.atms.constant.enums;

import java.util.HashMap;
import java.util.Map;

public class InvoiceRecordEnum {

    /**
     * 发票类型
     */
    public enum InvoiceType {
        ORDINARY(1, "增值税普通发票"),
        SPECIAL(2, "增值税专用发票");
        private Integer code;
        private String name;
        public static final Map<Integer, String> MAPPING = new HashMap<>();

        InvoiceType(Integer code, String name) {
            this.code = code;
            this.name = name;
        }

        public Integer getCode() {
            return code;
        }

        public String getName() {
            return name;
        }

        static {
            for (InvoiceRecordEnum.InvoiceType invoiceType : InvoiceRecordEnum.InvoiceType.values()) {
                MAPPING.put(invoiceType.getCode(), invoiceType.getName());
            }
        }
    }

    /**
     * 金额类型
     */
    public enum AmountType {
        INVOICE_AMOUNT(1, "开票金额"),
        TAX_AMOUNT(2, "税额");
        private Integer code;
        private String name;
        public static final Map<Integer, String> MAPPING = new HashMap<>();

        AmountType(Integer code, String name) {
            this.code = code;
            this.name = name;
        }

        public Integer getCode() {
            return code;
        }

        public String getName() {
            return name;
        }

        static {
            for (InvoiceRecordEnum.AmountType amountType : InvoiceRecordEnum.AmountType.values()) {
                MAPPING.put(amountType.getCode(), amountType.getName());
            }
        }
    }

}
