package pwc.taxtech.atms.constant.enums;

import java.util.HashMap;
import java.util.Map;

public class ReportFileUploadEnum {

    /**
     * 报表类型
     */
    public enum ReportType {
        NORMAL_DECLARATION("增值税纳税申报表", "增值税纳税申报表"),
        CORR_DECLARATION("增值税更正申报表", "增值税更正申报表"),
        NORMAL_TAX_RECEIPT("增值税纳税税票", "增值税纳税税票"),
        CORR_TAX_RECEIPT("增值税更正税票", "增值税更正税票");
        private String code;
        private String name;
        public static final Map<String, String> MAPPING = new HashMap<>();

        ReportType(String code, String name) {
            this.code = code;
            this.name = name;
        }

        public String getCode() {
            return code;
        }

        public String getName() {
            return name;
        }

        static {
            for (ReportFileUploadEnum.ReportType reportType : ReportFileUploadEnum.ReportType.values()) {
                MAPPING.put(reportType.getCode(), reportType.getName());
            }
        }
    }

    /**
     * 来源类型
     */
    public enum SuorceType {
        VAT("VAT", "VAT"),
        RECORD("RECORD", "档案");
        private String code;
        private String name;
        public static final Map<String, String> MAPPING = new HashMap<>();

        SuorceType(String code, String name) {
            this.code = code;
            this.name = name;
        }

        public String getCode() {
            return code;
        }

        public String getName() {
            return name;
        }

        static {
            for (ReportFileUploadEnum.SuorceType suorceType : ReportFileUploadEnum.SuorceType.values()) {
                MAPPING.put(suorceType.getCode(), suorceType.getName());
            }
        }
    }



}
