package pwc.taxtech.atms.constant.enums;

import java.util.HashMap;
import java.util.Map;

public class TaxesCalculateReportEnum {


    public enum Column {
        Column_1(0, "序号"),
        Column_2(1, "税金项目"),
        Column_3(2, "期间"),
        Column_4(3, "账载收入-明细"),
        Column_5(4, "销项开票收入数-专票"),
        Column_6(5, "销项开票税额-专票"),
        Column_7(6, "销项开票收入数-普票"),
        Column_8(7, "销项开票税额-普票"),
        Column_9(8, "计税基数 (应税收入）"),
        Column_10(9, "税率"),
        Column_11(10, "税额(元)"),
        Column_12(11, "收入类别"),
        Column_13(12, "计税方式"),
        Column_14(13, "备注")
        ;
        private Integer index;
        private String name;
        public static final Map<Integer, String> MAPPING = new HashMap<>();

        Column(Integer index, String name) {
            this.index = index;
            this.name = name;
        }

        public Integer getIndex() {
            return index;
        }

        public String getName() {
            return name;
        }

        static {
            for (TaxesCalculateReportEnum.Column accountType : TaxesCalculateReportEnum.Column.values()) {
                MAPPING.put(accountType.getIndex(), accountType.getName());
            }
        }
    }



}
