package pwc.taxtech.atms.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.service.impl.FormulaServiceImpl;

@RestController
@RequestMapping("/api/v1/formula")
public class FormulaController extends BaseController {

    @Autowired
    FormulaServiceImpl formulaService;

    @ResponseBody
//    @ApiOperation(value = "")
    @RequestMapping(value = "get", method = RequestMethod.GET)
    public OperationResultDto getAllFormulaList() {
        try {
            return OperationResultDto.success(formulaService.getAllFormulaList());
        } catch (Exception e) {
            logger.error("getAllFormulaList error.", e);
        }
        return OperationResultDto.error();
    }

    @ResponseBody
//    @ApiOperation(value = "")
    @RequestMapping(value = "param/get", method = RequestMethod.GET)
    public OperationResultDto getAllFormulaConfigList() {
        try {
            return OperationResultDto.success(formulaService.getAllFormulaParamList());
        } catch (Exception e) {
            logger.error("getAllFormulaConfigList error.", e);
        }
        return OperationResultDto.error();
    }

    @ResponseBody
//    @ApiOperation(value = "")
    @RequestMapping(value = "parammapping/get", method = RequestMethod.GET)
    public OperationResultDto getAllFormulaParamMappingList() {
        try {
            return OperationResultDto.success(formulaService.getAllFormulaParamMappingList());
        } catch (Exception e) {
            logger.error("getAllFormulaParamMappingList error.", e);
        }
        return OperationResultDto.error();
    }

}
