package pwc.taxtech.atms.controller;

import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import pwc.taxtech.atms.dto.ApiResultDto;
import pwc.taxtech.atms.dto.input.CamelPagingResultDto;
import pwc.taxtech.atms.dto.revenuconf.RevTypeAddDto;
import pwc.taxtech.atms.dto.revenuconf.RevenueConfParam;
import pwc.taxtech.atms.dto.revenuconf.RevenueTypeResult;
import pwc.taxtech.atms.service.impl.RevenueTypeMappingService;
import pwc.taxtech.atms.vat.entity.RevenueTypeMapping;

import javax.annotation.Resource;
import java.util.List;

@RestController
@RequestMapping(value = "api/v1/revenueConfMapping")
public class RevenueConfMappingController extends BaseController {

    @Resource
    private RevenueTypeMappingService mappingService;

    @PostMapping("queryPage")
    public CamelPagingResultDto<RevenueTypeResult> queryPage(@RequestBody RevenueConfParam param) {
        return new CamelPagingResultDto<>(mappingService.queryPage(param));
    }

    @PostMapping("add")
    public ApiResultDto addConf(@RequestBody RevTypeAddDto addDto) {
        mappingService.addConfig(addDto);
        return ApiResultDto.success();
    }

    @PostMapping("update")
    public ApiResultDto updateConf(@RequestBody RevenueTypeMapping mapping) {
        mappingService.updateConfig(mapping);
        return ApiResultDto.success();
    }

    @PostMapping("del")
    public ApiResultDto delConf(@RequestBody List<Long> idList) {
        mappingService.delConfig(idList);
        return ApiResultDto.success();
    }

    @PostMapping("upload")
    public ApiResultDto upload(@RequestParam MultipartFile file, @RequestParam Integer type) throws Exception {
        mappingService.upload(file, type);
        return ApiResultDto.success();
    }
}
