package pwc.taxtech.atms.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;
import pwc.taxtech.atms.dto.ServiceTypeDto;
import pwc.taxtech.atms.entity.ServiceType;
import pwc.taxtech.atms.service.impl.ProjectServiceImpl;
import pwc.taxtech.atms.service.impl.ServiceTypeServiceImpl;

import java.util.List;

@RestController
@RequestMapping("/api/v1/servicetype/")
public class ServiceTypeController {

    @Autowired
    private ProjectServiceImpl projectService;
    @Autowired
    private ServiceTypeServiceImpl serviceTypeService;

    @ResponseBody
//    @ApiOperation(value = "获取ServiceType列表")
    @RequestMapping(value = "getlist", method = RequestMethod.GET)
    public List<ServiceTypeDto> getList() {
        return projectService.getServiceList();
    }

    @ResponseBody
    @RequestMapping(value = "getlist", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
    public List<ServiceType> getServiceTypes() {
        return serviceTypeService.getServiceTypes();
    }
}
