package pwc.taxtech.atms.controller;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.service.impl.TemplateFormulaServiceImpl;

@RestController
@RequestMapping(value = "api/v1/templateFormula")
public class TemplateFormulaController {
    @Autowired
    TemplateFormulaServiceImpl templateFormulaService;

    private static final Logger logger = LoggerFactory.getLogger(TemplateFormulaController.class);

    @RequestMapping(value = "validate", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
    public @ResponseBody
    OperationResultDto validate(@RequestBody(required = false) String fromula) {
        try {
            return templateFormulaService.validate(fromula);
        } catch (Exception e) {
            logger.error("TemplateFormulaController Valdate", e);
            OperationResultDto result = new OperationResultDto();
            result.setResult(false);
            return result;
        }
    }

}
