package pwc.taxtech.atms.dto.dimension;

/**
 * @see PwC.Tax.Tech.Atms.Application.Dto\TaxAdminDto\DimensionDto.cs
 */
public enum AttributeTypeEnum {

    /***/
    Unknown(0),
    /***/
    SelfDimension(1),
    /***/
    BusinessUnit(2),
    /***/
    Area(3),
    /**
     * 机构层级
     */
    OrganizationStructure(4),
    /***/
    User(5),
    /***/
    Industry(6),
    /**
     * 子分公司
     */
    OrgSubChildren(7),
    /***/
    OrgCode(8),
    /***/
    TaxPayerNumber(9),
    /**
     * 行政区域
     */
    RegionId(10),
    /***/
    ;

    private Integer value;

    AttributeTypeEnum(Integer value) {
        this.value = value;
    }

    public Integer value() {
        return value;
    }

    public static AttributeTypeEnum valueOf(Integer value) {
        for (AttributeTypeEnum item : AttributeTypeEnum.values()) {
            if (item.value.equals(value)) {
                return item;
            }
        }
        return null;
    }

    public static String int2str(Integer value) {
        for (AttributeTypeEnum item : AttributeTypeEnum.values()) {
            if (item.value.equals(value)) {
                return item.name();
            }
        }
        return null;
    }

}
