package pwc.taxtech.atms.dto.ebsdto;

import javax.validation.constraints.Max;
import javax.validation.constraints.Size;
import java.io.Serializable;

/**
 * @Auther: Gary J Li
 * @Date: 04/03/2019 17:14
 * @Description:
 */
public class OrganizationQueryDto implements Serializable {

    @Size(max=50,message = "纳税人识别号超长,最长为50")
    private String taxPayerNumber;

    @Size(max=50,message = "机构代码超长,最长为50")
    private String code;

    @Size(max=50,message = "机构名称超长,最长为50")
    private String name;

    @Size(max=128,message = "机构名称超长,最长为128")
    private String enterpriseAccountCode;

    @Size(max=200,message = "法定负责人名称超长,最长为200")
    private String legalPersonName;

    @Size(max=500,message = "注册资本超长,最长为500")
    private String registrationCapital;

    @Size(max=500,message = "实缴资本超长,最长为500")
    private String paidInCapital;

    @Size(max=100,message = "注册负责人手机超长,最长为100")
    private String legalPersonPhoneNumber;

    @Size(max=100,message = "注册负责人座机超长,最长为100")
    private String legalPersonLandlineNum;

    @Size(max=100,message = "注册负责人邮箱超长,最长为100")
    private String legalPersonEmailAddress;

    @Size(max=200,message = "注册登记财务负责人姓名超长,最长为200")
    private String regFinancialOfficerName;

    @Size(max=200,message = "注册登记财务负责人手机超长,最长为200")
    private String regFinancialOfficerPhoneNum;

    @Size(max=100,message = "注册登记财务负责人座机超长,最长为100")
    private String regFinancialOfficerLandlineNum;

    @Size(max=100,message = "注册登记财务负责人手机超长,最长为100")
    private String regFinancialOfficerEmailAddress;

    @Size(max=50,message = "记账本位币超长,最长为50")
    private String currencyCode;

    @Size(max=500,message = "注册地址超长,最长为500")
    private String registerAddress;

    @Size(max=300,message = "上级公司名称超长,最长为300")
    private String parentName;

    @Max(value = 99999999,message = "雇员人数超过最大限制")
    private int staffSize;

    public String getTaxPayerNumber() {
        return taxPayerNumber;
    }

    public void setTaxPayerNumber(String taxPayerNumber) {
        this.taxPayerNumber = taxPayerNumber;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getEnterpriseAccountCode() {
        return enterpriseAccountCode;
    }

    public void setEnterpriseAccountCode(String enterpriseAccountCode) {
        this.enterpriseAccountCode = enterpriseAccountCode;
    }

    public String getLegalPersonName() {
        return legalPersonName;
    }

    public void setLegalPersonName(String legalPersonName) {
        this.legalPersonName = legalPersonName;
    }

    public String getRegistrationCapital() {
        return registrationCapital;
    }

    public void setRegistrationCapital(String registrationCapital) {
        this.registrationCapital = registrationCapital;
    }

    public String getPaidInCapital() {
        return paidInCapital;
    }

    public void setPaidInCapital(String paidInCapital) {
        this.paidInCapital = paidInCapital;
    }

    public String getLegalPersonPhoneNumber() {
        return legalPersonPhoneNumber;
    }

    public void setLegalPersonPhoneNumber(String legalPersonPhoneNumber) {
        this.legalPersonPhoneNumber = legalPersonPhoneNumber;
    }

    public String getLegalPersonLandlineNum() {
        return legalPersonLandlineNum;
    }

    public void setLegalPersonLandlineNum(String legalPersonLandlineNum) {
        this.legalPersonLandlineNum = legalPersonLandlineNum;
    }

    public String getLegalPersonEmailAddress() {
        return legalPersonEmailAddress;
    }

    public void setLegalPersonEmailAddress(String legalPersonEmailAddress) {
        this.legalPersonEmailAddress = legalPersonEmailAddress;
    }

    public String getRegFinancialOfficerName() {
        return regFinancialOfficerName;
    }

    public void setRegFinancialOfficerName(String regFinancialOfficerName) {
        this.regFinancialOfficerName = regFinancialOfficerName;
    }

    public String getRegFinancialOfficerPhoneNum() {
        return regFinancialOfficerPhoneNum;
    }

    public void setRegFinancialOfficerPhoneNum(String regFinancialOfficerPhoneNum) {
        this.regFinancialOfficerPhoneNum = regFinancialOfficerPhoneNum;
    }

    public String getRegFinancialOfficerLandlineNum() {
        return regFinancialOfficerLandlineNum;
    }

    public void setRegFinancialOfficerLandlineNum(String regFinancialOfficerLandlineNum) {
        this.regFinancialOfficerLandlineNum = regFinancialOfficerLandlineNum;
    }

    public String getRegFinancialOfficerEmailAddress() {
        return regFinancialOfficerEmailAddress;
    }

    public void setRegFinancialOfficerEmailAddress(String regFinancialOfficerEmailAddress) {
        this.regFinancialOfficerEmailAddress = regFinancialOfficerEmailAddress;
    }

    public String getCurrencyCode() {
        return currencyCode;
    }

    public void setCurrencyCode(String currencyCode) {
        this.currencyCode = currencyCode;
    }

    public String getRegisterAddress() {
        return registerAddress;
    }

    public void setRegisterAddress(String registerAddress) {
        this.registerAddress = registerAddress;
    }

    public String getParentName() {
        return parentName;
    }

    public void setParentName(String parentName) {
        this.parentName = parentName;
    }

    public int getStaffSize() {
        return staffSize;
    }

    public void setStaffSize(int staffSize) {
        this.staffSize = staffSize;
    }
}
