package pwc.taxtech.atms.dto.vatdto;

import pwc.taxtech.atms.constant.DataSourceName;
import pwc.taxtech.atms.constant.enums.FormulaDataSourceType;
import pwc.taxtech.atms.dpo.CellTemplatePerGroupDto;
import pwc.taxtech.atms.vat.entity.PeriodCellData;

import java.math.BigDecimal;

public class TaxCellDataSourceDto extends DataSourceDto {
    private String tag = "";
    private String name;
    private Integer year;
    private Integer period;
    private Integer columnIndex;
    private String columnName;
    private Integer rowIndex;
    private String rowName;
    private String reportTemplateId;
    private String reportName;
    private String cellDataId;
    private String cellTemplateId;
    private Boolean isOnlyManualInput;
    private Integer type;
    private Integer resultType;
    private BigDecimal amount;

    public TaxCellDataSourceDto() {
        this.type = FormulaDataSourceType.Report.getCode();
    }

    public void extractFromGroup(WPNAMEParasBo parasBo, Integer period, Integer year,
                                 CellTemplatePerGroupDto cellTemplateData) {
        this.tag = "WPNAME";
        this.name = DataSourceName.ReportDataSource;
        this.year = year;
        this.period = period;
        this.columnIndex = cellTemplateData.getColumnIndex();
        this.columnName = cellTemplateData.getColumnName();
        this.rowIndex = cellTemplateData.getRowIndex();
        this.rowName = cellTemplateData.getRowName();
        this.reportTemplateId = cellTemplateData.getReportTemplateId();
        this.cellTemplateId = cellTemplateData.getCellTemplateId() + "";
        this.resultType = cellTemplateData.getResultType();
        this.isOnlyManualInput = false;
        this.reportName = parasBo.getReportCode();
    }
    public void extractFromGroup(WPTYPEParasBo parasBo, Integer period, Integer year,
                                 CellTemplatePerGroupDto cellTemplateData) {
        this.tag = "WPTYPE";
        this.name = DataSourceName.ReportDataSource;
        this.year = year;
        this.period = period;
        this.columnIndex = cellTemplateData.getColumnIndex();
        this.columnName = cellTemplateData.getColumnName();
        this.rowIndex = cellTemplateData.getRowIndex();
        this.rowName = cellTemplateData.getRowName();
        this.reportTemplateId = cellTemplateData.getReportTemplateId();
        this.cellTemplateId = cellTemplateData.getCellTemplateId() + "";
        this.resultType = cellTemplateData.getResultType();
        this.isOnlyManualInput = false;
        this.reportName = parasBo.getReportCode();
    }
    public static TaxCellDataSourceDto nullDataSource(BBParasBo bbParasBo, CurrentPeriodBo currentPeriodBo) {
        TaxCellDataSourceDto nulDataSource = new TaxCellDataSourceDto();
        nulDataSource.name = DataSourceName.ReportDataSource;
        nulDataSource.reportTemplateId = bbParasBo.getReportCode();
        nulDataSource.year = currentPeriodBo.curYear;
        nulDataSource.period = currentPeriodBo.getCurPeriod();
        nulDataSource.columnIndex = bbParasBo.getColumnIndex() - 1;
        nulDataSource.rowIndex = bbParasBo.getRowIndex() - 1;
        nulDataSource.isOnlyManualInput = false;
        nulDataSource.reportName = bbParasBo.getReportCode();
        return nulDataSource;
    }

    public void extractFromGroup(BBParasBo bbParasBo, CurrentPeriodBo currentPeriodBo,
                                 PeriodCellData cellData, CellTemplatePerGroupDto cellTemplateData) {
        this.name = DataSourceName.ReportDataSource;
        this.year = currentPeriodBo.curYear;
        this.period = currentPeriodBo.curPeriod;
        this.columnIndex = bbParasBo.getColumnIndex() - 1;
        this.columnName = cellTemplateData.getColumnName();
        this.rowIndex = bbParasBo.getRowIndex() - 1;
        this.rowName = cellTemplateData.getRowName();
        this.reportTemplateId = cellTemplateData.getReportTemplateId();
        this.cellDataId = cellData.getId() + "";
        this.cellTemplateId = cellData.getCellTemplateId() + "";
        this.resultType = cellTemplateData.getResultType();
        this.isOnlyManualInput = false;
        this.reportName = bbParasBo.getReportCode();
    }

    public void extractFromGroup(BBParasBo bbParasBo, Integer period, Integer year,
                                 CellTemplatePerGroupDto cellTemplateData) {
        this.name = DataSourceName.ReportDataSource;
        this.year = year;
        this.period = period;
        this.columnIndex = bbParasBo.getColumnIndex() - 1;
        this.columnName = cellTemplateData.getColumnName();
        this.rowIndex = bbParasBo.getRowIndex() - 1;
        this.rowName = cellTemplateData.getRowName();
        this.reportTemplateId = cellTemplateData.getReportTemplateId();
        this.cellTemplateId = cellTemplateData.getCellTemplateId() + "";
        this.resultType = cellTemplateData.getResultType();
        this.isOnlyManualInput = false;
        this.reportName = bbParasBo.getReportCode();
    }

    public void fixedWithGroup(CellTemplatePerGroupDto dto) {
        cellTemplateId = dto.getCellTemplateId();
        rowName = dto.getRowName();
        columnName = dto.getColumnName();
        reportTemplateId = dto.getReportTemplateId();
        resultType = dto.getResultType();
    }

    public String getTag() {
        return this.tag;
    }

    public void setTag(String tag) {
        this.tag = tag;
    }

    @Override
    public String getName() {
        return this.name;
    }

    @Override
    public void setName(String name) {
        this.name = name;
    }

    @Override
    public Integer getYear() {
        return this.year;
    }

    @Override
    public void setYear(Integer year) {
        this.year = year;
    }

    @Override
    public Integer getPeriod() {
        return this.period;
    }

    @Override
    public void setPeriod(Integer period) {
        this.period = period;
    }

    @Override
    public Integer getColumnIndex() {
        return this.columnIndex;
    }

    @Override
    public void setColumnIndex(Integer columnIndex) {
        this.columnIndex = columnIndex;
    }

    @Override
    public String getColumnName() {
        return this.columnName;
    }

    @Override
    public void setColumnName(String columnName) {
        this.columnName = columnName;
    }

    @Override
    public Integer getRowIndex() {
        return this.rowIndex;
    }

    @Override
    public void setRowIndex(Integer rowIndex) {
        this.rowIndex = rowIndex;
    }

    @Override
    public String getRowName() {
        return this.rowName;
    }

    @Override
    public void setRowName(String rowName) {
        this.rowName = rowName;
    }

    @Override
    public String getReportTemplateId() {
        return this.reportTemplateId;
    }

    @Override
    public void setReportTemplateId(String reportTemplateId) {
        this.reportTemplateId = reportTemplateId;
    }

    public String getReportName() {
        return this.reportName;
    }

    public void setReportName(String reportName) {
        this.reportName = reportName;
    }

    @Override
    public String getCellDataId() {
        return this.cellDataId;
    }

    @Override
    public void setCellDataId(String cellDataId) {
        this.cellDataId = cellDataId;
    }

    @Override
    public String getCellTemplateId() {
        return this.cellTemplateId;
    }

    @Override
    public void setCellTemplateId(String cellTemplateId) {
        this.cellTemplateId = cellTemplateId;
    }

    public Boolean getIsOnlyManualInput() {
        return this.isOnlyManualInput;
    }

    public void setIsOnlyManualInput(Boolean onlyManualInput) {
        this.isOnlyManualInput = onlyManualInput;
    }

    @Override
    public Integer getType() {
        return this.type;
    }

    @Override
    public void setType(Integer type) {
        this.type = type;
    }

    @Override
    public Integer getResultType() {
        return this.resultType;
    }

    @Override
    public void setResultType(Integer resultType) {
        this.resultType = resultType;
    }

    @Override
    public BigDecimal getAmount() {
        return this.amount;
    }

    @Override
    public void setAmount(BigDecimal amount) {
        this.amount = amount;
    }
}
