package pwc.taxtech.atms.security;

/**
 * Usage1:<br>
 * mvn exec:java -Dexec.mainClass="pwc.taxtech.atms.security.LdapMain" -Dexec.args="username password LDAP://nam.ad.pwcinternal.com NAM"
 * Usage2:<br>
 * mvn exec:java -Dexec.mainClass="pwc.taxtech.atms.security.LdapMain" -Dexec.args="username password LDAP://cn.asia.ad.pwcinternal.com CN"
 */
public class LdapMain {

    public static void main(String[] args) {
        boolean argCheck = args != null && args.length >= 4;
        if (!argCheck) {
            System.out.println("Usage: java <MainClassName> username password ldapUrl domain");
            return;
        }
        String username = args[0];
        String password = args[1];
        String ldapUrl = args[2];
        String domain = args[3];
        LdapAuthenticationProviderImpl provider = new LdapAuthenticationProviderImpl();
        System.out.println("Ready to call authenticate");
        boolean authenticateResult = provider.authenticate(username, password, ldapUrl, domain);
        System.out.println("authenticateResult:" + authenticateResult);
    }

}
