package pwc.taxtech.atms.service;

import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.dto.ebsdto.*;

import java.util.List;

public interface EbsApiService {

    /**
     * EBS 日记账同步更新
     *
     * @param items
     */
    void queryRemoteServerThenUpdateJE(Long id,List<JournalEntryQueryDto> items);

    /**
     * ebs 科目余额表同步更新
     *
     * @param items
     */
    void queryRemoteServerThenUpdateTB(Long id,List<TrialBalanceQueryDto> items);

    /**
     * ebs 现金流量表同步更新
     *
     * @param items
     */
    void queryRemoteServerThenUpdateCF(Long id,List<CashFlowQueryDto> items);

    /**
     * ebs 资产负债表同步更新
     *
     * @param items
     */
    void queryRemoteServerThenUpdateBS(Long id,List<BalanceSheetQueryDto> items);

    /**
     * ebs 资产负债表PRC同步更新
     *
     * @param items
     */
    void queryRemoteServerThenUpdateBSprc(Long id,List<BalanceSheetPrcQueryDto> items);

    /**
     * ebs 利润表同步更新
     *
     * @param items
     */
    void queryRemoteServerThenUpdatePL(Long id ,List<ProfitLossStatementQueryDto> items);

    /**
     * ebs 利润表PRC同步更新
     *
     * @param items
     */
    void queryRemoteServerThenUpdatePLprc(Long id,List<ProfitLossStatementPrcQueryDto> items);

    /**
     * ebs 汇率表同步更新
     *
     * @param items
     */
    void queryRemoteServerThenUpdateOAR(Long id,List<OrganizationAccountingRateQueryDto> items);

    /**
     * ebs 机构信息表同步更新
     *
     * @param items
     */
    void queryRemoteServerThenUpdateOrg(Long id, List<OrganizationQueryDto> items);

    /**
     * ebs最后调用更新状态
     * @param ebsCallBackDto
     */
    void changeCallBackStatus(EbsCallBackDto ebsCallBackDto);

    /**
     * ebs 触发同步机构信息
     * @param
     */
    OperationResultDto syncOrg();
}
