package pwc.taxtech.atms.service.impl;

import org.springframework.stereotype.Service;
import pwc.taxtech.atms.dao.OperationLogFileTypeMapper;
import pwc.taxtech.atms.entity.OperationLogFileType;
import pwc.taxtech.atms.entity.OperationLogFileTypeExample;
import javax.annotation.Resource;
import java.util.List;

/**
 * 查询
 */
@Service
public class OperationLogFileTypeServiceImpl {

    @Resource
    private OperationLogFileTypeMapper operationLogFileTypeMapper;

    public List<OperationLogFileType> selectFileTypesList(){
        OperationLogFileTypeExample example = new OperationLogFileTypeExample();
        return operationLogFileTypeMapper.selectByExample(example);
    }

    public boolean addFileTypesList(OperationLogFileType operationLogFileType){
        int num = operationLogFileTypeMapper.insert(operationLogFileType);
        if(num>0){
            return true;
        }else{
            return false;
        }
    }

    public boolean deleteFileTypes(String id){
        int num = operationLogFileTypeMapper.deleteByPrimaryKey(id);
        if(num>0){
            return true;
        }else{
            return false;
        }
    }

    public boolean editFilesType(OperationLogFileType operationLogFileType){
        int num = operationLogFileTypeMapper.updateByPrimaryKey(operationLogFileType);
        if(num>0){
            return true;
        }else{
            return false;
        }
    }

    public List<OperationLogFileType> selectListForLog(List<String> fileTypeIds) {
        OperationLogFileTypeExample example = new OperationLogFileTypeExample();
        OperationLogFileTypeExample.Criteria criteria = example.createCriteria();
        if (null != fileTypeIds && fileTypeIds.size()>0){
            criteria.andIdIn(fileTypeIds);
        }
        return operationLogFileTypeMapper.selectByExample(example);
    }
}
