package pwc.taxtech.atms.service.impl;

import org.springframework.stereotype.Service;
import pwc.taxtech.atms.dao.OperationLogTaxDocumentMapper;
import pwc.taxtech.atms.entity.OperationLogTaxDocument;
import pwc.taxtech.atms.entity.OperationLogTaxDocumentExample;
import javax.annotation.Resource;
import java.util.List;

/**
 * 查询
 */
@Service
public class OperationLogTaxDocServiceImpl {

    @Resource
    private OperationLogTaxDocumentMapper operationLogTaxDocumentMapper;

    public List<OperationLogTaxDocument> selectTaxDocumentList(){
        OperationLogTaxDocumentExample example = new OperationLogTaxDocumentExample();
        return operationLogTaxDocumentMapper.selectByExample(example);
    }

    public boolean addTaxDocumentList(OperationLogTaxDocument operationLogTaxDocument){
        int num = operationLogTaxDocumentMapper.insert(operationLogTaxDocument);
        if(num>0){
            return true;
        }else{
            return false;
        }
    }

    public boolean deleteTaxDocument(String id){
        int num = operationLogTaxDocumentMapper.deleteByPrimaryKey(id);
        if(num>0){
            return true;
        }else{
            return false;
        }
    }

    public boolean editFilesType(OperationLogTaxDocument operationLogTaxDocument){
        int num = operationLogTaxDocumentMapper.updateByPrimaryKey(operationLogTaxDocument);
        if(num>0){
            return true;
        }else{
            return false;
        }
    }

    public List<OperationLogTaxDocument> selectListForLog(List<String> taxDocumentIds) {
        OperationLogTaxDocumentExample example = new OperationLogTaxDocumentExample();
        OperationLogTaxDocumentExample.Criteria criteria = example.createCriteria();
        if (taxDocumentIds.size()>0){
            criteria.andIdIn(taxDocumentIds);
        }
        return operationLogTaxDocumentMapper.selectByExample(example);
    }
}
