package pwc.taxtech.atms.vat.dao;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import pwc.taxtech.atms.invoice.InputInvoiceMapper;
import pwc.taxtech.atms.vat.entity.InputInvoice;
import pwc.taxtech.atms.vat.entity.InputInvoiceExample;

import java.util.Calendar;
import java.util.List;

@Service
public class InputInvoiceDao {
    @Autowired
    InputInvoiceMapper inputInvoiceMapper;

    public List<InputInvoice> getInputInvoice(Integer period, String invoiceType, String checkPass, String scanPass, String notPass) {
        InputInvoiceExample example = new InputInvoiceExample();
        InputInvoiceExample.Criteria criteria = example.createCriteria();

        if (period != null) {
            Calendar date = Calendar.getInstance();
            String year = String.valueOf(date.get(Calendar.YEAR));
            //认证期间
            criteria.andRZSQEqualTo(year + (period > 9 ? period.toString() : "0" + period.toString()));
        }

        if (invoiceType != null) {
            //发票类型
            criteria.andFPLXEqualTo(String.valueOf(invoiceType));
//            criteria1.andFPLXEqualTo(String.valueOf(invoiceType));
        }

        if (StringUtils.isNotBlank(notPass)) {
            String unPass = "2";
            //认证结果
            criteria.andRZJGEqualTo(unPass);
//            criteria1.andRZJGEqualTo(unPass);
        } else if (StringUtils.isNotBlank(checkPass) && StringUtils.isNotBlank(scanPass)) {
            String pass = "1";
            criteria.andRZJGEqualTo(pass);
//            criteria1.andRZJGEqualTo(pass);
//            example.or(criteria1);
        }
        //发票状态
        criteria.andFPZTNotEqualTo("1"); // 过滤作废状态

//        List<InputInvoice> list = inputInvoiceMapper.selectByExample(example).stream().filter(x -> {
//            return x.getRZSQ().endsWith("-" + (period.intValue() > 9 ? period.toString() : "0" + period.toString()));
//        }).collect(Collectors.toList());
        return inputInvoiceMapper.selectByExample(example);
    }
}
