package pwc.taxtech.atms.vat.service.impl;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.vat.dao.PeriodCellCommentMapper;
import pwc.taxtech.atms.vat.entity.PeriodCellComment;
import pwc.taxtech.atms.vat.entity.PeriodCellCommentExample;

import java.util.List;
import java.util.Optional;

@Service
public class CellCommentServiceImpl {
    private final  static Logger logger = LoggerFactory.getLogger(CellCommentServiceImpl.class);

    @Autowired
    public PeriodCellCommentMapper periodCellCommentMapper;
    public OperationResultDto<List<PeriodCellComment>> getCellComments(Optional<Long> cellDataId,String projectId) {
        OperationResultDto resultDto = new OperationResultDto();
        try {
            if (!cellDataId.isPresent() || cellDataId.get() == 0L) {
                resultDto.setResult(false);
                resultDto.setResultMsg("cellDataId is invalid");
                return resultDto;
            }

            PeriodCellCommentExample example = new PeriodCellCommentExample();
            example.createCriteria().andCellDataIdEqualTo(cellDataId.get());
            example.createCriteria().andProjectIdEqualTo(projectId);
            List<PeriodCellComment> cellComments = periodCellCommentMapper.selectByExample(example);
            resultDto.setResult(true);
            resultDto.setData(cellComments);
        } catch (Exception ex) {
            logger.error(ex.getMessage(), ex);
            resultDto.setResult(false);
        }
        return resultDto;
    }
}
