package pwc.taxtech.atms.vat.service.impl;

import com.grapecity.documents.excel.Workbook;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;
import pwc.taxtech.atms.dto.vatdto.JsonExportDto;

import java.io.File;
import java.io.InputStream;
import java.util.UUID;

@Component
public class ExportServiceImpl {

    private final static Logger logger = LoggerFactory.getLogger(ExportServiceImpl.class);

    public String export(JsonExportDto jsonExportDto, String serverPath) {
        String filePath = "";
        try{
            filePath = String.format("%s_%s.xlsx",jsonExportDto.getType(), UUID.randomUUID().toString());
            String fullFilePath = combine(serverPath, filePath);
            Workbook workbook = new Workbook();
            workbook.fromJson(jsonExportDto.getJsonData());
            workbook.save(fullFilePath);
        }catch (Exception e){
            logger.error(String.format("导出文件异常:%s",e.getMessage()));
        }
        return filePath;
    }

    private String combine(String parent, String child) {
        return String.format("%s" + File.separator + "%s", parent, child);
    }

}
