package pwc.taxtech.atms.vat.service.impl.report.functions;

import org.apache.poi.ss.formula.OperationEvaluationContext;
import org.apache.poi.ss.formula.eval.EvaluationException;
import org.apache.poi.ss.formula.eval.NumberEval;
import org.apache.poi.ss.formula.eval.StringEval;
import org.apache.poi.ss.formula.eval.ValueEval;
import org.apache.poi.ss.formula.functions.FreeRefFunction;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import pwc.taxtech.atms.exception.Exceptions;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Map;

import static pwc.taxtech.atms.common.util.FormulaUtil.resolverInteger;
import static pwc.taxtech.atms.common.util.FormulaUtil.resolverString;

/**
 * author kevin
 * todo 需要检验公式的准确
 */

public class SUM2 extends FunctionBase implements FreeRefFunction {
    final static ValueEval defaultEval = new StringEval("0");
    static final Logger LOGGER = LoggerFactory.getLogger(BB.class);
    public BigDecimal cellValue;

    public SUM2(FormulaContext formulaContext) {
        super(formulaContext);
    }

    //检查参数合法性
    public Map parameterCheck(ValueEval[] valueEvals, OperationEvaluationContext ec) {
        Map<String, Object> map = new HashMap<String, Object>();
        if(valueEvals.length != 2)
            throw Exceptions.parameterError;
        try {
            String argsOne = resolverString(valueEvals, ec, 0);
            String argsTwo = resolverString(valueEvals, ec, 1);
            if(!argsOne.substring(0,1).equals(argsTwo.substring(0,1)))
                throw Exceptions.parameterError;
            map.put("colIndex", argsOne.substring(0,1));
            map.put("rowIndexBegin", argsOne.substring(1,1));
            map.put("rowIndexEnd", argsTwo.subSequence(1,1));
        } catch (EvaluationException e) {
            e.printStackTrace();
            return  null;
        }
        return map;
    }

    @Override
    public ValueEval evaluate(ValueEval[] valueEvals, OperationEvaluationContext operationEvaluationContext) {
        Map map = parameterCheck(valueEvals, operationEvaluationContext);
        if(map != null){
            return new NumberEval(getSUM2Data(formulaContext.getReportTemplateGroupId(), formulaContext.getPeriod(), map));
        };
        return new NumberEval(0.00);
     /*   for (int i = 0, j = valueEvals.length; i < j; i++) {
            try {
                return new NumberEval(sum(getData(parameter(resolverString(valueEvals, operationEvaluationContext, i)))).doubleValue());
            } catch (EvaluationException e) {
                e.printStackTrace();
                return defaultEval;
            }
        }*/
    }
}
