﻿systemConfigurationModule.directive('subjectCorresponding', ['$log',
    function ($log) {
        'use strict';
        $log.debug('subjectCorresponding.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/admin/systemConfiguration/subjectCorresponding/subject-corresponding.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'SubjectCorrespondingController',
            link: function (scope, element) {
                  
                Split(['#left-container', '#right-container'], {
                    //An array of initial sizes of the elements, specified as percentage values. Example: Setting the initial sizes to 25% and 75%.
                    sizes: [78, 22],

                    //An array of minimum sizes of the elements, specified as pixel values. Example: Setting the minimum sizes to 100px and 300px, respectively.
                    minSize: [750, 250],

                    onDragEnd: function () {
                        //$timeout(function () {
                        //    $rootScope.$broadcast(enums.vatEvent.layoutChanged, {});
                        //}, 700);
                    }
                });

                $(".multi-org-container").on("click", function (e) {
                    e.stopPropagation();
                });

                var ClearSelectedTreeNode = function () {
                    ClearSelectedTreeNodeRecursion(scope.OrgMultiData);
                    scope.selectedCopyOrgIDList = [];
                    scope.checkedSet = {};
                };


                //递归清除选中的节点
                var ClearSelectedTreeNodeRecursion = function (tree) {
                    tree.forEach(function (o) {
                        o.selected = false;
                        if (o.children) {
                            ClearSelectedTreeNodeRecursion(o.children);
                        }
                    });
                };

                //显示复制对应关系下的组织机构多选列表
                scope.displayMultiOrg = function () {

                    //ClearSelectedTreeNode();
                    scope.gridInstance.unselectAll();
                    if ($('.multi-org-container').is(":hidden")) {
                        $(".multi-org-container").show();
                    } else {
                        $(".multi-org-container").hide();
                    }

                    $(document).one("click", function () {
                        $(".multi-org-container").hide();
                    });
                    event.stopPropagation();
                };

                scope.closeMultiOrg = function () {
                    $(".multi-org-container").hide();
                };

                var previousOrgID, previousEspID;

                //企业科目列表和标准科目列表切换
                scope.SwitchAccount = function (flag) {
                    $('.subject-corresponding-container').toggle();
                    $('.std-subject-container').toggle();

                    var currentOrgID = scope.enterpriseAccountSetSelect && scope.enterpriseAccountSetSelect.id || '';
                    var currentEspID = scope.selectedOrgID;


                    if (flag == 'detail') {

                        //修改之后无法查看，直接查接口
                        // if (previousEspID === currentEspID && currentOrgID === previousOrgID) {
                        //     return;
                        // }

                        scope.InitStdSubjectLinkEtsSubject();

                        previousOrgID = currentOrgID;
                        previousEspID = currentEspID;
                    }
                };

                $(".filter-select").on("click", function (e) {
                    e.stopPropagation();
                });

                scope.showFilter = function () {
                    if ($('.filter-select').is(":hidden")) {
                        $(".filter-select").show();
                    } else {
                        $(".filter-select").hide();
                    }

                    $(document).one("click", function () {
                        $(".filter-select").hide();
                    });
                    event.stopPropagation();
                };
            }
        };
    }
]);