﻿citModule.controller('citImportDocumentListController', ['$scope', '$rootScope', '$log', '$translate', '$timeout', '$q', '$compile', '$stateParams',
    'apiInterceptor', 'vatExportService', 'SweetAlert', 'ackMessageBox', 'vatSessionService', 'templateService', 'BSPLService', 'vatReportService',
    'vatOperationLogService', 'loginContext', 'enums', '$state', 'vatCommonService', 'vatWorkflowService', 'projectService'
    , '$uibModal', '$cookies', 'Upload', 'vatImportService', 'dataImportService','uiGridConstants', '$interval',
    function ($scope, $rootScope, $log, $translate, $timeout, $q, $compile, $stateParams, apiInterceptor, vatExportService, SweetAlert, ackMessageBox,
        vatSessionService, templateService, BSPLService, vatReportService, vatOperationLogService, loginContext, enums, $state, vatCommonService
        , vatWorkflowService, projectService, $uibModal, $cookies, Upload, vatImportService, dataImportService,uiGridConstants,$interval) {
        'use strict';
        $log.debug('citImportDocumentListController.ctor()...');


        var uploadFileDtoList = [];
        var selectedDocCategroyCode = '1000';
        //var reportCode = {
        //    FinanceLostReport: 'CIT.CL004',
        //    ResearchCost: 'CIT.CL022'
        //}

        // TODO: Remove the default org setting
        $scope.DEFAULT_ORGID = "fc3246a4-2158-4539-a4c0-a7d498a38098";
        $scope.taxDocumentCategory = [];
        $scope.org = {};
        $scope.selectedOrges = []; //文件上传，选中的机构
        $scope.showAmount = false;
        $scope.showProjectCode = false;
        $scope.selectedUploadFiles = [];
        $scope.fileUploadToServer = [];
        $scope.selectedDocType = {};
        $scope.selectedDocName = {};
        //$scope.treeTypeCode = '1100'; //选中左边TreeNode时的文档类型(第二级)，先hardcode
        $scope.documentDetail = [];
        //$scope.selectedReportCode = '';
        $scope.selectedMultiDocTypes = []; //上传文件，文档类型多选框
        //$scope.hasDocument = false;
        //$scope.docNum = 0;

        var taxTypeCode = {
            FinanceLost: '1100', //资产损失
            ResearchCost: '1250', //研发费用
            TaxAudit: '7050' //税务稽查
        };

       

        $scope.exportReportTreeOptions = {
            dataSource: [{ id: '0', templateId: '0', name: '纳税申报表', items: [], expanded: true }],
            displayExpr: 'name',
            keyExpr: 'id',
            selectionMode: 'Multiple',
            showCheckBoxesMode: 'normal',
            dataStructure: "plain",
            selectByClick: true,
            selectNodesRecursive: true,
            expandAllEnabled: true,
            expandNodesRecursive: true,
            onSelectionChanged: function(args) {
                $scope.selectedReportIds = args.component.getSelectedNodesKeys();
            }
        };

        //打开导出文件弹出框
        $scope.openExportPop = function() {
            var grp = _.find($scope.$parent.$parent.groups, function(g) {
                return g.name == 'TaxReturn';
            });

            if (!grp || !grp.children) {
                return;
            }

            $scope.exportReportTreeOptions.dataSource[0].items = [];
            $scope.exportReportTreeOptions.dataSource[0].items = _.map(grp.children, function(item) {
                return { id: item.reportId, templateId: item.id, name: item.name, parentId: '0' };
            });

            var parentElem = angular.element($('#exportReportFilesContainer'));
            $scope.exportReportInstance = $uibModal.open({
                ariaLabelledBy: 'modal-title',
                ariaDescribedBy: 'modal-body',
                templateUrl: 'exportReport.html',
                windowClass: 'data-table',
                appendTo: parentElem,
                backdrop: 'static',
                scope: $scope
            });
        }

        //批量导出EXCEL
        $scope.export = function() {
            var grp = _.find($scope.$parent.$parent.groups, function(g) {
                return g.name == 'TaxReturn';
            });

            if (!grp || !grp.children) {
                return;
            }

            if (!$scope.selectedReportIds || $scope.selectedReportIds.length == 0) {
                SweetAlert.warning($translate.instant('ExportReportRequiredCheck'));
                return;
            }

            //设置报表的排序号，用于对导出的报表sheet进行排序
            var orderIndex = 0;
            _.each(grp.children, function (item) {
                item.orderIndex = orderIndex;
                orderIndex++;
            });

            var reportArray = $scope.selectedReportIds;

            $scope.spreads = [];
            $scope.exportReportData = [];
            $('.export-container').html('');
            $('#export').html('');

            $scope.exportSheetNum = reportArray.length;
            var promiss = [];

            //报表数据源公式检查表达式。
            var reg = /^([A-Z]+[0-9]+){1}$|^([A-Z]+[0-9]+){1}([\+-]{1}[A-Z]+[0-9]+)+$/g;
            var exportReportData = [];
            angular.forEach(reportArray, function(currentVal) {
                var node = _.first(_.where(grp.children, { reportId: currentVal }));
                if (!node) {
                    return;
                }
                var reportPromiss = vatReportService.getReportData(node.reportId).success(function(reportData) {
                    if (reportData && reportData.data) {
                        _.each(reportData.data, function(x) {
                            x.value = x.cellValue;
                            if (x.formula && reg.test(x.formula)) {
                                x.isFormula = true;
                            }
                            x.isExportData = true;
                            delete x.cellValue;
                        });

                        reportData.data.reportName = node.name;
                        reportData.data.orderIndex = node.orderIndex;
                        reportData.data.templateId = node.id;
                        exportReportData.push(reportData.data);
                    }
                });
                promiss.push(reportPromiss);
            });

            $q.all(promiss).then(function () {
                //重新排序报表
                exportReportData = _.sortBy(exportReportData, function (item) {
                    return item.orderIndex;
                });

                for (var j = 0; j < exportReportData.length; j++) {
                    var report = "<vat-report-sheet id='r_" + exportReportData[j].templateId + "' spread='spreads[" + j + "]' report-source = 'exportReportData[" + j + "]' template-id='\"" + exportReportData[j].templateId + "\"' is-export='true' service-type='6'></vat-report-sheet>";
                    var html = $compile(report)($scope);
                    $('.export-container').append(html);
                }

                timeOutExportSpread(exportReportData);
            });
            return;
        };

        var timeOutCount = 0;
        function timeOutExportSpread(exportReportData) {
            //20秒之内一直等待spreadjs初始化完成所有需要下载的报表，直到超时
            if ($scope.validateFileCount === $scope.spreads.length || timeOutCount === 20) {
                exportSpread(exportReportData);
                timeOutCount = 0;
            } else {
                $timeout(function () {
                    timeOutExportSpread(exportReportData);
                }, 1000);
            }
            timeOutCount++;
        }

        function exportSpread(exportReportData) {
            $scope.exportReportData = exportReportData;
            $timeout(function() {
                var mainSpread = new GcSpread.Sheets.Spread(document.getElementById("export"), { sheetCount: 1 });
                mainSpread.isPaintSuspended(true);
                mainSpread.sheets.pop();
                for (var index = 0; index < $scope.spreads.length; index++) {

                    var currentSheet = $scope.spreads[index].getActiveSheet();
                    currentSheet.setIsProtected(false);
                    for (var rowIndex = 0; rowIndex < currentSheet.getRowCount(); rowIndex++) {
                        for (var columnIndex = 0; columnIndex < currentSheet.getColumnCount(); columnIndex++) {
                            var cellStyle = currentSheet.getActualStyle(rowIndex, columnIndex, GcSpread.Sheets.SheetArea.viewport, true);
                            currentSheet.setStyle(rowIndex, columnIndex, cellStyle, GcSpread.Sheets.SheetArea.viewport);
                        }
                    }

                    mainSpread.sheets.push(currentSheet);
                }

                var dataObj = {
                    "spread": mainSpread.toJSON(),
                    "exportFileType": "xlsx"
                };

                var content = JSON.stringify(dataObj);
                dataObj = null;

                vatExportService.exportReport(content).success(function(data) {
                    window.open(loginContext.vatApiHost + '/' + data);
                });
                $('.export-container').html('');
                $('#export').html('');

                $log.debug(mainSpread);
            }, 500);
        };

        $scope.$on(enums.vatEvent.reportRendered, function() {
            $scope.exportSheetNum = $scope.exportSheetNum - 1;
            if ($scope.exportSheetNum <= 0) {
                exportSpread();
            }
        });

        ///////////////////////

        //展示导入模态框
        $scope.showImportModal = function () {
            $scope.operateType = constant.Operation.Add;
        }

        $scope.selectTemplate = function (m) {

        }
        $scope.templateModel = {};

        $scope.refreshReportView = function (model) {
            $scope.$broadcast("refreshReportView", "");
        }


        $scope.isUpdateTemplate = false;

        $scope.showOperateLogPop = function() {
            $scope.isShowLog = true;
        };

        $scope.saveDocumentList = function () {
            $scope.$broadcast(enums.vatEvent.saveReportSheet);
        };

        var initTaxGridView = {
            initGridDocumentDetail: function () {
                var columns = [];
                var actionTemplate = "<div class='document-detail-action'>"
                                    //+ " <span ng-click='grid.appScope.lintToItem(row.entity)'>关联事项</span>"
                                    + " <span>删除</span>"
                                    + " </div>";

                columns.push({ name: $translate.instant('LogIndex'), cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}</span></div>', width: '5%' },
                             { name: $translate.instant('DocumentName'), cellTemplate: '<div class="ui-grid-cell-contents"><a href="#" ng-click="grid.appScope.openDocumentFile(row.entity)">{{row.entity.taxDocumentName}}</a></div>', width: '20%' },
                             { name: $translate.instant('DocumentProjectCode'), cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.projectCode}}</span></div>' },
                             { name: $translate.instant('Amount'), cellTemplate: '<div class="ui-grid-cell-contents" style="text-align:right"><span>{{row.entity.amount}}</span></div>', width: '15%' },
                             { name: $translate.instant('DocumentExpiredDuration'), cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.expiredDuration}}</span></div>', width: '20%' },
                             { name: $translate.instant('UploadFileTime'), cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.uploadTimeString}}</span></div>' },
                             { name: $translate.instant('UploadUserName'), cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.uploadUserName}}</span></div>' },
                             { name: $translate.instant('LogComments'), cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.comments}}<span></div>' },
                             { name: $translate.instant('Action'), cellTemplate: actionTemplate}
                           );

                $scope.gridDocumentDetailOptions = {
                    enableColumnResizing: true,
                    rowHeight: constant.UIGrid.rowHeight,
                    selectionRowHeaderWidth: constant.UIGrid.rowHeight,
                    enableSorting: false,
                    enableColumnMenus: false,
                    virtualizationThreshold: 50,//默认加载50条数据，避免在数据展示时，只显示前面4条
                    enableHorizontalScrollbar: uiGridConstants.scrollbars.NEVER,
                    enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
                    columnDefs: columns,    
                    onRegisterApi: function (gridApi) {
                        $scope.gridDocumentApi = gridApi;
                        // call resize every 500 ms for 5 s after modal finishes opening - usually only necessary on a bootstrap modal
                        $interval(function () {
                            $scope.gridDocumentApi.core.handleWindowResize();
                        }, 500, 60 * 60 * 8);
                    }
                }

                $scope.documentDetail = [];
            },

        };


        //初始化各类下拉框
        var initDropDown = {
            //文档类型单选框
            initDocType: function (categoryCode) {
                var docTypeDataSource = _.where($scope.taxDocumentCategory, { codeLevel: 2, parentCode: categoryCode });
                $("#ddlDocType").dxSelectBox({
                    dataSource: docTypeDataSource,
                    valueExpr: 'code',
                    displayExpr: 'name',
                    height: "35px",
                    onValueChanged: function (e) {
                        //initDropDown.initDocName(e.value);
                    },
                    onSelectionChanged: function (e) {
                        if (!_.isNull(e.selectedItem)) {
                            $scope.selectedDocType = e.selectedItem;
                            //$scope.showProjectCode = e.selectedItem.code === taxTypeCode.ResearchCost ? true : false;
                            //$scope.showAmount = e.selectedItem.code === taxTypeCode.FinanceLost ? true : false;
                            initDropDown.initDocName(e.selectedItem.code);
                        }                      
                    }
                });         
            },


            //文档类型多选框
            initDocTypeMulti: function (categoryCode) {
                var docTypeDataSource = _.where($scope.taxDocumentCategory, { codeLevel: 2, parentCode: categoryCode });
                $scope.docTypeMultiOptions = {
                    bindingOptions: {
                        value: 'selectedMultiDocTypes',
                    },
                    valueExpr: "code",
                    displayExpr: "name",
                    placeholder: "",
                    showClearButton: false,
                    dataSource: docTypeDataSource,
                    treeView: {
                        dataSource: docTypeDataSource,
                        dataStructure: "plain",
                        keyExpr: "code",
                        displayExpr: "name",
                        selectByClick: true,
                        selectNodesRecursive: false,
                        showCheckBoxesMode: "normal",
                        selectionMode: "multiple",
                        height: "200px",
                        onContentReady: function (e) {
                            $scope.docTypeMultiComponent = e.component;
                            //if ($scope.docTypeMultiComponent) {
                            //    $scope.docTypeMultiComponent.unselectAll();
                            //}

                        },
                        onItemSelectionChanged: function (args) {
                            var value = args.component.getSelectedNodesKeys();
                            $scope.selectedMultiDocTypes = value;
                            var getFinanceLost = _.find($scope.selectedMultiDocTypes, function (el) { return el === taxTypeCode.FinanceLost; });
                            var getResearchCost = _.find($scope.selectedMultiDocTypes, function (el) { return el === taxTypeCode.ResearchCost; });
                            $scope.showProjectCode = !_.isUndefined(getResearchCost) ? true : false;
                            $scope.showAmount = !_.isUndefined(getFinanceLost) ? true : false;
                            initDropDown.initDocName($scope.selectedMultiDocTypes);
                        }
                    }
                };


            },

            //文档名称单选框
            initDocName: function (docTypeCode) {
                var docTypeDataSource = [];
                $scope.selectedMultiDocTypes.forEach(function (item, index) {
                    var getDocument = _.where($scope.taxDocumentCategory, { codeLevel: 3, parentCode: item });
                    docTypeDataSource = docTypeDataSource.concat(getDocument);
                });

                //if (docTypeCode !== '') {
                //    docTypeDataSource = _.where($scope.taxDocumentCategory, { codeLevel: 3, parentCode: docTypeCode });
                //}
                $("#ddlDocName").dxSelectBox({
                    dataSource: docTypeDataSource,
                    valueExpr: 'code',
                    displayExpr: 'name',
                    height: "35px",
                    onValueChanged: function (e) {
                    },
                    onSelectionChanged: function (e) {
                        $scope.selectedDocName = e.selectedItem;                     
                    }
                });
           
            },

            //机构多选框
            initOrg: function () {
                var initalYearTree = function () {
                    if ($scope.orgTreeView) {
                        $scope.fromSyncSelection = true;
                        $scope.orgTreeView.unselectAll();
                        $scope.fromSyncSelection = false;
                    }
                };
                $scope.orgFilterOptions = {
                    bindingOptions: {
                        value: 'selectedOrges',
                    },
                    valueExpr: "id",
                    displayExpr: "name",
                    placeholder: "",
                    showClearButton: false,
                    dataSource: $scope.org,
                    treeView: {
                        dataSource: $scope.org,
                        dataStructure: "plain",
                        keyExpr: "id",
                        displayExpr: "name",
                        selectByClick: true,
                        selectNodesRecursive: false,
                        showCheckBoxesMode: "normal",
                        selectionMode: "multiple",
                        height: "200px",
                        onContentReady: function (e) {
                            $scope.orgTreeView = e.component;
                            initalYearTree();
                        },
                        onItemSelectionChanged: function (args) {
                            if (!$scope.fromSyncSelection) {
                                var value = args.component.getSelectedNodesKeys();
                                $scope.selectedOrges = value;
                                console.log("选中的机构:");
                                console.log($scope.selectedOrges);
                            }
                        }
                    }
                };
            }
        };



        //初始化各类日期选择框
        var initDatePick = {      
            initUploadDatePick: function (id) {
                $('#' + id).dxDateBox({
                    type: "date",
                    showClearButton: true,
                    value: new Date()
                });
            }
        };


        //清除下拉框、日期等数据
        var clearData = {
            clearUploadWindowValue: function () {
                $scope.selectedUploadFiles = [];
                $scope.fileUploadToServer = [];
                uploadFileDtoList = [];
                //$scope.showProjectCode = false;
                //$scope.showAmount = false;
                $('#projecCode').val('');
                $("#amount").val('');
                $('#txtRemark').val('');
                //$('#ddlDocType').dxSelectBox('instance').option('value', '');
                $('#ddlDocName').dxSelectBox('instance').option('value', '');
            }
        };

      
        var loadPageData = function () {
            dataImportService.getAllTaxDocumentCategory().success(function (re) {
                if (re.result) {
                    $scope.taxDocumentCategory = re.data;
                    //$scope.taxCategoryNav = _.where($scope.taxDocumentCategory, { codeLevel: 1 });
                    dataImportService.getOrginaztionById($scope.DEFAULT_ORGID).success(function (re) {
                        if (re.result) {
                            $scope.org = re.data;                                               
                        }
                    });
                }
            });
        }
        $scope.templateDownload = function () {
            vatReportService.getTemplateDownloadPath($stateParams.templateid).success(function (url) {
                window.open(loginContext.apiHost + url.replace("~", ""), "_blank");
            });
        };

        var showUpload = function () {
            if (selectedDocCategroyCode === '') {
                selectedDocCategroyCode = _.where($scope.taxDocumentCategory, { codeLevel: 1 })[0].code;
            }
       
          
            initDropDown.initDocType(selectedDocCategroyCode);
            initDropDown.initDocTypeMulti(selectedDocCategroyCode);
            initDropDown.initDocName('');
            initDropDown.initOrg();
            clearData.clearUploadWindowValue();
            initDatePick.initUploadDatePick('dateExpiredFrom');
            initDatePick.initUploadDatePick('dateExpiredTo');    
            $('#modalUploadFile').modal('show');
        };


        var showDocumentDetail = function (typeCode, rogId) {
            $scope.documentDetail = [];       
            dataImportService.getDocumentManageList(typeCode, rogId).success(function (re) {
                if (re.result) {
                    var data = re.data;
                    var showDocDetailAmountColumn = false;
                    var showDocDetailProjectCode = false;
                    if (data[0]) {
                        var firstTypeCode = data[0].taxTypeCode;
                        if (firstTypeCode === taxTypeCode.FinanceLost) {
                            showDocDetailAmountColumn = true;
                            showDocDetailProjectCode = false;
                        }

                        if (firstTypeCode === taxTypeCode.ResearchCost) {
                            showDocDetailProjectCode = true;
                            showDocDetailAmountColumn = false;
                        }
                    }

                    data.forEach(function (item, index) {
                        var dtExpiredFrom = new Date(item.expiredFrom);
                        var dtExpiredTo = new Date(item.expriedTo);
                        var uploadTime = new Date(item.uploadTime);
                        item.expiredDuration = dtExpiredFrom.formatDateTime('yyyy-MM-dd') + ' ' + $translate.instant('Duration') + ' '
                                                + dtExpiredTo.formatDateTime('yyyy-MM-dd');
                        item.uploadTimeString = uploadTime.formatDateTime('yyyy-MM-dd');
                        item.amount = PWC.round(item.amount, 2);
                        $scope.documentDetail.push(item);
                    });

                    var actionColumn = _.where($scope.gridDocumentDetailOptions.columnDefs, { name: $translate.instant('Action') })[0];
                    var projectColumn = _.where($scope.gridDocumentDetailOptions.columnDefs, { name: $translate.instant('DocumentProjectCode') })[0];
                    var amountColumn = _.where($scope.gridDocumentDetailOptions.columnDefs, { name: $translate.instant('Amount') })[0];
                    if (!_.isUndefined(projectColumn) && !_.isUndefined(amountColumn)) {
                        projectColumn.visible = showDocDetailProjectCode;
                        amountColumn.visible = showDocDetailAmountColumn;
                    }
                    if (!_.isUndefined(actionColumn)) {
                        actionColumn.visible = $scope.documentDetail.length > 0;
                    }

                    if ($scope.documentDetail.length === 0) {
                        var emptyRow = {};
                        emptyRow.expiredDuration = $translate.instant('NoData');
                        $scope.documentDetail.push(emptyRow);
                    }

                    

                    $scope.gridDocumentDetailOptions.data = $scope.documentDetail;
                    $('#modalDocumentDetail').modal('show');
                }
            });
        };

        var refreshDocList = function () {
            ackMessageBox.confirm($translate.instant('ConfirmClearDataBeforeSyncTemplate')).then(function (ifConfirm) {
                vatReportService.citRefreshDocList(vatSessionService.project.id, $scope.docTemplateId || $stateParams.templateid, !ifConfirm, vatSessionService.logUser.id).then(function () {
                    $scope.$broadcast('refreshReportView');
                });
            });
        };

        //控制明细信息中删除权限
        var getUserPermission = function () {
            var list = [];
            $scope.editCode = constant.citPermission.dataImport.documentList.importCode;
            list.push($scope.editCode);
            $scope.hasEditPermission = false;
            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasEditPermission = data[$scope.editCode];
            });
        };


        (function initialize() {
            $log.debug('citImportDocumentListController.initialize()...');
            //$scope.cellDoubleClick = cellDoubleClick;
            //$scope.cellClick = cellClick;

            //修复多个modal依次弹出时叠加的问题
            $(document).on('show.bs.modal', '.modal', function () {
                var zIndex = 1040 + (10 * $('.modal:visible').length);
                $(this).css('z-index', zIndex);
                setTimeout(function () {
                    $('.modal-backdrop').not('.modal-stack').css('z-index', zIndex - 1).addClass('modal-stack');
                }, 0);
            });

            getUserPermission();
            $scope.showUpload = showUpload;
            $scope.showDocumentDetail = showDocumentDetail;
            $scope.refreshDocList = refreshDocList;
            initTaxGridView.initGridDocumentDetail();
            loadPageData();
           
        })();
    }
]);