﻿citModule.controller('CitImportDataCtrl', ['$scope', '$log', 'Upload', '$timeout', '$http', '$translate', '$interval', '$q'
    , 'loginContext', 'enums', 'SweetAlert', 'dataImportService', 'vatImportService', 'modelConfigurationService', '$uibModal'
    , 'vatSessionService', 'citSessionService', 'uiGridConstants', 'projectService', 'vatCommonService',
function ($scope, $log, Upload, $timeout, $http, $translate, $interval, $q, loginContext
    , enums, SweetAlert, dataImportService, vatImportService, modelConfigurationService, $uibModal
    , vatSessionService, citSessionService, uiGridConstants, projectService, vatCommonService) {
    var webHost = loginContext.apiHost;
    var fileGuid = ''; //保存上传文件后在server端生成的guid 
    var importMethod = ''; //oneClick:一键导入；universal：万能导入
    var importType = -1; //0:覆盖；1：添加
    var projectId = vatSessionService.project.id;
    var period = enums.wholeYearPeriod.import; //citSessionService.month; //period < 0 覆盖导入时会删除所有数据
    var projectDbName = vatSessionService.project.dbName;
    var fileExtension = '';
    var fileNames = [];
    var token = $('input[name="__RequestVerificationToken"]').val();
    var CONST_ACEOLEDB = "Microsoft.ACE.OLEDB.12.0 is not registered";
    var validateCategory = enums.ValidateCategoryEnum.Basic;
    var ValidationConstructor = function (num, imagePic, dataCheckType, errorCount, tips, erpCheckTypeId
        , imageTypeId, period, validationDetails) {
        this.num = num;
        this.imagePic = imagePic;
        this.dataCheckType = dataCheckType;
        this.errorCount = errorCount;
        this.tips = tips;
        this.erpCheckTypeId = erpCheckTypeId;
        this.imageTypeId = imageTypeId;
        this.period = period;
        this.validationDetails = validationDetails;
    };
    var DuplicateValidationConstructor = function (num, tableName, duplicateCount, erpCheckTypeId, validationDetails) {
        this.num = num;
        this.tableName = tableName;
        this.duplicateCount = duplicateCount;
        this.erpCheckTypeId = erpCheckTypeId;
        this.validationDetails = validationDetails;
    };

    $scope.filePath = '';
    $scope.showUniversal = false;
    $scope.startNumber = -1;
    $scope.excelDownloadPath = webHost + '/Resource/ImportData/万能模板.xlsx';
    $scope.csvDownLoadPath = webHost + '/Resource/ImportData/csv万能模板.zip';
    $scope.duplicateList = [];
    $scope.basicCheckList = [];
    $scope.correctCheckList = [];
    $scope.checkTypeId = null;

    //设置正确性、重复数据验证的错误提示图标
    var setValidationErrorStyle = function (chkCorrect, checkDuplicate) {
        var errorCount = 0;
        var duplicateNum = 0;
        var activeErrorStyle = {
            'background-image': 'url(/app-resources/images/vat/error.png)',
            'background-repeat': 'no-repeat',
            'background-position': 'right 5px center'
        }

        var inactiveErrorStyle = {
            'background-image': 'none'
        }

        if (chkCorrect) {
            for (var i = 1; i < $scope.correctCheckList.length; i++) {
                errorCount = $scope.correctCheckList[i].errorCount;
                if (errorCount > 0) {
                    break;
                }
            }

            if (errorCount > 0) {
                return activeErrorStyle;
            }
            else {
                return inactiveErrorStyle;
            }
        }


        if (checkDuplicate) {
            for (var i = 1; i < $scope.duplicateList.length; i++) {
                duplicateNum = $scope.duplicateList[i].duplicateCount;
                if (duplicateNum > 0) {
                    break;
                }
            }

            if (duplicateNum > 0) {
                return activeErrorStyle;
            }
            else {
                return inactiveErrorStyle;
            }
        }

    };


    //点击一键/万能导入
    var importTypeSwitch = function (index) {
        //一键导入
        if (index === 1) {
            $scope.filePath = $translate.instant('ConfirmSelectErpImportFileTitle');
            importMethod = 'oneClick';
            $scope.showUniversal = false;
            $scope.startNumber = -1;
            $('#btnOneClick').removeClass('disableBtn');
            $('#btnUniversal').addClass('disableBtn');
        }

        //万能导入
        if (index === 2) {
            $scope.filePath = $translate.instant('ConfirmSelectErpImportFileTitle');
            importMethod = 'universal';
            $scope.showUniversal = true;
            $scope.startNumber = 0;
            $('#btnUniversal').removeClass('disableBtn');
            $('#btnOneClick').addClass('disableBtn');
        }
    };


    //上传文件
    var uploadFiles = function (files, errFiles) {
        $scope.f = files;
        $scope.showError = false;
        $scope.errFile = errFiles && errFiles[0];
        if (files && files.length) {
            fileNames = [];
            angular.forEach($scope.f, function (file) {
                fileNames.push(file.name);
            })
            $scope.filePath = fileNames.toString();//$scope.f[0].name;
            if (!checkUploadFiles($scope.f)) {
                return false;
            }

            Upload.upload({
                url: webHost + '/api/v1/financeImportData/importData/financeDataUpload',
                data: {
                    importMethod: importMethod,
                    file: files
                },
                headers: {
                    'Access-Control-Allow-Origin': '*',
                    Authorization: loginContext.tokenType + ' ' + loginContext.apiToken,
                    from: vatSessionService.project.dbName + '@cn.pwc.com'
                },
                __RequestVerificationToken: token,
                withCredentials: true
            }).then(function (response) {
                var ret = response.data;
                if (ret.result) {
                    fileGuid = ret.data.guid;
                    fileExtension = ret.data.fileExtension;
                }
                else {
                    if (ret.resultMsg && ret.resultMsg.length > 0) {
                        swal({
                            title: $translate.instant('FailureTitle'),
                            text: $translate.instant('UploadFileFail') + ret.resultMsg,
                            type: "error",
                            confirmButtonText: $translate.instant('Confirm')
                        });
                        //alert(ret.resultMsg);
                    }
                }

                //$timeout(function () {
                //    file.result = response.data;
                //});

            }, function (response) {
                console.log('import error: ' + response.status);
                if (response.status > 0) {
                    //$scope.errorMsg = response.status + ': ' + response.data;
                    $log.debug('erp load file error:');
                    $log.debug(response.status + ': ' + response.data);
                }


            }, function (evt) {
                //file.progress = Math.min(100, parseInt(100.0 *
                //                         evt.loaded / evt.total));
                $scope.progress =
                  Math.min(100, parseInt(100.0 * evt.loaded / evt.total));

            });
        }
        else {
            // $scope.showError = true;
        }

    };


    //导入财务数据
    var importData = function (importTypeParam) {
        if ($scope.filePath == $translate.instant('ConfirmSelectErpImportFileTitle')) {
            swal({
                title: $translate.instant('ConfirmSelectErpImportFileTitle'),
                text: $translate.instant('ConfirmSelectErpImportFile'),
                type: "warning",
                confirmButtonText: $translate.instant('Yes')
            });
            return false;
        }

        if (vatSessionService.project.projectStatusList[period] >= constant.ProjectStatusEnum.AccountMapSubmitted) {
            swal({
                title: "warning!",
                text: $translate.instant('IsConfirmToReImport').formatObj({ status: vatCommonService.getProjectStautsEnumDesc(vatSessionService.project.projectStatusList[period]) }),
                type: "warning",
                showCancelButton: true,
                confirmButtonText: $translate.instant('ConfirmYes'),
                cancelButtonText: $translate.instant('ConfirmNo'),
                closeOnConfirm: false,
                closeOnCancel: false
            },
            function (isConfirm) {
                if (isConfirm) {
                    swal.close();
                    startToImportErpData(importTypeParam);
                }
                else {
                    swal.close();
                }
            });
        }
        else {
            startToImportErpData(importTypeParam);
        }



    };


    var startToImportErpData = function (importTypeParam) {
        vatImportService.getImportType(projectId, period, constant.serviceType.CIT).success(function (data) {
            if (data === enums.TbImportTypeEnum.UnImported || data === enums.TbImportTypeEnum.ErpImported) {
                importErpData(importTypeParam);
            }

            if (data === enums.TbImportTypeEnum.TbImported) {
                swal({
                    title: $translate.instant('ConfirmCleartTbTitle'),
                    text: $translate.instant('ConfirmTbDataToDelete'),
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonText: $translate.instant('Yes'),
                    cancelButtonText: $translate.instant('No'),
                    closeOnConfirm: true,
                    closeOnCancel: true
                },
                 function (isConfirm) {
                     //1. 清除TB导入数据
                     if (isConfirm) {
                         vatImportService.deleteTbData(period)
                           .success(function (data) {
                               //2. 导入财务数据
                               if (data) {
                                   importErpData(importTypeParam);
                               }
                               else {
                                   swal({
                                       title: $translate.instant('FailureTitle'),
                                       text: $translate.instant('ClearTbError'),
                                       type: "error",
                                       confirmButtonText: $translate.instant('Confirm')
                                   });
                               }
                           });
                     }
                 });
            }
        });
    };


    //校验界面
    var openTab = function (evt, tabId) {
        var i, tabcontent, tablinks;
        //隐藏所有tabContent
        tabcontent = document.getElementsByClassName("tabContent");
        for (i = 0; i < tabcontent.length; i++) {
            tabcontent[i].style.display = "none";
        }

        //删除所有tab button中的active, inactive class
        tablinks = document.getElementsByClassName("tablinks");
        for (i = 0; i < tablinks.length; i++) {
            tablinks[i].className = tablinks[i].className.replace(" active", "");
            tablinks[i].className = tablinks[i].className.replace(" inactive", "");
            tablinks[i].className = tablinks[i].className.replace(" inactive-rightborder", "");
        }

        evt.currentTarget.className += " active";

        /*
        //设置选中tab   
        document.getElementById(tabId).style.display = "block";
        evt.currentTarget.className += " active";

        //设置未选中tab
        for (i = 0; i < tablinks.length; i++) {
            if (tablinks[i].id != evt.currentTarget.id) {
                tablinks[i].className += " inactive";

                if ($("#btnCorrectChk").attr("class").indexOf(" active") === -1) {
                    if (_.isEqual(tablinks[i].id, "btnBasicChk")) {
                        tablinks[i].className += " inactive-rightborder";
                    }

                    if (_.isEqual(tablinks[i].id, "btnCorrectChk")) {
                        //基础数据验证和数据正确性验证都不可用时，只要基础数据验证加右边框就可以了
                        if ($("#btnBasicChk").attr("class").indexOf("inactive-rightborder") === -1) {
                            tablinks[i].className += " inactive-rightborder";
                        }
                    }
                }
                
            }            
        }
        */

        if (evt.currentTarget.id === "btnDuplicateData") {
            validateCategory = enums.ValidateCategoryEnum.Duplicate;
            if ($scope.duplicateList.length === 0) {
                getDuplicateRecords().then(function () {
                    setDuplicateValidationSummaryGrid($scope.duplicateList);
                });
            }
            else {

                setDuplicateValidationSummaryGrid($scope.duplicateList);
            }
        }


        if (evt.currentTarget.id === "btnBasicChk") {
            validateCategory = enums.ValidateCategoryEnum.Basic;
            if ($scope.basicCheckList.length === 0) {
                getBasicValidationRecords().then(function () {
                    setValicationSummaryGrid($scope.basicCheckList, validateCategory);
                });
            }
            else {
                setValicationSummaryGrid($scope.basicCheckList, validateCategory);
            }

        }

        if (evt.currentTarget.id === "btnCorrectChk") {
            validateCategory = enums.ValidateCategoryEnum.Correctness;
            if ($scope.correctCheckList.length === 0) {
                getCorrectValidationRecords().then(function () {
                    setValicationSummaryGrid($scope.correctCheckList, validateCategory);
                });
            }
            else {
                setValicationSummaryGrid($scope.correctCheckList, validateCategory);
            }

        }
    };


    //删除选中的Voucher
    var deleteDuplicateVouchers = function () {
        var duplicateDataGrid = $('#gridDuplicateDetail').dxDataGrid("instance");
        var selectedVouchers = [];
        duplicateDataGrid.getSelectedRowsData().done(function (rowData) {
            rowData.forEach(function (item, index) {
                selectedVouchers.push(item.VoucherID);
            });

            if (selectedVouchers.length > 0) {
                dataImportService.deleteVoucherDuplicateItems(selectedVouchers)
                  .success(function (data) {
                      $scope.closeValidtionModal();
                      if (data) {
                          swal({
                              title: $translate.instant('SuccessTitle'),
                              text: $translate.instant('DeleteSuccess'),
                              type: "success",
                              timer: 1000
                          });
                          ReCheckAndManageData();
                      }
                  });
            }
            else {
                SweetAlert.warning($translate.instant('DeleteEmptyWarning'));
            }
        });
    };


    //删除选中的CustBalance
    var deleteDuplicateTbes = function () {
        var duplicateDataGrid = $('#gridDuplicateDetail').dxDataGrid("instance");
        var selectedTbes = [];
        duplicateDataGrid.getSelectedRowsData().done(function (rowData) {
            rowData.forEach(function (item, index) {
                selectedTbes.push(item.BalanceId);
            });

            if (selectedTbes.length > 0) {
                dataImportService.deleteCustBalanceItems(selectedTbes)
                  .success(function (data) {
                      $scope.closeValidtionModal();
                      if (data) {
                          swal({
                              title: $translate.instant('SuccessTitle'),
                              text: $translate.instant('DeleteSuccess'),
                              type: "success",
                              timer: 1000
                          });
                          ReCheckAndManageData();
                      }
                  });
            }
            else {
                SweetAlert.warning($translate.instant('DeleteEmptyWarning'));
            }
        });
    };


    //检查用户机构权限
    var checkUserOrganizationPermissionList = function () {
        var list = [];
        var userManageTemp = constant.vatPermission.dataImport.erpImport;
        list.push(userManageTemp.importCode);
        $scope.hasImportPermission = false;
        $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
            $scope.hasImportPermission = data[userManageTemp.importCode];
        });
    };


    //根据hasImportPermission设置按钮的样式
    var setButtonSetByPermission = function () {
        if (!$scope.hasImportPermission) {
            return { cursor: "not-allowed" };
        }
        else {
            return { cursor: "default" };
        }
    };


    //清理数据校验的数组
    var clearAllDataValidationArray = function () {
        $log.debug("start to clear all data validation array");
        $scope.duplicateList = [];
        $scope.basicCheckList = [];
        $scope.correctCheckList = [];
    };


    //导入数据
    var importErpData = function (importTypeParam) {
        $log.debug("start to import data");
        importType = importTypeParam;
        $http({
            method: 'POST',
            url: webHost + '/api/v1/financeImportData/importData/importFinancedata',
            params: {
                importMethod: importMethod,
                importType: importType,
                fileName: fileNames,
                fileGuid: fileGuid,
                fileExtension: fileExtension,
                period: period
            },
            headers: {
                'Access-Control-Allow-Origin': '*',
                Authorization: loginContext.tokenType + ' ' + loginContext.apiToken,
                from: vatSessionService.project.dbName + '@cn.pwc.com'
            },
            __RequestVerificationToken: token,
            withCredentials: true
        }).then(function successCallback(response) {
            var ret = response.data;
            if (ret.result) {
                swal({
                    title: $translate.instant('SuccessTitle'),
                    text: $translate.instant('ImportErpDataSuccess'),
                    type: "success",
                    timer: 1000
                });
                $log.debug("import data successfully,start to update project import type");
                updateProjectImportType();
                clearAllDataValidationArray();
                vatCommonService.setProjectStatus(projectDbName, period, constant.ProjectStatusEnum.Imported
                    , constant.DictionaryDictKey.WFImportErpData, enums.FinishStatusEnum.Finished);
                vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isErpImport, true);
                $log.debug("import erp importErpData: " + vatSessionService.project.importSubStatus.isErpImport);
                getPeriodInfor();
                startManageData(period);
                $scope.filePath = $translate.instant('ConfirmSelectErpImportFileTitle'); //还原导入文件路径

            }
            else {
                $scope.filePath = $translate.instant('ConfirmSelectErpImportFileTitle');//还原导入文件路径; //清理导入文件路径
                if (ret.resultMsg && ret.resultMsg.length > 0) {
                    var errorMessages = "";
                    var popUpErrorMsg = "";
                    ret.data.forEach(function (item, index) {
                        errorMessages = errorMessages + "\r\n" + item.errorMsg;
                    });
                    //出错信息中包含CONST_ACEOLEDB的话，弹出特殊提示
                    errorMessages = errorMessages.toLowerCase();
                    if (errorMessages.indexOf(CONST_ACEOLEDB.toLowerCase()) > 0) {
                        popUpErrorMsg = $translate.instant('ACEOLEDBUnInstallError');
                    }
                    else {
                        popUpErrorMsg = $translate.instant('ImportErpDataFail') + ret.resultMsg;
                    }

                    swal({
                        title: $translate.instant('FailureTitle'),
                        text: popUpErrorMsg,
                        type: "error",
                        confirmButtonText: $translate.instant('Confirm')
                    });
                }

            }
        }, function errorCallback(response) {
            $log.debug('erp import data error');
            $log.debug(response);
        });
    };


    //上传文件格式验证
    var checkUploadFiles = function (files) {
        var result = true;
        for (var i = 0; i < files.length; i++) {
            var item = files[i];
            var fileName = item.name;
            var fileExtension = fileName.substr(fileName.lastIndexOf(".") + 1, fileName.length - fileName.lastIndexOf(".")).toLowerCase();
            if (fileExtension !== enums.ValidFileExtension.CSV
              && fileExtension !== enums.ValidFileExtension.XLS
              && fileExtension !== enums.ValidFileExtension.XLSX) {
                swal({
                    title: $translate.instant('WarningTitle'),
                    text: $translate.instant('ErpUploadFileExtensionCheck'),
                    type: "warning",
                    confirmButtonText: $translate.instant('Confirm')
                });
                result = false;
            }
        }

        return result;
    };


    //组装重复数据验证数据
    var initDuplicateRecords = function (or) {
        var data = or.data;
        $scope.duplicateList = [];
        data.forEach(function (item, index) {
            var validteDto = new DuplicateValidationConstructor(item.num, item.tableName, item.duplicateCount
                , item.erpCheckTypeId, item.validationDetails);
            $scope.duplicateList.push(validteDto);
        });
    }


    //重复数据验证
    var getDuplicateRecords = function () {
        var deferred = $q.defer();
        dataImportService.getDuplicateResults().success(function (data) {
            initDuplicateRecords(data);
            deferred.resolve();
        });

        return deferred.promise;
    };


    //组装基础校验数据
    var initBasicValicationsRecords = function (or) {
        var data = or.data;
        $scope.basicCheckList = [];
        data.forEach(function (item, index) {
            var validteDto = new ValidationConstructor(item.num, item.imagePic, item.dataCheckType, item.errorCount
                      , item.tips, item.erpCheckTypeId, item.imageTypeId, item.period, item.validationDetails);
            $scope.basicCheckList.push(validteDto);
        });
    };


    //基础数据验证
    var getBasicValidationRecords = function () {
        var deferred = $q.defer();
        dataImportService.getBasicValidationResults()
          .success(function (data) {
              initBasicValicationsRecords(data);
              deferred.resolve();
          });
        return deferred.promise;
    };


    //组装数据正确性验证
    var initCorrectValidationRecords = function (or) {
        var data = or.data;
        $scope.correctCheckList = [];
        data.forEach(function (item, index) {
            var validteDto = new ValidationConstructor(item.num, item.imagePic, item.dataCheckType, item.errorCount
                     , item.tips, item.erpCheckTypeId, item.imageTypeId, item.period, item.validationDetails);
            $scope.correctCheckList.push(validteDto);
        });
    };


    //数据正确性验证
    var getCorrectValidationRecords = function () {
        var deferred = $q.defer();
        dataImportService.getCitCorrectValidationResults().success(function (data) {
            initCorrectValidationRecords(data);
            deferred.resolve();
        });
        return deferred.promise;
    };


    //运行所有校验并选中基础数据验证
    var getAllValidationResults = function (isManage) {
        dataImportService.getBasicValidationResults().success(function (baiscData) {
            initBasicValicationsRecords(baiscData);
            dataImportService.getCitCorrectValidationResults().success(function (correctData) {
                initCorrectValidationRecords(correctData);
                dataImportService.getDuplicateResults().success(function (dupData) {
                    initDuplicateRecords(dupData);
                    triggBasicCheck();
                    $scope.setValidationErrorStyle(true, false);
                    $scope.setValidationErrorStyle(false, true);
                    if (isManage) {
                        SweetAlert.success($translate.instant('ManageDataSuccess'));
                    }
                });
            });
        });
    };


    //1.数据整理
    var startManageData = function (period) {
        dataImportService.manageData(period).success(function (data) {
            getAllValidationResults(true);
        });
    };


    //更新TaxAdmin中dbo.PeriodInfo.ImportType
    var updateProjectImportType = function () {
        var queryImportDto = {
            serviceTypeId: constant.serviceType.CIT,
            periods: [period],
            projectId: projectId,
            importTypeId: enums.TbImportTypeEnum.ErpImported
        }
        vatImportService.updatePeriodStatus(queryImportDto)
          .success(function (data) {
              $log.debug("vatImportService.updatePeriodStatus complete");
          });
    };


    //重新校验和整理数据
    var ReCheckAndManageData = function () {
        $log.debug("star to recheck and remanage data");
        dataImportService.reManageData(period).success(function (data) {
            if (data) {
                $log.debug("remanage data successfully");
                getAllValidationResults(true);
            }
        });
    };


    var triggBasicCheck = function () {
        //默认选中基础校验
        setTimeout(function () {
            $('#btnBasicChk').trigger('click');
        }, 1000);
    };


    //初始化dataGrid的常规配置
    var initErpGridOptions = function () {
        var isDouble = 0;
        $scope.validationSource = [];
        $scope.validationColumns = [];
        $scope.duplicateDetailSource = [];
        $scope.duplicateDetailColumns = [];
        $scope.duplicatedFilterCondition = ["IsNeedDelete", "=", true];
        $scope.basicDetailColumns = [];
        $scope.basicDetailSource = [];
        $scope.basicVoucherDebitCreditColumns = [];
        $scope.correctDetailColumns = [];
        $scope.correctDetailSource = [];
        $scope.correctAccountDetailChildColumns = [];

        $scope.erpValidationGridOptions = {
            //验证汇总dataGrid
            validationSummary: {
                allowColumnResizing: true,
                bindingOptions: {
                    "dataSource.store.data": "validationSource",
                    "columns": "validationColumns"
                },
                dataSource: { store: { type: "array" } },
                paging: { pageSize: constant.page.pageSizeArrary[4] },
                filterRow: { visible: false },
                showBorders: true,
                showRowLines: true,
                hoverStateEnabled: true,
                rowAlternationEnabled: true,
                //selection: { mode: 'single' },
                onCellClick: function (e) {
                    isDouble++;
                    var dataGrid = $('#gridErpValidationDetail').dxDataGrid("instance");
                    var dataSource = dataGrid.option("dataSource").store.data;
                    var rowIndex = dataGrid.pageIndex() * dataGrid.pageSize();
                    var selectedRow = dataSource[rowIndex + e.rowIndex];
                    $scope.checkTypeId = selectedRow.erpCheckTypeId;
                    setTimeout(function () {
                        if (isDouble === 2 && !_.isNull(selectedRow)) {
                            if (selectedRow.errorCount === 0) {
                                SweetAlert.warning($translate.instant('ErpDetailWarning'));
                            }
                            else {
                                showValidationDetailModal(validateCategory, selectedRow);
                            }

                        }
                        isDouble = 0;
                    }, 500);
                }
            },

            //重复数据详细信息dataGrid         
            duplicateDetail: {
                allowColumnResizing: true,
                bindingOptions: {
                    "dataSource.store.data": "duplicateDetailSource",
                    "selectionFilter": "duplicatedFilterCondition",
                    "columns": "duplicateDetailColumns"
                },
                dataSource: { store: { type: "array" } },
                filterRow: { visible: true },
                showBorders: true,
                showRowLines: true,
                hoverStateEnabled: true,
                rowAlternationEnabled: true,
                selection: {
                    mode: "multiple",
                    selectAllMode: "allPages",
                    showCheckBoxesMode: "always",
                    deferred: true
                },
                paging: { pageSize: constant.page.pageSizeArrary[0] }
            },

            //基础数据验证详细信息dataGrid
            basicDetail: {
                allowColumnResizing: true,
                bindingOptions: {
                    "dataSource.store.data": "basicDetailSource",
                    "columns": "basicDetailColumns"
                },
                dataSource: { store: { type: "array" } },
                filterRow: { visible: true },
                showBorders: true,
                showRowLines: true,
                hoverStateEnabled: true,
                rowAlternationEnabled: true,
                paging: { pageSize: constant.page.pageSizeArrary[0] }
            },

            //基础数据验证详细信息,凭证借贷平衡
            basicVoucherDebitCredit: {
                allowColumnResizing: true,
                bindingOptions: {
                    "dataSource.store.data": "basicDetailSource",
                    "columns": "basicDetailColumns"
                },
                dataSource: { store: { type: "array" } },
                filterRow: { visible: true },
                showBorders: true,
                showRowLines: true,
                hoverStateEnabled: true,
                rowAlternationEnabled: true,
                paging: { pageSize: constant.page.pageSizeArrary[0] },
                masterDetail: {
                    enabled: true,
                    template: function (container, options) {
                        var expandedMasterRow = options.data;
                        container.addClass("internal-grid-container");
                        $("<div>")
                        .addClass("internal-grid")
                        .dxDataGrid({
                            dataSource: expandedMasterRow.Children,
                            columns: $scope.basicVoucherDebitCreditColumns,
                            filterRow: { visible: false },
                            showBorders: true,
                            showRowLines: true,
                            hoverStateEnabled: true,
                            rowAlternationEnabled: true,
                            paging: {
                                enabled: true,
                                pageSize: constant.page.pageSizeArrary[4]
                            },
                            loadPanel: { enabled: false }
                        }).appendTo(container);
                    }
                }
            },

            //数据正确性验证详细信息dataGrid
            correctDetailAccountBegBal: {
                allowColumnResizing: true,
                bindingOptions: {
                    "dataSource.store.data": "correctDetailSource",
                    "columns": "correctDetailColumns"
                },
                dataSource: { store: { type: "array" } },
                filterRow: { visible: true },
                showBorders: true,
                showRowLines: true,
                hoverStateEnabled: true,
                rowAlternationEnabled: true,
                paging: { pageSize: constant.page.pageSizeArrary[0] },
                masterDetail: {
                    enabled: true,
                    template: function (container, options) {
                        var expandedMasterRow = options.data;
                        container.addClass("internal-grid-container");
                        $("<div>")
                        .addClass("internal-grid")
                        .dxDataGrid({
                            dataSource: expandedMasterRow.Children,
                            columns: $scope.correctAccountDetailChildColumns,
                            filterRow: { visible: false },
                            showBorders: true,
                            showRowLines: true,
                            hoverStateEnabled: true,
                            rowAlternationEnabled: true,
                            paging: {
                                enabled: true,
                                pageSize: constant.page.pageSizeArrary[4]
                            },
                            loadPanel: { enabled: false }
                        }).appendTo(container);
                    }
                }
            },

            correctDetailBegBal: {
                allowColumnResizing: true,
                bindingOptions: {
                    "dataSource.store.data": "correctDetailSource",
                    "columns": "correctDetailColumns"
                },
                dataSource: { store: { type: "array" } },
                filterRow: { visible: true },
                showBorders: true,
                showRowLines: true,
                hoverStateEnabled: true,
                rowAlternationEnabled: true,
                paging: { pageSize: constant.page.pageSizeArrary[0] },
                masterDetail: { enabled: false }
            }
        };

    };


    //设置图片的路径
    var setPicturePath = function (data) {

        data.forEach(function (item, index) {
            if (item.imageTypeId === enums.ImageType.Success) {
                item.imagePic = '/app-resources/images/cit/success.png';
            }
            else if (item.imageTypeId === enums.ImageType.Alert) {
                item.imagePic = '/app-resources/images/cit/information.png';
            }
            else if (item.imageTypeId === enums.ImageType.Warning) {
                item.imagePic = '/app-resources/images/cit/warning.png';
            }
            else if (item.imageTypeId === enums.ImageType.Error) {
                item.imagePic = '/app-resources/images/cit/error.png';
            }


        });
        return data;
    };


    //设置dataGrid columns,datasource: 基础数据验证、数据正确性验证
    var setValicationSummaryGrid = function (data, validteType) {
        $scope.validationSource = [];
        $scope.validationColumns = [];
        data = setPicturePath(data);

        $scope.validationColumns.push({
            caption: $translate.instant('Num'),
            dataField: "num",
            width: 100
        });

        $scope.validationColumns.push({
            caption: $translate.instant('ImagePic'),
            dataField: "imagePic",
            width: 100,
            cellTemplate: function (container, options) {
                $("<div>").append($("<img>", { "src": options.value })).appendTo(container);
            }
        });

        $scope.validationColumns.push({
            caption: $translate.instant('PeriodId'),
            dataField: "period",
            width: 100,
            visible: validteType === enums.ValidateCategoryEnum.Correctness ? true : false
        });

        $scope.validationColumns.push({
            caption: $translate.instant('DataCheckType'),
            dataField: "dataCheckType",
        });

        $scope.validationColumns.push({
            caption: $translate.instant('ErrorCount'),
            dataField: "errorCount",
            width: 100
        });


        $scope.validationColumns.push({
            caption: $translate.instant('Tips'),
            dataField: "tips",
        });

        $scope.validationColumns.push({
            caption: $translate.instant('ErpCheckTypeId'),
            dataField: "erpCheckTypeId",
            visible: false
        });

        $scope.validationColumns.push({
            caption: $translate.instant('ValidationDetails'),
            dataField: "validationDetails",
            visible: false
        });

        $scope.validationSource = data; //_.filter(data, function (num, index) { return index > 0; });
    };


    //设置dataGrid columns,datasource: 重复数据
    var setDuplicateValidationSummaryGrid = function (data) {
        $scope.validationSource = [];
        $scope.validationColumns = [];
        $scope.validationColumns.push({
            caption: $translate.instant('Num'),
            dataField: "num",
            width: 100
        });


        $scope.validationColumns.push({
            caption: $translate.instant('TableName'),
            dataField: "tableName",
        });

        $scope.validationColumns.push({
            caption: $translate.instant('DuplicateNum'),
            dataField: "duplicateCount",
            width: 100
        });

        $scope.validationColumns.push({
            caption: $translate.instant('ErpCheckTypeId'),
            dataField: "erpCheckTypeId",
            visible: false
        });

        $scope.validationColumns.push({
            caption: $translate.instant('ValidationDetails'),
            dataField: "validationDetails",
            visible: false
        });


        $scope.validationSource = data;
    };


    //弹出详细验证入口函数
    var showValidationDetailModal = function (validateCategoryValue, row) {
        if (validateCategoryValue === enums.ValidateCategoryEnum.Basic) {
            showBasicValidationDetail(row);
        }
        else if (validateCategoryValue === enums.ValidateCategoryEnum.Duplicate) {
            showDuplicateValidationDetail(row);
        }
        else if (validateCategoryValue === enums.ValidateCategoryEnum.Correctness) {
            showCorrectValidationDetail(row);
        }
    };


    //弹出"重复验证"详细信息框
    var showDuplicateValidationDetail = function (row) {
        $scope.modalDuplicateValidation = $uibModal.open({
            animation: false,
            ariaLabelledBy: 'modal-title',
            ariaDescribedBy: 'modal-body',
            templateUrl: 'model-duplicate-validation.html',
            scope: $scope,
            windowClass: "model-duplicate-validation"
        });

        $scope.closeValidtionModal = function () {
            $scope.modalDuplicateValidation.dismiss('cancel');
        };

        setDuplicateDetailGrid(row);
    };


    //设置dataGrid columns,datasource: 重复数据详细数据
    var setDuplicateDetailGrid = function (row) {
        $scope.duplicateDetailSource = [];
        $scope.duplicateDetailColumns = [];
        if (row.erpCheckTypeId === enums.ErpCheckTypeEnum.DuplicatedVoucher) {
            $scope.duplicateDetailColumns.push({
                caption: $translate.instant('period'),
                dataField: "Period",
                width: 100
            });

            $scope.duplicateDetailColumns.push({
                caption: $translate.instant('vGroup'),
                dataField: "Group"
            });


            $scope.duplicateDetailColumns.push({
                caption: $translate.instant('vid'),
                dataField: "VID",
                width: 100
            });

            $scope.duplicateDetailColumns.push({
                caption: $translate.instant('itemID'),
                dataField: "ItemID",
                width: 100
            });

            $scope.duplicateDetailColumns.push({
                caption: $translate.instant('AccountCode'),
                dataField: "AcctCode"
            });

            $scope.duplicateDetailColumns.push({
                caption: $translate.instant('JournalZY'),
                dataField: "Summary",
            });

            $scope.duplicateDetailColumns.push({
                caption: $translate.instant('DebitBal'),
                dataField: "Debit",
                width: 100
            });


            $scope.duplicateDetailColumns.push({
                caption: $translate.instant('CreditBal'),
                dataField: "Credit",
                width: 100
            });

            $scope.duplicateDetailColumns.push({
                caption: $translate.instant('VoucherID'),
                dataField: "VoucherID",
                width: 100,
                visible: false
            });

            $scope.duplicateDetailSource = JSON.parse(row.validationDetails);
        }
        else if (row.erpCheckTypeId === enums.ErpCheckTypeEnum.DuplicatedTb) {
            $scope.duplicateDetailColumns.push({
                caption: $translate.instant('period'),
                dataField: "PeriodId",
                width: 100
            });

            $scope.duplicateDetailColumns.push({
                caption: $translate.instant('AccountCode'),
                dataField: "AcctCode"
            });


            $scope.duplicateDetailColumns.push({
                caption: $translate.instant('JournalKHDM'),
                dataField: "CustomerCode"
            });

            $scope.duplicateDetailColumns.push({
                caption: $translate.instant('BegDebitBal'),
                dataField: "BegDebitBal",
                width: 100
            });

            $scope.duplicateDetailColumns.push({
                caption: $translate.instant('BegCreditBal'),
                dataField: "begCreditBal",
                width: 100
            });

            $scope.duplicateDetailColumns.push({
                caption: $translate.instant('BegBal'),
                dataField: "BegBal",
                width: 100
            });

            $scope.duplicateDetailColumns.push({
                caption: $translate.instant('BalanceId'),
                dataField: "BalanceId",
                visible: false
            });

            $scope.duplicateDetailSource = JSON.parse(row.validationDetails);
        }
    };


    //删除重复数据入口函数
    var deleteDuplicateItems = function (checkTypeId) {
        if (checkTypeId === enums.ErpCheckTypeEnum.DuplicatedVoucher) {
            deleteDuplicateVouchers();
        }
        else if (checkTypeId === enums.ErpCheckTypeEnum.DuplicatedTb) {
            deleteDuplicateTbes();
        }
    };


    //弹出"基础数据验证"详细信息框
    var showBasicValidationDetail = function (row) {
        $scope.popUpBasicRules[row.erpCheckTypeId](row);
        setBasicDetailGrid(row);
    };


    //设置基础验证弹出框（没有master-children）
    var setBasicPopup = function (row) {
        $scope.modalBasicValidation = $uibModal.open({
            animation: false,
            ariaLabelledBy: 'modal-title',
            ariaDescribedBy: 'modal-body',
            templateUrl: 'model-basic-validation.html',
            scope: $scope,
            windowClass: "model-basic-validation"
        });

        $scope.closeBasicDetailModal = function () {
            $scope.modalBasicValidation.dismiss('cancel');
        };
    };


    //设置基础数据验证，凭证借贷平衡弹出框 (有master-children)
    var setBasicVoucherDebitCreditPopup = function (row){
        $scope.visibleVDebitCreditPopup = true;
        $scope.popupVoucherDebitCredit = {
            width: 850,
            height: "auto",
            contentTemplate: "infoVoucherDebitCredit",
            showTitle: true,
            title: $translate.instant('ErrorDetails'),
            dragEnabled: false,
            closeOnOutsideClick: true,
            shading: false,
            showCloseButton: false,
            bindingOptions: {
                visible: "visibleVDebitCreditPopup"               
            }
        };

        $scope.closeVoucherDebitCredit = function () {
            $scope.visibleVDebitCreditPopup = false;
        };
    };

    //设置dataGrid columns,datasource: 基础数据验证详细入口
    var setBasicDetailGrid = function (row) {
        $scope.basicDetailColumns = [];
        $scope.basicDetailSource = [];
        $scope.basicVoucherDebitCreditColumns = [];
        $scope.basicRules[row.erpCheckTypeId](row);
    };


    //设置dataGrid columns,datasource: 基础数据验证详细，凭证相关
    var setBasicVoucherDetailGrid = function (row) {
        if (_.isNull(row)) {
            return;
        }

        $scope.basicDetailColumns.push({
            caption: $translate.instant('AccountCode'),
            dataField: "AcctCode"
        });

        $scope.basicDetailColumns.push({
            caption: $translate.instant('JournalKHDM'),
            dataField: "CustomerCode"
        });

        $scope.basicDetailColumns.push({
            caption: $translate.instant('vid'),
            dataField: "VID"
        });

        $scope.basicDetailColumns.push({
            caption: $translate.instant('vGroup'),
            dataField: "Group"
        });


        $scope.basicDetailColumns.push({
            caption: $translate.instant('period'),
            dataField: "Period"
        });

        $scope.basicDetailColumns.push({
            caption: $translate.instant('itemID'),
            dataField: "ItemID"
        });

        $scope.basicDetailColumns.push({
            caption: $translate.instant('JournalZY'),
            dataField: "Summary"
        });

        $scope.basicDetailColumns.push({
            caption: $translate.instant('JournalJFJE'),
            dataField: "Debit"
        });

        $scope.basicDetailColumns.push({
            caption: $translate.instant('JournalDFJE'),
            dataField: "Credit"
        });

        $scope.basicDetailSource = JSON.parse(row.validationDetails);
    };


    //设置dataGrid columns,datasource: 基础数据验证详细，科目相关
    var setBasicAccountGrid = function (row) {
        if (_.isNull(row)) {
            return;
        }

        $scope.basicDetailColumns.push({
            caption: $translate.instant('AccountCode'),
            dataField: "AccountCode"
        });

        $scope.basicDetailSource = JSON.parse(row.validationDetails);
    };


    //设置dataGrid columns,datasource: 基础数据验证详细，凭证借贷平衡
    var setBasicVoucherDebitCreditDetailGrid = function (row) {

        //master columns
        $scope.basicDetailColumns.push({
            caption: $translate.instant('AccountCode'),
            dataField: "AcctCode"
        });

        $scope.basicDetailColumns.push({
            caption: $translate.instant('JournalKHDM'),
            dataField: "CustomerCode"
        });

        $scope.basicDetailColumns.push({
            caption: $translate.instant('vid'),
            dataField: "VID"
        });

        $scope.basicDetailColumns.push({
            caption: $translate.instant('vGroup'),
            dataField: "Group"
        });


        $scope.basicDetailColumns.push({
            caption: $translate.instant('period'),
            dataField: "Period"
        });

        $scope.basicDetailColumns.push({
            caption: $translate.instant('itemID'),
            dataField: "ItemID"
        });

        $scope.basicDetailColumns.push({
            caption: $translate.instant('JournalZY'),
            dataField: "Summary"
        });

        $scope.basicDetailColumns.push({
            caption: $translate.instant('JournalJFJE'),
            dataField: "Debit"
        });

        $scope.basicDetailColumns.push({
            caption: $translate.instant('JournalDFJE'),
            dataField: "Credit"
        });


        //children columns
        $scope.basicVoucherDebitCreditColumns.push({
            caption: $translate.instant('AccountCode'),
            dataField: "AcctCode"
        });

        $scope.basicVoucherDebitCreditColumns.push({
            caption: $translate.instant('JournalKHDM'),
            dataField: "CustomerCode"
        });

        $scope.basicVoucherDebitCreditColumns.push({
            caption: $translate.instant('vid'),
            dataField: "VID"
        });

        $scope.basicVoucherDebitCreditColumns.push({
            caption: $translate.instant('vGroup'),
            dataField: "Group"
        });


        $scope.basicVoucherDebitCreditColumns.push({
            caption: $translate.instant('period'),
            dataField: "Period"
        });

        $scope.basicVoucherDebitCreditColumns.push({
            caption: $translate.instant('itemID'),
            dataField: "ItemID"
        });

        $scope.basicVoucherDebitCreditColumns.push({
            caption: $translate.instant('JournalZY'),
            dataField: "Summary"
        });

        $scope.basicVoucherDebitCreditColumns.push({
            caption: $translate.instant('JournalJFJE'),
            dataField: "Debit"
        });

        $scope.basicVoucherDebitCreditColumns.push({
            caption: $translate.instant('JournalDFJE'),
            dataField: "Credit"
        });

        $scope.basicDetailSource = JSON.parse(row.validationDetails);
    };

    //弹出"数据正确性验证"详细信息框
    var showCorrectValidationDetail = function (row) {
        $scope.popUpCorrectRules[row.erpCheckTypeId](row);
        setCorrectDetailGrid(row);
    };


    //设置dataGrid columns,datasource: 数据正确性验证详细信息入口
    var setCorrectDetailGrid = function (row) {
        $scope.correctDetailColumns = [];
        $scope.correctDetailSource = [];
        $scope.correctAccountDetailChildColumns = [];
        $scope.correctRules[row.erpCheckTypeId](row);
    };


    //设置dataGrid columns,datasource: 数据正确性验证详细，初余额借贷不平衡
    var setCorrectBegBalDetailGrid = function (row) {
        $scope.correctDetailColumns.push({
            caption: $translate.instant('BegDebitBal'),
            dataField: "BegDebitBal"
        });

        $scope.correctDetailColumns.push({
            caption: $translate.instant('BegCreditBal'),
            dataField: "BegCreditBal"
        });

        $scope.correctDetailSource = JSON.parse(row.validationDetails);
    };


    //设置dataGrid columns,datasource: 数据正确性验证详细，初余额上下级不平衡
    var setCorrectAccountDetailGrid = function (row) {
        //master columns
        $scope.correctDetailColumns.push({
            caption: $translate.instant('AccountCode'),
            dataField: "AcctCode"
        });

        $scope.correctDetailColumns.push({
            caption: $translate.instant('BegBal'),
            dataField: "AcctSum"
        });

        $scope.correctDetailColumns.push({
            caption: $translate.instant('ChildAcctBegSubSum'),
            dataField: "SubSum"
        });


        //child columns
        $scope.correctAccountDetailChildColumns.push({
            caption: $translate.instant('AccountCode'),
            dataField: "AcctCode"
        });


        $scope.correctAccountDetailChildColumns.push({
            caption: $translate.instant('BegBal'),
            dataField: "AcctSum"
        });

        $scope.correctDetailSource = JSON.parse(row.validationDetails);
    };


    //设置dataGrid columns,datasource: 数据正确性验证详细, 系统计算所得的试算平衡表期末余额与导入的是否一致
    var setCorrectEndBal = function (row) {
        dataImportService.isComBalanceEndBalNotZero(row.period)
          .success(function (data) {
              $scope.correctDetailColumns.push({
                  caption: $translate.instant('PeriodId'),
                  dataField: "PeriodId"
              });

              $scope.correctDetailColumns.push({
                  caption: $translate.instant('AccountCode'),
                  dataField: "AccountCode"
              });


              $scope.correctDetailColumns.push({
                  caption: $translate.instant('AccountName'),
                  dataField: "AccountName"
              });

              if (data) {

                  $scope.correctDetailColumns.push({
                      caption: $translate.instant('ComEndBal'),
                      dataField: "ComEndBal"
                  });

                  $scope.correctDetailColumns.push({
                      caption: $translate.instant('CustEndBal'),
                      dataField: "CustEndBal"
                  });

                  $scope.correctDetailColumns.push({
                      caption: $translate.instant('BalDiff'),
                      dataField: "EndDiff"
                  });
              }
              else {

                  $scope.correctDetailColumns.push({
                      caption: $translate.instant('ComDebitBal'),
                      dataField: "ComEndDebitBal"
                  });

                  $scope.correctDetailColumns.push({
                      caption: $translate.instant('ComCreditBal'),
                      dataField: "ComEndCreditBal"
                  });


                  $scope.correctDetailColumns.push({
                      caption: $translate.instant('CustDebitBal'),
                      dataField: "CustEndDebitBal"
                  });

                  $scope.correctDetailColumns.push({
                      caption: $translate.instant('CustCreditBal'),
                      dataField: "CustEndCreditBal"
                  });

                  $scope.correctDetailColumns.push({
                      caption: $translate.instant('DebitBalDiff'),
                      dataField: "DebitBalDiff"
                  });

                  $scope.correctDetailColumns.push({
                      caption: $translate.instant('CreditBalDiff'),
                      dataField: "CreditBalDiff"
                  });
              }

              $scope.correctDetailSource = JSON.parse(row.validationDetails);
          });
    };


    //设置dataGrid columns,datasource: 数据正确性验证详细, 系统计算所得的试算平衡表期间发生额与导入的是否一致
    var setCorrectAmount = function (row) {
        $scope.correctDetailColumns.push({
            caption: $translate.instant('PeriodId'),
            dataField: "PeriodId"
        });

        $scope.correctDetailColumns.push({
            caption: $translate.instant('AccountCode'),
            dataField: "AccountCode"
        });


        $scope.correctDetailColumns.push({
            caption: $translate.instant('AccountName'),
            dataField: "AccountName"
        });

        $scope.correctDetailColumns.push({
            caption: $translate.instant('ComDebitBal'),
            dataField: "ComDebitBal"
        });

        $scope.correctDetailColumns.push({
            caption: $translate.instant('ComCreditBal'),
            dataField: "ComCreditBal"
        });

        $scope.correctDetailColumns.push({
            caption: $translate.instant('CustDebitBal'),
            dataField: "CustDebitBal"
        });

        $scope.correctDetailColumns.push({
            caption: $translate.instant('CustCreditBal'),
            dataField: "CustCreditBal"
        });

        $scope.correctDetailColumns.push({
            caption: $translate.instant('DebitBalDiff'),
            dataField: "DebitBalDiff"
        });

        $scope.correctDetailColumns.push({
            caption: $translate.instant('CreditBalDiff'),
            dataField: "CreditBalDiff"
        });

        $scope.correctDetailSource = JSON.parse(row.validationDetails);
    };


    //设置dataGrid columns,datasource: 数据正确性验证详细, 系统计算所得的上月期末与导入的本月期初是否一致
    var setCorrectEndBegBal = function (row) {
        dataImportService.isComBalanceEndBalNotZero(row.period)
          .success(function (data) {
              $scope.correctDetailColumns.push({
                  caption: $translate.instant('PeriodId'),
                  dataField: "PeriodId"
              });

              $scope.correctDetailColumns.push({
                  caption: $translate.instant('AccountCode'),
                  dataField: "AccountCode"
              });


              $scope.correctDetailColumns.push({
                  caption: $translate.instant('AccountName'),
                  dataField: "AccountName"
              });

              if (data) {

                  $scope.correctDetailColumns.push({
                      caption: $translate.instant('LastPeriodEndBal'),
                      dataField: "CustEndBal"
                  });

                  $scope.correctDetailColumns.push({
                      caption: $translate.instant('CurrentPeriodEndBal'),
                      dataField: "ComBegBal"
                  });

                  $scope.correctDetailColumns.push({
                      caption: $translate.instant('BalDiff'),
                      dataField: "BegBalDiff"
                  });
              }
              else {

                  $scope.correctDetailColumns.push({
                      caption: $translate.instant('LastPeriodEndDebitBal'),
                      dataField: "CustEndDebitBal"
                  });

                  $scope.correctDetailColumns.push({
                      caption: $translate.instant('LastPeriodEndCreditBal'),
                      dataField: "CustEndCreditBal"
                  });

                  $scope.correctDetailColumns.push({
                      caption: $translate.instant('CurrentPeriodBegDebitBal'),
                      dataField: "ComBegDebitBal"
                  });

                  $scope.correctDetailColumns.push({
                      caption: $translate.instant('CurrentPeriodBegCreditBal'),
                      dataField: "ComBegCreditBal"
                  });

                  $scope.correctDetailColumns.push({
                      caption: $translate.instant('DebitBalDiff'),
                      dataField: "BegDebitDiff"
                  });

                  $scope.correctDetailColumns.push({
                      caption: $translate.instant('CreditBalDiff'),
                      dataField: "BegCreditDiff"
                  });
              }

              $scope.correctDetailSource = JSON.parse(row.validationDetails);
          })
    };


    //设置"期初余额上下级平衡"详细信息的弹出框(有master-children)
    var setCorrectAccountBegbalPopup = function (row) {
        $scope.visiblePopupAccountBegBal = true;
        $scope.popupOptionsAccountBegBal = {
            width: 850,
            height: 600,
            contentTemplate: "infoAccountBegBal",
            showTitle: true,
            title: $translate.instant('ErrorDetails'),
            dragEnabled: false,
            closeOnOutsideClick: true,
            shading: false,
            showCloseButton: false,
            bindingOptions: {
                visible: "visiblePopupAccountBegBal",
            }
        };

        $scope.closeAccountBegBalModal = function () {
            $scope.visiblePopupAccountBegBal = false;
        };
    };


    //设置"期初余额借贷平衡"详细信息的弹出框(没有master-children)
    var setCorrectBegBalPopup = function (row) {
        $scope.visiblePopupBegBal = true;
        //$scope.begBalPopupHeight = row.erpCheckTypeId === enums.ErpCheckTypeEnum.BegBalUnValidate ? 280 : 600;     
        $scope.popupOptionsBegBal = {
            width: 650,
            height: "auto",
            contentTemplate: "infoBegBal",
            showTitle: true,
            title: $translate.instant('ErrorDetails'),
            dragEnabled: false,
            closeOnOutsideClick: true,
            shading: false,
            showCloseButton: false,
            bindingOptions: {
                visible: "visiblePopupBegBal"
                //height: "begBalPopupHeight"
            }
        };

        $scope.closeBegBalModal = function () {
            $scope.visiblePopupBegBal = false;
        };
    };


    var getPeriodInfor = function () {
        vatImportService.getImportType(vatSessionService.project.id, period, constant.serviceType.CIT).success(function (data) {
            $scope.isImportTypeErp = enums.projectImportType.ErpImported === data ? true : false;
        });
    };

    //开始
    (function initialize() {
        //默认显示万能导入          
        $scope.deleteDuplicateItems = deleteDuplicateItems;
        $scope.importTypeSwitch = importTypeSwitch;
        $scope.checkUserOrganizationPermissionList = checkUserOrganizationPermissionList;
        $scope.setValidationErrorStyle = setValidationErrorStyle;
        $scope.uploadFiles = uploadFiles;
        $scope.importData = importData;
        $scope.openTab = openTab;
        $scope.setButtonSetByPermission = setButtonSetByPermission;

        $scope.importTypeSwitch(2);
        $scope.checkUserOrganizationPermissionList();
        initErpGridOptions();
        getAllValidationResults(false);
        getPeriodInfor();
        //基础验证信息,dataGrid column/datasource设置查找表
        $scope.basicRules = {
            1: setBasicAccountGrid,
            2: setBasicAccountGrid,
            3: setBasicVoucherDebitCreditDetailGrid,
            4: setBasicVoucherDetailGrid,
            5: setBasicVoucherDetailGrid,
            6: setBasicVoucherDetailGrid,
            7: setBasicVoucherDetailGrid
        };

        //基础验证详细验证，popup设置查找表
        $scope.popUpBasicRules = {
            1: setBasicPopup,
            2: setBasicPopup,
            3: setBasicVoucherDebitCreditPopup,
            4: setBasicPopup,
            5: setBasicPopup,
            6: setBasicPopup,
            7: setBasicPopup
        };

        //正确性验证详细信息，popup设置查找表
        $scope.popUpCorrectRules = {
            8: setCorrectAccountBegbalPopup,
            9: setCorrectBegBalPopup,
            10: setCorrectBegBalPopup,
            11: setCorrectBegBalPopup,
            13: setCorrectBegBalPopup
        };

        //正确性验证，dataGrid column/datasource设置查找表
        $scope.correctRules = {
            8: setCorrectAccountDetailGrid,
            9: setCorrectBegBalDetailGrid,
            10: setCorrectEndBal,
            11: setCorrectAmount,
            13: setCorrectEndBegBal
        };

    })();

}]);