﻿
citModule.controller('citImportLayoutController', ['$scope', '$q', '$log', '$translate', '$location', 'loginContext', 'enums', 'vatSessionService',
    'citSessionService', 'vatCommonService', 'vatImportService',
function ($scope, $q, $log, $translate, $location, loginContext, enums, vatSessionService, citSessionService, vatCommonService, vatImportService) {
    'use strict';
    $log.debug('citImportLayoutController.ctor()...');

    if (!$location.$$url.startWith('/cit/')) {
        return false;
    }

    //using .replace(';', '<br/>') to text-wrap at exact position as designed in menu 
    var getMenuList = function () {
        if ($location && $location.absUrl().indexOf('previewData') > -1) {
            $scope.nodeDicKey = constant.DictionaryDictKey.DataImport;
            $scope.linkShort = enums.linkShort.PreviewData;
            $scope.menus = [
                // {
                //     name: 'balanceSheet', permission: constant.citPermission.dataPreview.balanceSheet.queryCode,
                //     text: $translate.instant('balanceSheet'), icon: 'fa fa-bank'
                // },
                // {
                //     name: 'accountVoucher', permission: constant.citPermission.dataPreview.accountVoucher.queryCode,
                //     text: $translate.instant('accountVoucher'), icon: 'fa fa-columns'
                // },
                {
                    name: 'journalMerge', permission: constant.citPermission.dataPreview.journalMerge.queryCode,
                    text: $translate.instant('journal'), icon: 'fa fa-bank'
                },
                {
                    name: 'bsGenerateVer', permission: constant.citPermission.dataPreview.bsGenerateVer.queryCode,
                    text: $translate.instant('bsGenerateVer'), icon: 'fa fa-bank'
                },
                {
                    name: 'bsMappingVer', permission: constant.citPermission.dataPreview.bsMappingVer.queryCode,
                    text: $translate.instant('bsMappingVer'), icon: 'fa fa-bank'
                },
                {
                    name: 'assetsList', permission: constant.citPermission.dataPreview.assetsList.queryCode,
                    text: $translate.instant('AssetList'), icon: 'fa fa-bank'
                },
                {
                    name: 'salaryAdvance', permission: constant.citPermission.dataPreview.salaryAdvance.queryCode,
                    text: $translate.instant('salaryAdvance'), icon: 'fa fa-bank'
                },
                {
                    name: 'eamDisposal', permission: constant.citPermission.dataPreview.eamDisposal.queryCode,
                    text: $translate.instant('eamDisposal'), icon: 'fa fa-bank'
                },
            ];

            // TODO: For DCH Demo
            var project = vatSessionService.getProperty("project");
            if (project && project.id === '612a3872-b6ed-408c-8b7e-09eb6909437f') {
                $scope.menus.length = 1;
            }
        }
        else if ($location && $location.absUrl().indexOf('citAnalyzeLayout') > -1) {
            //citModelAnalysis
            $scope.nodeDicKey = null;
            $scope.menus = [
                {
                    name: 'citAnalyzeReport', permission: constant.citPermission.dataAnalysis.modelAnalysisCode,
                    text: $translate.instant('ModelAnalysis'), icon: 'fa fa-map'
                },
                {
                    name: 'citOrganizeDashboard', permission: constant.citPermission.dataAnalysis.modelAnalysisCode,
                    text: $translate.instant('Dashboard'), icon: 'fa fa-map'
                },
            ];
        }
        else if ($location && $location.absUrl().indexOf('reductionData') > -1) {
            $scope.nodeDicKey = constant.DictionaryDictKey.DataProcess;
            $scope.linkShort = enums.linkShort.ReductionData;
            debugger;
            $scope.menus = [
            {
                name: 'caculateData', permission: constant.citPermission.dataManage.caculateDataCode,
                text: $translate.instant('caculateData'), icon: 'fa fa-random'
            },
            // {
            //     name: 'accountMapping', permission: constant.citPermission.dataManage.accountMappingCode,
            //     text: $translate.instant('accountMapping'), icon: 'fa fa-map'
            // },
            {
                name: 'assetEamMapping', permission: constant.citPermission.dataManage.assetEamMapping,
                text: $translate.instant('AssetEamMapping'), icon: 'fa fa-map'
            },
            {
                name: 'distributionTable', permission: constant.citPermission.dataManage.distributionTable,
                text: $translate.instant('DistributionTable'), icon: 'fa fa-map'
            },
            ];
        }
        else {
            $scope.nodeDicKey = constant.DictionaryDictKey.DataImport;
            $scope.linkShort = enums.linkShort.ImportData;
            $scope.menus = [
                // {
                // name: 'balanceSheet', permission: constant.citPermission.dataImport.balanceSheet.queryCode,
                // text: $translate.instant('balanceSheet'), icon: 'fa fa-bank'
                // },
                // {
                //     name: 'documentList', permission: constant.citPermission.dataImport.documentList.queryCode,
                //     text: $translate.instant('documentList'), icon: 'fa fa-file-text-o'
                // },
                // {
                //     name: 'journalEntry', permission: constant.citPermission.dataImport.journalEntry.queryCode,
                //     text: $translate.instant('journalEntry'), icon: 'fa fa-align-left'
                // },
                // {
                //     name: 'erpData', permission: constant.citPermission.dataImport.erpImport.queryCode,
                //     text: $translate.instant('erpData'), icon: 'fa fa-list-ul'
                // },
                // {
                //     name: 'auditAdjust', permission: constant.citPermission.dataImport.auditAdjust.queryCode,
                //     text: $translate.instant('auditAdjust'), icon: 'fa fa-adjust'
                // },
                {
                    name: 'assetList', permission: constant.citPermission.dataImport.assetList.queryCode,
                    text: $translate.instant('AssetList'), icon: 'fa fa-list-ul'
                }
            ];

            // TODO: For DCH Demo
            var project = vatSessionService.getProperty("project");
            if (project && project.id === '612a3872-b6ed-408c-8b7e-09eb6909437f') {
                $scope.menus.length = 1;
            }
        }
    }
    $scope.errorCount = 0;
    $scope.$on('errorCount', function (event, data) {
        $scope.errorCount = data;       //父级能得到值
    });

    //获取分组菜单
    var getImportTables = function () {
        return vatImportService.getTableMenuList().then(function (data) {
            if (data && data.data && data.data.length > 0) {
                $scope.tableMenuList = data.data;
            }
            if (!_.isEmpty(vatSessionService.tableInfoList)) {
                var tableInfoList = angular.copy(vatSessionService.tableInfoList);
                _.each(tableInfoList, function (x) {
                    x.show = true;
                });
                $scope.noGroupTableList = _.filter(tableInfoList, function (m) { return PWC.isNullOrEmpty(m.menuIndex) });

                if ($scope.tableMenuList && $scope.tableMenuList.length > 0)
                {
                    _.each($scope.tableMenuList, function (item) {
                        item.tableList = _.filter(tableInfoList, function (m) { return m.menuIndex == item.menuIndex });
                        item.isMenuClosed = false;
                    });
                } 
            }

            return $q.when(tableInfoList);
        }, function (data) {
            $scope.tableMenuList = [];
            $scope.noGroupTableList = [];

            return $q.when([]);
        });
    };

    $scope.showMenu = function (group) {
        group.isMenuClosed = !group.isMenuClosed;
    };


    (function initialize() {
        $scope.isImportMenu = false;
        $scope.noGroupTableList = [];
        $scope.tableMenuList = [];

        if ($location && $location.absUrl().indexOf('importData') > -1) {
            $scope.isImportMenu = true;
        }
        $scope.importIcon = 'fa fa-adjust';
        $scope.serviceTypeId = enums.serviceType.CIT;
        getMenuList();
        // getImportTables().then(function (tableInfoList) {
        //     vatCommonService.isLayoutMenuShow(vatSessionService.project.dbName, citSessionService.month,
        //         $scope.nodeDicKey, $scope.linkShort, $scope.menus, tableInfoList);
        // });
    })();
}
]);