﻿citModule.controller('citPreviewSalaryAdvanceController', ['$scope', '$log', '$translate', '$timeout', '$compile', '$uibModal', 'apiInterceptor',
     'SweetAlert', '$q', 'uiGridConstants', '$interval', 'vatSessionService', 'citSessionService', 'vatImportService', 'loginContext',
    'browserService', 'enums', 'vatOperationLogService', 'citPreviewDataService', 'vatCommonService', 'ackMessageBox','commonWebService','vatExportService',
    function ($scope, $log, $translate, $timeout, $compile, $uibModal, apiInterceptor, SweetAlert, $q, uiGridConstants,
              $interval, vatSessionService, citSessionService, vatImportService, loginContext, browserService, enums, vatOperationLogService, citPreviewDataService,
              vatCommonService, ackMessageBox, commonWebService, vatExportService) {
        'use strict';
        $scope.listData = [];


        var minDate = [1, 2010];
        // var minDate = moment().startOf('month').subtract(0, 'months');
        var maxDate = [12, 2019];
        var setDate = [[1, 2010], [12, 2019]];
        $scope.monthList = [$translate.instant('Month01'),
            $translate.instant('Month02'),
            $translate.instant('Month03'),
            $translate.instant('Month04'),
            $translate.instant('Month05'),
            $translate.instant('Month06'),
            $translate.instant('Month07'),
            $translate.instant('Month08'),
            $translate.instant('Month09'),
            $translate.instant('Month10'),
            $translate.instant('Month11'),
            $translate.instant('Month12')
        ];

        //初始化dx控件
        function initAssetResultDxGrid() {
            var dupColumns = [
                { caption: $translate.instant('ImportErrorPopUpNoCol'), dataField: "index", width: 50, allowEditing: false, fixed: true },
                { caption: $translate.instant('poNo'), dataField: "poNo", allowEditing: false, fixed: true },
                { caption: $translate.instant('poRow'), dataField: "poRow",  allowEditing: false, fixed: true },
                { caption: "PO创建日期", dataField: "createTime",  allowEditing: false, fixed: true },
                { caption: $translate.instant('ladingBillPerson'), dataField: "ladingBillPerson",  allowEditing: false, fixed: true },
                { caption: $translate.instant('purchasePerson'), dataField: "purchasePerson", width: 200, allowEditing: false, fixed: true },
                { caption: $translate.instant('poSubjectCode'), dataField: "poSubjectCode",  allowEditing: false, fixed: true },
                { caption: $translate.instant('poSubjectName'), dataField: "poSubjectName",  allowEditing: false, fixed: true },
                { caption: $translate.instant('costCenterCode'), dataField: "costCenterCode",  allowEditing: false, fixed: true },
                { caption: $translate.instant('costCenter'), dataField: "costCenter",  allowEditing: false, fixed: true },
                { caption: $translate.instant('supplier'), dataField: "supplier",  allowEditing: false, fixed: true },
                { caption: $translate.instant('item'), dataField: "item",  allowEditing: false, fixed: true },
                { caption: $translate.instant('standardMoney'), dataField: "standardMoney",  allowEditing: false, fixed: true },
                { caption: $translate.instant('currency'), dataField: "currency",  allowEditing: false, fixed: true },
                { caption: $translate.instant('orderAmount'), dataField: "orderAmount",  allowEditing: false, fixed: true },
                { caption: $translate.instant('executedServiceSchedule'), dataField: "executedServiceSchedule",  allowEditing: false, fixed: true },
                { caption: $translate.instant('coupaTotalAccept'), dataField: "coupaTotalAccept",  allowEditing: false, fixed: true },
                { caption: $translate.instant('advance'), dataField: "advance",  allowEditing: false, fixed: true },
                { caption: $translate.instant('unexecutedServiceSchedule'), dataField: "unexecutedServiceSchedule",  allowEditing: false, fixed: true },
                { caption: $translate.instant('approvedStandardInvoiceAmount'), dataField: "approvedStandardInvoiceAmount",  allowEditing: false, fixed: true },
                { caption: $translate.instant('paidInvoiceAmount'), dataField: "paidInvoiceAmount",  allowEditing: false, fixed: true },
                { caption: $translate.instant('usableInvoiceAmount'), dataField: "usableInvoiceAmount",  allowEditing: false, fixed: true },
                { caption: $translate.instant('usableBalance'), dataField: "usableBalance",  allowEditing: false, fixed: true },
                { caption: $translate.instant('advanceWriteOff'), dataField: "advanceWriteOff",  allowEditing: false, fixed: true },
                { caption: $translate.instant('checkOne'), dataField: "checkOne",  allowEditing: false, fixed: true },
                { caption: $translate.instant('reclassifyAmount'), dataField: "reclassifyAmount",  allowEditing: false, fixed: true },
                { caption: $translate.instant('exchangeRate'), dataField: "exchangeRate",  allowEditing: false, fixed: true },
                { caption: $translate.instant('ledgerId'), dataField: "ledgerId",  allowEditing: false, fixed: true },
                { caption: $translate.instant('debitAdvanceGene'), dataField: "debitAdvanceGene",  allowEditing: false, fixed: true },
                { caption: $translate.instant('creditPrepaidAccounts'), dataField: "creditPrepaidAccounts",  allowEditing: false, fixed: true },
                { caption: $translate.instant('remark'), dataField: "remark",  allowEditing: false, fixed: true }
            ];

            $scope.assetsResultGridOptions = {
                columns: dupColumns,
                bindingOptions: {
                    "dataSource": "listData",
                },
                editing: {
                    mode: "batch",
                    allowUpdating:false,
                },
                onInitialized: function (e) {
                    $scope.dataGridInstance = e.component;
                },
                onCellPrepared: function (e) {

                },
                loadPanel: {
                    enabled: true
                },
                paging: {
                    pageSize: 100,
                },
                searchPanel: {
                    visible: true,
                    width: 240,
                    placeholder: $translate.instant('SearchPlaceholder')
                },
                showBorders: true,
                hoverStateEnabled: true,
                //scrolling: { mode: "virtual" },
                noDataText: $translate.instant('AccountVoucher_DataGrid_NoDataText'),
                height: '99%',
                width: '98%',
                filterRow: {
                    visible: true
                },
                onRowUpdating: function (e) {
                },
                onToolbarPreparing: function (e) {
                }
            }
        }

        //导出数据
        $scope.downloadTB = function () {
            citPreviewDataService.exportDataSalaryAdvance( $scope.queryParams).success(function (data, status, headers) {
                if(status===204){
                    SweetAlert.warning("没有数据可以下载");
                    return;
                }
                vatExportService.exportToExcel(data, status, headers, '预提重分类数据源.xlsx', true);
            }).error(function (error) {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        }


        $scope.doDataReset = function () {
            $scope.queryParams.period = null;
            $scope.queryParams.poSubjectName = null;
            $scope.refreshConfigGrid();
        }
        $scope.doSearch = function () {
            $scope.refreshConfigGrid();
        }

        var initListData = function(){
            citPreviewDataService.getCitPreviewSalaryAdvanceDataList($scope.queryParams).success(function (res) {
                $scope.listData = commonWebService._index(res.list);
                $scope.queryParams.pagingOptions.totalItems = res.pageInfo.totalCount;
                //$scope.$apply();
            }).error(function (error) {
                swal({
                    title: "信息",
                    text: error,
                    type: "info"
                });
            });

        }

        //刷新页面
        $scope.refreshConfigGrid = function () {
            citPreviewDataService.getCitPreviewSalaryAdvanceDataList($scope.queryParams)
                .success(function (res) {
                    if (res && res.list) {
                        $scope.listData =commonWebService._index(res.list);
                        $scope.queryParams.pagingOptions.totalItems = res.pageInfo.totalCount;
                    }else {
                        SweetAlert.error($translate.instant('SystemError'));
                    }
                })
        };


        //开始
        (function initialize() {
            $('#input-invoice-period-picker').focus(function () {
                $('.filter-button').popover("hide");
            });
            //初始化month-picker
            $('#input-invoice-period-picker').rangePicker({
                minDate: minDate,
                maxDate: maxDate,
                setDate: setDate,
                months: $scope.monthList,//['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
                ConfirmBtnText: $translate.instant('Confirm'),
                CancelBtnText: $translate.instant('ButtonCancel')
            }) .on('datePicker.done', function (e, result) {
                //对日期进行封装
                var start = result[0][1].toString()  + result[0][0];
                var end  =result[1][1].toString()  + result[1][0];
                commonWebService._dateByPicker(start, end);//转换日期
                //开始月份
                $scope.queryParams.periodStart = commonWebService._dateByPicker(start, end).start;
                //结束月份
                $scope.queryParams.periodEnd = commonWebService._dateByPicker(start, end).end;
                $scope.refreshConfigGrid();
            });
            $scope.queryParams = {};
            $scope.formParam = {};

            //分页的设置
            $scope.queryParams.pagingOptions = {
                pageIndex: 1,  //当前页码
                totalItems: 0,  //总数据
                pageSize: 20,  //每页多少条数据
            };
            initAssetResultDxGrid();
            initListData();
        })();
    }
]);