﻿citModule.controller('citReportLayoutController', ['$scope', '$log', '$q', 'loginContext',
    '$translate', '$location', 'templateGroupService', 'vatSessionService', 'citReportService', '$state', 'enums', /*'checkListService',*/
    function ($scope, $log, $q, loginContext, $translate, $location, templateGroupService, vatSessionService,
        citReportService, $state, enums/*, checkListService*/) {
        'use strict';
        $scope.$on('refreshGenerateReport', function (event, data) {
            // $scope.selectedTemplateId = data.templateId;
            loadTemplateMenu();
        });
        var loadTemplateMenu = function () {
            // Mock Data
            var projectID = vatSessionService.project.id;
            //because project in overview is mock up, so I have to mock the project id from database,
            //otherwise the project not exist in database.
            //通用
            //projectID = 'd6dcfb47-a92c-4b0b-a063-354b63756bd0';
            //房地产
            //projectID = '0cf0945f-d41c-4df3-8235-ae693d5e724d';
            $q.all([
                templateGroupService.getGroupTemplateByGroupID(vatSessionService.project.templateGroupID, projectID),
                citReportService.getFilterTemplate(vatSessionService.project.id, constant.serviceType.CIT, 0)
            ]).then(function (result) {
                if (!_.isEmpty(result[0]) && !_.isEmpty(result[0].data) && !_.isEmpty(result[0].data.data)
                    && !_.isEmpty(result[1]) && !_.isEmpty(result[1].data) && !_.isEmpty(result[1].data.data)) {

                    // 获取 BSPL Report Template
                    var grps = [];
                    if ($scope.hasBsPlPermission) {
                        //todo:use reject here later , filter here just for test --FX
                        //grps = _.filter(result[0].data.data, {name: 'TaxReturn'});
                        if (grps && grps[0] && grps[0].children) {
                            if (!$scope.hasBsPermission) {
                                grps.children = _.reject(grps[0].children, {name: '资产负债表'});
                            }
                            if (!$scope.hasPlPermission) {
                                grps.children = _.reject(grps[0].children, {name: '利润表'});
                            }
                        }
                    }

                    if ($scope.hasTaxReturnPermission && $scope.hasQueryTaxReturnPermission) {
                        var len = grps.length;//初始化第一个排序号
                        var grpByType = _.groupBy(result[1].data.data, 'reportType');
                        _.each(grpByType, function (val, key) {
                            var typeName = 'TaxReturnType';
                            if (key != null || key == "null") {
                                //兼容以前的的 vat报表 类型 为 null 的情况
                                var idx = 1;
                                var obj = _.find(constant.citReportTypeList, { 'value': parseInt(key) });
                                if (obj != null) {
                                    typeName = obj.name;
                                    idx = len + obj.orderIndex;
                                }
                            }

                            // 获取 申报表 Report Template
                            var taxRtnGrp = {
                                name: typeName,
                                children: _.map(val, function (x) {
                                    return {
                                        reportId: x.id,
                                        id: x.templateId,
                                        name: x.templateName,
                                        code: x.templateCode
                                    }
                                }),
                                orderIndex: idx
                            };
                            grps.push(taxRtnGrp);
                        });
                    }
                    //     var diffArr = ['会计数据统计','出口数据比对','进项税额差异分析表','收入差异分析表'];
                    //     // var templates = _.chain
                    //     // 获取 申报表 Report Template
                    //     var diffRtnGrp = {name:'差异分析表', children:[],orderIndex:1};
                    //     var taxRtnGrp = {
                    //         name: 'TaxReturn',
                    //         children: _.chain(result[1].data.data)
                    //             .sortBy(function(x){
                    //                 return x.templateCode;
                    //             })
                    //             .map(function(x){
                    //                 var nameIndex;
                    //                 // var tempName = x.templateName.substr(x.templateName.length - 4);
                    //                 if(x.templateName == ('增值税纳税申报表')){
                    //                     nameIndex = 0;
                    //                 } else if(x.templateName.search("一") != -1){
                    //                     nameIndex = 1;
                    //                 } else if(x.templateName.search("二") != -1){
                    //                     nameIndex = 2;
                    //                 } else if(x.templateName.search("三") != -1){
                    //                     nameIndex = 3;
                    //                 } else if(x.templateName.search("四") != -1){
                    //                     nameIndex = 4;
                    //                 } else if(x.templateName.search("五") != -1){
                    //                     nameIndex = 5;
                    //                 } else if(x.templateName.search('代扣代缴') != -1){
                    //                     nameIndex = 6;
                    //                 } else if(x.templateName.search('海关专用') != -1){
                    //                     nameIndex = 7;
                    //                 } else if(x.templateName.search('增值税减免税申报明细表') != -1){
                    //                     nameIndex = 8;
                    //                 } else if(x.templateName.search('营改增') != -1){
                    //                     nameIndex = 9;
                    //                 } else if(x.templateName.search('附加税报表') != -1){
                    //                     nameIndex = 10;
                    //                 } else {
                    //                     nameIndex = 20;
                    //                     if($.inArray(x.templateName, diffArr) != -1){
                    //                         diffRtnGrp.children.push(x);
                    //                     }
                    //                 }
                    //                return {
                    //                     id:x.id,
                    //                     templateId:x.templateId,
                    //                     templateName:x.templateName,
                    //                     templateCode:x.templateCode,
                    //                     nameIndex:nameIndex
                    //                 }
                    //             })
                    //             .filter(function(x){
                    //                 return $.inArray(x.templateName, diffArr) == -1;
                    //             })
                    //             .sortBy(function(x){
                    //                 return x.nameIndex;
                    //             })
                    //             .map(function (x) {
                    //             return {
                    //                 reportId: x.id,
                    //                 id: x.templateId,
                    //                 name: x.templateName,
                    //                 code: x.templateCode
                    //             };
                    //         }).value(),
                    //         orderIndex: grps.length
                    //     };

                    //     diffRtnGrp.children = _.chain(diffRtnGrp.children)
                    //         .map(function(x){
                    //             return {
                    //                 reportId: x.id,
                    //                 id: x.templateId,
                    //                 name: x.templateName,
                    //                 code: x.templateCode
                    //             };
                    //         }).value();
                    //     grps.push(taxRtnGrp);
                    //     grps.push(diffRtnGrp);
                    // }

                    $scope.groups = _.chain(grps).sortBy(function (x) {
                        return x.orderIndex;
                    }).map(function (x) {
                        x.isExpand = true;
                        return x;
                    }).value();

                    $scope.selectedTemplateId = null;
                    if (vatSessionService.isFromTopMenu) {
                        var firstNode = _.first(grps);
                        var firstSubNode = _.first(firstNode.children);
                        if(firstSubNode.id!==undefined) {
                            $scope.selectedTemplateId = firstSubNode.id;
                            $state.go('cit.generateReport.reportView', {
                                id: firstSubNode.reportId,
                                templateid: firstSubNode.id,
                                name: firstSubNode.name,
                                templatecode: firstSubNode.code
                            });
                            vatSessionService.isFromTopMenu = false;
                        }
                    }
                    //var firstNode = _.first(grps);
                    //var firstSubNode = _.first(firstNode.children);
                    //$scope.selectedTemplateId = firstSubNode.id;
                    //$state.go('vat.generateReport.reportView', { id: firstSubNode.reportId, templateid: firstSubNode.id, name: firstSubNode.name, templatecode: firstSubNode.code });
                }
                //$scope.menus = [{ id: 'mainVatReturns', text: $translate.instant('mainVatReturnsReport').replace(/;/g, '<br/>') }];
            });
        };

        //检查用户机构权限
        var checkUserOrganizationPermissionList = function () {
            var list = [];
            var reportTemp = constant.vatPermission.reportView;
            list.push(reportTemp.bsplCode);
            list.push(reportTemp.bspl.bsCode);
            list.push(reportTemp.bspl.plCode);
            list.push(reportTemp.taxReturnCode);
            list.push(reportTemp.taxReturn.queryCode);
            list.push(reportTemp.taxReturn.editCode);
            $scope.hasBsPlPermission = false;
            $scope.hasBsPermission = false;
            $scope.hasPlPermission = false;
            $scope.hasTaxReturnPermission = false;
            $scope.hasQueryTaxReturnPermission = false;
            $scope.hasEditTaxReturnPermission = false;
            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasBsPlPermission = data[reportTemp.bsplCode];
                $scope.hasBsPermission = data[reportTemp.bspl.bsCode];
                $scope.hasPlPermission = data[reportTemp.bspl.plCode];
                $scope.hasTaxReturnPermission = data[reportTemp.taxReturnCode];
                $scope.hasQueryTaxReturnPermission = data[reportTemp.taxReturn.queryCode];
                $scope.hasEditTaxReturnPermission = data[reportTemp.taxReturn.editCode];
            });
        };
        var toggleGroup = function (group) {
            group.isExpand = !group.isExpand;
        };
        $scope.uploadliShow = false;
        (function initialize() {
            checkUserOrganizationPermissionList();
            loadTemplateMenu();
            $scope.expend = true;
            $scope.toggleGroup = toggleGroup;
        })();

    }]);