﻿citModule.directive('citReportLayout', ['$log', '$rootScope', '$timeout', 'enums',
    function ($log, $rootScope, $timeout, enums) {
        'use strict';

        $log.debug('citReportLayout.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/cit/report/cit-report-layout/cit-report-layout.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'citReportLayoutController',
            link: function ($scope, $element, $attr) {



                Split(['#cit-report-nav-menu', '#cit-report-content'], {
                    sizes: [17, 83],
                    minSize: [1, 1330],
                    onDragEnd: function () {
                        $timeout(function () {
                            $rootScope.$broadcast(enums.vatEvent.layoutChanged, {});
                        }, 700);
                    }
                })


                $scope.isCollapsed = false;
            }
        };
    }
]);

citModule.directive('eatClickIf', ['$parse', '$rootScope',
  function ($parse, $rootScope) {
      return {
          // this ensure eatClickIf be compiled before ngClick
          priority: 100,
          restrict: 'A',
          compile: function ($element, attr) {
              var fn = $parse(attr.eatClickIf);
              return {
                  pre: function link(scope, element) {
                      var eventName = 'click';
                      element.on(eventName, function (event) {
                          var callback = function () {
                              if (fn(scope, { $event: event })) {
                                  // prevents ng-click to be executed
                                  event.stopImmediatePropagation();
                                  // prevents href 
                                  event.preventDefault();
                                  return false;
                              }
                          };
                          if ($rootScope.$$phase) {
                              scope.$evalAsync(callback);
                          } else {
                              scope.$apply(callback);
                          }
                      });
                  },
                  post: function () { }
              }
          }
      }
  }
]);