﻿citModule.controller('entryListModalController', ['$log', 'apiInterceptor', 'Upload', '$scope', '$q', '$translate', '$uibModal', '$document', '$rootScope', 'SweetAlert', 'enums',
    'vatReportService', 'loginContext', 'vatSessionService', 'stdAccountService', 'vatCommonService', 'formulaService', 'KeyValueConfigService', 'modelConfigurationService', '$timeout', 'cellCommentService', 'modifiedReportCellService', 'commonWebService',
    function ($log, apiInterceptor, Upload, $scope, $q, $translate, $uibModal, $document, $rootScope, SweetAlert, enums, vatReportService, loginContext,
              vatSessionService, stdAccountService, vatCommonService, formulaService, KeyValueConfigService, modelConfigurationService, $timeout, cellCommentService, modifiedReportCellService, commonWebService) {

        var _ra = null;
        var priorities = ["Low", "Normal", "Urgent", "High"];
        var entityInit = function () {
            //初始化值
            $scope.entry = {
                JFFSETotal: "",
                DFFSETotal: "",
                QMYETotalFirst: "",
                QMYETotalend: ""
            }
        }
        var _logIndex = 0;
        if ($scope.relObj.logs == undefined || $scope.relObj.logs.length == 0) {
            $scope.relObj.logs = [];
        }
        entityInit();

        $scope.filterArr = ["isSelect", "=", "1"];
        $scope.dataGridOptions = {
            bindingOptions: {
                columns: 'entryListColumns',
                dataSource: 'relObj.entryDataSource',
                selectionFilter: 'filterArr'

            },
            loadPanel: {
                enabled: false
            },
            scrolling: {
                mode: "standard"
            },
            selection: {
                mode: "multiple",
                selectAllMode: "allPages",
                showCheckBoxesMode: "always",
                deferred: true
            },
            sorting: {
                mode: 'single'
            },
            filterRow: {
                visible: true
            },
            searchPanel: {
                visible: true,
                width: 240,
                placeholder: $translate.instant('SearchPlaceholder')
            },
            onSelectionChanged: function (selectedItems) {
                $scope.dataGrid.getSelectedRowsData().done(function (rowData) {
                    $scope.relObj.logs = $scope.doCalcute(rowData);
                });

                /* $scope.selectedItems = $.map(selectedItems.selectedRowsData, function (data) {
                     $scope.selectedAddDatasourceItems = selectedItems.selectedRowsData;
                     return data.id;
                 });
                var
                 $log.debug($scope.selectedItems);*/
                /*$scope.doCalcute(selectedItems.selectedRowsData);
                var _in = {};
                if (selectedItems.currentDeselectedRowKeys.length == 0) {
                    _in.operate = "增";
                    _in.accountingDate = selectedItems.currentSelectedRowKeys[0].accountingDate;
                    _in.voucherNum = selectedItems.currentSelectedRowKeys[0].voucherNum;
                    _in.orgCode = selectedItems.currentSelectedRowKeys[0].orgCode;
                    _in.organizationId = selectedItems.currentSelectedRowKeys[0].organizationId;
                    _in.id = selectedItems.currentSelectedRowKeys[0].id;
                    _in.subjectCode= selectedItems.currentSelectedRowKeys[0].subjectCode;
                } else {
                    _in.operate = "减";
                    _in.accountingDate = selectedItems.currentDeselectedRowKeys[0].accountingDate;
                    _in.voucherNum = selectedItems.currentDeselectedRowKeys[0].voucherNum;
                    _in.orgCode = selectedItems.currentDeselectedRowKeys[0].orgCode;
                    _in.organizationId = selectedItems.currentDeselectedRowKeys[0].organizationId;
                    _in.id = selectedItems.currentDeselectedRowKeys[0].id;
                    _in.subjectCode= selectedItems.currentDeselectedRowKeys[0].subjectCode;
                }
                _in.subjectCode = $scope.relObj.entryLogIdByCode;
                $scope.relObj.logs.push(_in);*/
            },
            allowColumnResizing: true,
            hoverStateEnabled: true,
            showBorders: true,
            showRowLines: true,
            showColumnLines: true,
            filterRow: {
                visible: true
            },
            onInitialized: function (e) {
                $scope.dataGrid = e.component;

            }
        };

        $scope.relObj.initMethod = function () {
            $scope.dataGrid.getSelectedRowsData().done(function (rowData) {
                $scope.relObj.logs = $scope.doCalcute(rowData);
                switch ($scope.relObj.backSelect) {
                    case $('check1').data("type"):
                        $('#check1').click();
                        break;
                    case $('check2').data("type"):
                        $('#check2').click();
                        break;
                    case $('check3').data("type"):
                        $('#check3').click();
                        break;
                    case $('check4').data("type"):
                        $('#check4').click();
                        break;
                }
            });
        }

        //设置数据源表格的列
        var getEntryListColumns = function () {
            return [
                {
                    dataField: 'index',
                    caption: $translate.instant('ImportErrorPopUpNoCol'),
                    alignment: 'center'
                },
                {
                    dataField: 'accountingDate',
                    caption: $translate.instant('JournalPZRQ'),
                    alignment: 'left',
                    dataType: 'date',
                    customizeText: function (cellInfo) {
                        if (cellInfo && cellInfo.value) {
                            return new Date(cellInfo.value).dateTimeToString('yyyyMMdd');
                        }
                        return "";
                    }
                },
                {
                    dataField: 'voucherNum',
                    caption: $translate.instant('AccountVoucher_DataGrid_ColVID'),
                    alignment: 'center'
                },
                {
                    dataField: 'description',
                    caption: $translate.instant('JournalZY'),
                    alignment: 'center'
                },
                {
                    dataField: 'accountedDr',//借方发生额
                    caption: $translate.instant('DebitAmount'),
                    alignment: 'right'
                },
                {
                    dataField: 'accountedCr',//贷方发生额
                    caption: $translate.instant('CreditAmount'),
                    alignment: 'right'
                },
            ];
        };

        $scope.entryListColumns = getEntryListColumns();

        //确定
        $scope.makeSure = function () {
            $scope.relObj.checkRadio = _ra;
            $('#entryListModal').modal('hide');
        }

        $scope.selectRadio = function (event) {
            _ra = event.target.value;
        }

        $scope.cancel = function () {
            $('#entryListModal').modal('hide');
            //entityInit();
        }

        $scope.hideCellAttachmentModel = function () {
            $('#entryListModal').modal('hide');
            //entityInit();
        }

        //
        //配置计算公式进行计算
        $scope.doCalcute = function (data) {
            var log = [];
            var v1 = 0;//借方发生额合计
            var v2 = 0//贷方发生额合计
            var _index = 0;
            data.forEach(function (item) {
                if (_index == 0) {
                    v1 = parseFloat(item.accountedDr);
                    v2 = parseFloat(item.accountedCr);
                } else {
                    v1 += parseFloat(item.accountedDr);
                    v2 += parseFloat(item.accountedCr);
                }
                log.push({
                    operate: "增",
                    accountingDate: item.accountingDate,
                    voucherNum: item.voucherNum,
                    orgCode: item.orgCode,
                    organizationId: item.organizationId,
                    id: item.id,
                    subjectCode: item.subjectCode
                });
                _index++;

            });
            $scope.entry.JFFSETotal = v1.toFixed(2);
            $scope.entry.DFFSETotal = v2.toFixed(2);
            $scope.entry.QMYETotalFirst = (v2 - v1).toFixed(2);
            $scope.entry.QMYETotalend = (v1 - v2).toFixed(2);
            return log;
        }

    }
]);