﻿citModule.controller('entryLogModalController', ['$log', 'apiInterceptor', 'Upload', '$scope', '$q', '$translate', '$uibModal', '$document', '$rootScope', 'SweetAlert', 'enums',
    'vatReportService', 'loginContext', 'vatSessionService', 'stdAccountService', 'vatCommonService', 'formulaService', 'KeyValueConfigService', 'modelConfigurationService', '$timeout', 'cellCommentService', 'modifiedReportCellService',
    function ($log, apiInterceptor, Upload, $scope, $q, $translate, $uibModal, $document, $rootScope, SweetAlert, enums, vatReportService, loginContext,
              vatSessionService, stdAccountService, vatCommonService, formulaService, KeyValueConfigService, modelConfigurationService, $timeout, cellCommentService, modifiedReportCellService) {

        $scope.dataGridOptions = {
            bindingOptions: {
                columns: 'entryLogColumns',
                dataSource: 'relObj.logs'
            },
            loadPanel: {
                enabled: false
            },
            scrolling: {
                mode: "standard"
            },
            selection: {
                mode: "multiple"
            },
            sorting: {
                mode: 'single'
            },
            filterRow: {
                visible: true
            },
            searchPanel: {
                visible: true,
                width: 240,
                placeholder: $translate.instant('SearchPlaceholder')
            },
            allowColumnResizing: true,
            hoverStateEnabled: true,
            showBorders: true,
            showRowLines: true,
            showColumnLines: true,
        };


        //设置数据源表格的列
        var getEntryLogColumns = function () {
            var dataGridColumns;
            dataGridColumns = [
                {
                    dataField: 'index',
                    caption: $translate.instant('ImportErrorPopUpNoCol'),
                    alignment: 'center'
                },
                {
                    dataField: 'accountingDate',
                    caption: $translate.instant('OperateDate'),
                    alignment: 'left',
                    dataType: 'date',
                    customizeText: function (cellInfo) {
                        if (cellInfo && cellInfo.value) {
                            return new Date(cellInfo.value).dateTimeToString('yyyyMMdd');
                        }
                        return "";
                    }
                },
                {
                    dataField: 'voucherNum',
                    caption: $translate.instant('VoucherCode'),
                    alignment: 'center'
                },
                {
                    dataField: 'operate',
                    caption: $translate.instant('Operate'),
                    alignment: 'center'
                }
            ];
            return dataGridColumns;
        };

        $scope.entryLogColumns = getEntryLogColumns();

       /* $scope.$watch('relObj.logs', function (n,o) {

        });*/
        $scope.hideCellAttachmentModel = function () {
            $('#entryListModal').modal('hide');
        }
    }
]);