﻿commonModule.
controller('addEnterpriseAccountModalController', ['$scope', '$log', '$translate', 'uiGridConstants', '$location', '$timeout', '$interval', '$filter', 'SweetAlert', 'enterpriseAccountService', 'apiInterceptor', 'Upload',
    function ($scope, $log, $translate, uiGridConstants, $location, $timeout, $interval, $filter, SweetAlert, enterpriseAccountService, apiInterceptor, Upload) {

        var modalSelector = '#addEnterpriceAccountSetPop';
        var uploadUrl = apiInterceptor.webApiHostUrl + '/enterpriseAccountManage/Upload';
        var resumable = true;

        var showWarning = function (resultMsg) {

            var errMsg = $translate.instant(resultMsg);
            SweetAlert.warning(errMsg);
        };

        var showSuccessMsg = function (resultMsg) {

            var errMsg = $translate.instant(resultMsg);
            SweetAlert.success(errMsg);
        };

        var showModal = function () {
            $(modalSelector).modal("show");
        };
        $scope.$watch('operateType', function (newValue, oldValue) {
            if (newValue) {

                if (newValue == constant.Operation.Add) {
                    $scope.isAdd = true;
                    showModal();
                } else if (newValue == constant.Operation.Edit) {

                }
            }
        });

        $(".addEnterpriceAccountSetPop").on("hidden.bs.modal", function () {
            $scope.operateType = null;
        });

        $scope.closeModal = function () {
            $scope.operateType = null;
        };

        var hasDataUpdated = function () {
            $scope.operateType = null;
            $scope.isUpdate = true;
        };

        $scope.saveEnterpriseAccountSet = function () {

            resetErrorStatusSet();
            if (!($('#addEnterpriceAccountSetForm').valid())) {
                return false;
            }

            if ($scope.isAdd && !$scope.file) {
                SweetAlert.warning($translate.instant(resources.setfileRequired));
                return false;
            }

            enterpriseAccountSetOrgValidate();
            hasDataUpdated();
        };


        var importData = function () {
            if (!$scope.file || !$scope.file.name) {

                SweetAlert.info($translate.instant('SelectCustomerFileRequired'));
                return;
            }

            var tempFileName = PWC.newGuid() + '.dat';
            var token = $('input[name="__RequestVerificationToken"]').val();

            // if (!getEnterpriseAccountSetOrgListUI()) {
            //     return;
            // }

            // var orgList = $scope.editModel.saveOrgList;
            // var json = JSON.stringify(orgList);

            var enterpriseAccountSetID = $scope.isAdd ? '' : $scope.enterpriseAccountSetSelect().id;

            // updateProgressToZero();
            Upload.upload({
                url: uploadUrl,
                data: {
                    cancel: false,
                    filename: $scope.file.name,
                    tempFileName: tempFileName,
                    Remark: $scope.remark,
                    name: $scope.editModel.name,
                    // selectedOrgList: json,
                    enterpriseAccountSetID: enterpriseAccountSetID,
                    isImportAppend: $scope.isImportAppend,
                },
                file: $scope.file,
                resumeChunkSize: resumable ? $scope.chunkSize : null,
                headers: {
                    'Access-Control-Allow-Origin': '*',
                    Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken(),
                    __RequestVerificationToken: token,
                    withCredentials: true
                },
                __RequestVerificationToken: token,
                withCredentials: true
            }).then(function (resp) {
                var ret = resp.data;
                if (ret.result) {

                    $scope.errList = [];
                    $scope.ImportErrorTag = false;
                    // 全部导入成功
                    $('#addEnterpriceAccountSetPop').modal('hide');
                    $('#importEnterpriceAccountSetPop').modal('hide');
                    if ($scope.isAdd) {
                        SweetAlert.success($translate.instant('AddSuccess'));
                    } else {
                        SweetAlert.success($translate.instant('ImportSuccess'));
                    }

                } else {

                    if (ret.resultMsg && ret.resultMsg.length > 0) {
                        SweetAlert.warning($translate.instant(ret.resultMsg));
                        //SweetAlert.swal($translate.instant(ret.resultMsg));
                        $scope.errList = [];
                        $scope.ImportErrorTag = false;
                    } else {
                        // 提示没有导入成功的数据
                        var codeNameList = [];

                        var errorInfo = $translate.instant('ImportErrorTips').format(ret.data.length);
                        $scope.errList = ret.data;
                        $scope.ImportErrorTag = true;

                        SweetAlert.swal({
                            title: $translate.instant('EnterpriceAccountManage'),
                            text: errorInfo,
                            type: "info",
                            showCancelButton: false,
                            closeOnConfirm: false,
                            closeOnCancel: true,
                            html: true
                        });

                    }
                }

            }, function (resp) {
                console.log('Error status: ' + resp.status);
            }, function (evt) {
                var progressPercentage = parseInt(100.0 * evt.loaded / evt.total);
                $log.debug('progress: ' + progressPercentage + '% ' + evt.config.data.file.name);
            });
        };
        var setErrorStyle = function (error, element) {
            if (element.hasClass('has-error')) {
                element.parent().addClass('has-error');
                error.insertAfter(element);
                error.addClass('label');
            }
        };

        var saveEditEnterpriseAccountSet = function () {
            resetErrorStatusSet();
            if (!($('#addEnterpriceAccountSetForm').valid())) {
                return;
            }

            if ($scope.isAdd) {
                $scope.isImportAppend = false;
                importData();
            } else {

                // 有文件的修改
                if ($scope.file) {

                    SweetAlert.swal({
                        title: $translate.instant('ComfirmImportData'),
                        text: $translate.instant('EnterpriseAccountSetOverLayImportTips'),
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        confirmButtonText: $translate.instant('Confirm'),
                        cancelButtonText: $translate.instant('Cancel'),
                        closeOnConfirm: false,
                        closeOnCancel: true
                    },
                        function (isConfirm) {
                            if (isConfirm) {
                                // 选中
                                importData();
                            }
                        });

                } else {
                    // 没有文件修改
                    var model = {
                        id: $scope.enterpriseAccountSetSelect().id,
                        name: $scope.editModel.name,
                        // enterpriseAccountSetOrgList: []
                    };

                    // if (!getEnterpriseAccountSetOrgListUI()) {
                    //     return;
                    // }

                    // model.enterpriseAccountSetOrgList = $scope.editModel.saveOrgList;

                    enterpriseAccountService.updateEnterpriseAccountSet(model).success(function (data) {
                        if (data && data.result) {
                            $('#addEnterpriceAccountSetPop').modal('hide');
                            loadEnterpriseAccountSetList();
                            SweetAlert.success($translate.instant('SaveSuccess'));
                        } else {
                            swal($translate.instant('SaveFail'), $translate.instant(data.resultMsg), 'warning');
                        }
                    });
                }
            }
        };

        var getEnterpriseAccountSetOrgListUI = function () {

            var enterpriseAccountSetOrgList = [];
            var isError = false;
            if ($scope.editModel.enterpriseAccountSetOrgList && $scope.editModel.enterpriseAccountSetOrgList.length > 0) {
                for (var i = 0; i <= $scope.editModel.enterpriseAccountSetOrgList.length - 1; i++) {
                    var row = $scope.editModel.enterpriseAccountSetOrgList[i];
                    var item = {
                        OrganizationID: row.organizationID,
                        EffectiveDateStr: row.effectiveDateStr,
                        ExpiredDateStr: row.expiredDateStr
                    };

                    if (!row.organizationID) {
                        SweetAlert.warning(resources.organizationRequired);

                        return false;
                    }

                    if (!row.effectiveDateStr) {
                        SweetAlert.warning(resources.effectiveDateRequired);
                        return false;
                    }

                    if (!row.expiredDateStr) {
                        SweetAlert.warning(resources.expiredDateRequired);
                        return false;
                    }

                    if (!validateDate(row.effectiveDateStr, row.expiredDateStr)) {
                        SweetAlert.warning($translate.instant('EffectiveDateAreaProblem'));
                        return false;
                    }

                    enterpriseAccountSetOrgList.push(item);
                };
            }

            $scope.editModel.saveOrgList = enterpriseAccountSetOrgList;
            return true;
        };

        var validateDate = function (from, to) {
            var fromDate = new Date(from + '-01');
            var toDate = new Date(to + '-01');
            toDate.setMonth(toDate.getMonth() + 1);
            toDate.setDate(toDate.getDate() - 1);

            if (fromDate <= toDate) {
                return true;
            } else {
                return false;
            }
        };

        // 验证机构唯一性
        var enterpriseAccountSetOrgValidate = function () {
            var model = {
                id: $scope.editModel.id,
                enterpriseAccountSetOrgList: []
            };

            if (!getEnterpriseAccountSetOrgListUI()) {
                return;
            }

            model.enterpriseAccountSetOrgList = $scope.editModel.saveOrgList;

            enterpriseAccountService.enterpriseAccountSetOrgValidate(model).success(function (data) {
                if (data && data.result) {
                    // 验证成功
                    saveEditEnterpriseAccountSet();
                } else {
                    if (data.data && data.data.length > 0) {
                        var orgNameList = [];
                        var i = 1;
                        data.data.forEach(function (row) {
                            orgNameList.push(i + '.' + $translate.instant('OrganizationName') + ':' + row.organizationName);
                            i++;
                        });

                        orgNameList = getLimitLogs(orgNameList);

                        var str = orgNameList.join('<br/>');

                        str = "<div class='text-left'>" + str + '</div>';

                        SweetAlert.swal({
                            title: $translate.instant(data.resultMsg),
                            text: str,
                            type: "warning",
                            showCancelButton: false,
                            confirmButtonColor: "#DD6B55",
                            confirmButtonText: $translate.instant('Confirm'),
                            cancelButtonText: $translate.instant('Cancel'),
                            closeOnConfirm: false,
                            closeOnCancel: false,
                            html: true
                        }
                             );

                    }
                }

            });
        };

        var resetErrorStatusSet = function () {
            var currentForm = $('#addEnterpriceAccountSetForm');
            $('#addEnterpriceAccountSetForm .has-error > label').remove();
            currentForm.find('.has-error').removeClass('has-error');
            validatorset.resetForm();
        };

        var resources = {
            codeRequired: $translate.instant('EnterpriceAccountCodeRequired'),
            nameRequired: $translate.instant('EnterpriceAccountNameRequired'),
            selectDirectionRequired: $translate.instant('StandardAccountRequired'),
            selectAcctPropRequired: $translate.instant('StandardAccountAccountTypesRequired'),
            setnameRequired: $translate.instant('EnterpriceAccountSetNameRequired'),
            setfileRequired: $translate.instant('EnterpriceAccountSetFileRequired'),
            enterpriseAccountSetNameRepeat: $translate.instant('EnterpriseAccountSetNameRepeat'),
            organizationRequired: $translate.instant('SelectOrganizationRequired'),
            effectiveDateRequired: $translate.instant('EffectiveDateRequired'),
            expiredDateRequired: $translate.instant('ExpiredDateRequired')
        };



        var validatorset = $("#addEnterpriceAccountSetForm").validate({
            errorClass: "has-error",
            rules: {
                name: {
                    required: true,
                    remote: {
                        type: "get",
                        url: apiInterceptor.webApiHostUrl + "/enterpriseAccountManage/enterpriseAccountSetNameValidate",
                        data: {
                            id: function () {
                                return $("#enterpriseAccountSetID").val();
                            },
                            name: function () {
                                return $("#enterpriseAccountSetName").val();
                            }
                        },
                        dataType: "json",
                        dataFilter: function (data, type) {

                            var ret = JSON.parse(data);
                            if (ret && ret.result)
                                return true;
                            else
                                return false;
                        }
                    }
                },
                fileName: {
                    // 把这条注释条， ng-required生效
                    // required: true
                },
                organization: {
                    // required: true
                },
                effectiveDate: {
                    // required: true
                },
                expiredDate: {
                    // required: true
                }

            },
            messages: {
                name: {
                    required: resources.setnameRequired,
                    remote: resources.enterpriseAccountSetNameRepeat
                },
                fileName: {
                    required: resources.setfileRequired
                },
                organization: {
                    required: resources.organizationRequired
                },
                effectiveDate: {
                    required: resources.effectiveDateRequired
                },
                expiredDate: {
                    required: resources.expiredDateRequired
                }

            },
            errorPlacement: function (error, element) {
                setErrorStyle(error, element);
            }
        });


        (function initialize() {
            $log.debug('addEnterpriseAccountModalController.ctor()...');
            // showModal();
        })();

    }
]);
