﻿commonModule.
controller('editEquityChangeModalController', ['$scope', '$log', '$translate', 'uiGridConstants', '$location', '$timeout', '$interval', 'areaRegionService', '$filter', 'SweetAlert', 'regionService', 'orgService', 'enterpriseAccountService', 'organizationStructureService', 'businessUnitService', 'projectService', 'dimensionService','equityService',
    function ($scope, $log, $translate, uiGridConstants, $location, $timeout, $interval, areaRegionService, $filter, SweetAlert, regionService, orgService, enterpriseAccountService, organizationStructureService, businessUnitService, projectService, dimensionService,equityService) {

        var selectedModel = '.editEquityChangeControlPop'; //'#addOrgControlPop' + $scope.dimensionId;

        $scope.pleaseSelect = $translate.instant('PleaseSelect');
        $scope.startDate = new Date(new Date().getFullYear() - 20, 1, 1);
        $scope.endDate = new Date(new Date().getFullYear() + 20, 1, 1);
        $scope.viewMode = 1;


        $scope.showPage = function (pageIndex) {

            // if (pageIndex === 0)
            // {
            //     $('#orgModalFooter').css('padding-left','139px');
            // } else{
            //     $('#orgModalFooter').css('padding-left','35px');
            // }

        };

        $scope.nameKeyUp = function(){
            var hasSpecialChar = window.PWC.hasSpecialChar($scope.editEquityModel.name);

            if (hasSpecialChar){
                $scope.editEquityModel.nameError = $translate.instant('SpecialChar');
            } else{
                $scope.editEquityModel.nameError = null;
            }
        };

        // 保存股权
        $scope.saveEquity = function () {
            $scope.equityControlForm.$setSubmitted();
            var rows = $scope.equityListInstance.getVisibleRows();
            var updateEquity = [];
            for (var i = 0; i < rows.length; i++) {
                delete rows[i].data.__KEY__;
                rows[i].data.organizationId = $scope.editOrgModel.id;
                updateEquity.push(rows[i].data);
            }
            var comment = $scope.editOrgModel.comment?$scope.editOrgModel.comment:'';
            equityService.change($scope.editOrgModel.name,comment,updateEquity).success(function (data) {
                if (data && !data.result) {
                    //SweetAlert.info("Disable", orgId);
                    SweetAlert.warning($translate.instant(data.resultMsg));
                    return;
                }
                SweetAlert.success($translate.instant('EquityChangeSuccess'));
                // refreshEquity($scope.editOrgModel.id);
                $scope.operateType = null;
            });
        };

        var loadEquityInfoDatagrid = function () {

            $scope.equityInfoGridOptions = {
                bindingOptions: {
                    // dataSource: equityInfoStore
                    dataSource: 'EquityList'
                },
                showBorders: true,
                editing: {
                    mode: "batch",
                    allowUpdating: true,
                    allowDeleting: true,
                    allowAdding: true
                },
                columns: [
                    {
                        dataField : "id",
                        visible : false,
                        allowHeaderFiltering:false
                    },
                    {
                        dataField: "eNum",
                        visible : false,
                        sortOrder: "asc",
                        allowHeaderFiltering:false
                    },
                    {
                        dataField: "organizationId",
                        visible : false,
                        allowHeaderFiltering:false
                    },
                    {
                        dataField: "investorName",
                        caption: $translate.instant('InvestorName'),
                        allowHeaderFiltering:false
                    },
                    {
                        dataField: "investorEconomicNature",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('InvestorEconomicNature')
                    },
                    {
                        dataField: "certificateType",
                        caption: $translate.instant('CertificateType'),
                        width: "140px",
                        lookup: {
                            dataSource: constant.CertificateTypeList,
                            displayExpr: "type",
                            valueExpr: "type"
                        }
                    },
                    {
                        dataField: "idNum",
                        caption: $translate.instant('IdNum'),
                        allowHeaderFiltering: false
                    },
                    {
                        dataField: "investmentAmount",
                        caption: $translate.instant('InvestmentAmount'),
                        allowHeaderFiltering: false
                    },
                    {
                        dataField: "investmentCurrency",
                        caption: $translate.instant('InvestmentCurrency'),
                        allowHeaderFiltering: false,
                        lookup: {
                            dataSource: constant.EquityCurrency,
                            displayExpr: "type",
                            valueExpr: "type"
                        }
                    },
                    {
                        dataField: "investmentRadio",
                        caption: $translate.instant('InvestmentRadio'),
                        allowHeaderFiltering: false
                    },
                    {
                        dataField: "payableShareholderName",
                        caption: $translate.instant('PayableShareholderName'),
                        allowHeaderFiltering: false
                    },
                    {
                        dataField: "payableShareholderIdNum",
                        caption: $translate.instant('PayableShareholderIdNum'),
                        allowHeaderFiltering: false
                    },
                    {
                        dataField: "payableCapitalContributionAmount",
                        caption: $translate.instant('PayableCapitalContributionAmount'),
                        allowHeaderFiltering: false
                    },
                    {
                        dataField: "payableCapitalContributionCurrency",
                        caption: $translate.instant('PayableCapitalContributionCurrency'),
                        allowHeaderFiltering: false,
                        lookup: {
                            dataSource: constant.EquityCurrency,
                            displayExpr: "type",
                            valueExpr: "type"
                        }
                    },
                    {
                        dataField: "payableContributionProportion",
                        caption: $translate.instant('PayableContributionProportion'),
                        allowHeaderFiltering: false
                    }
                ],
                onContentReady: function (e) {
                    $scope.equityListInstance = e.component;
                    var totalCount =e.component.totalCount();
                    if(totalCount>0)
                    {
                        $scope.totalCount=totalCount;
                    }
                },
                onEditingStart: function(e) {
                },
                onInitNewRow: function(e) {
                },
                onRowInserting: function(e) {
                    SweetAlert.success($translate.instant('ClickEnsureTip'));
                },
                onRowInserted: function(e) {
                },
                onRowUpdating: function(e) {
                    SweetAlert.success($translate.instant('ClickEnsureTip'));
                },
                onRowUpdated: function(e) {
                },
                onRowRemoving: function(e) {
                    SweetAlert.success($translate.instant('ClickEnsureTip'));
                },
                onRowRemoved: function(e) {
                },
                loadPanel: {
                    enabled: false
                },
                selection: {
                    mode: "single"
                },
                grouping: {
                    autoExpandAll: false
                },
                allowColumnResizing: true,
                columnAutoWidth: true,
                showRowLines: true,
                showColumnLines: true,
                rowAlternationEnabled: true,  //单双行颜色
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                /*searchPanel: {
                    placeholder: $translate.instant('Search'),
                    width: 518,
                    visible: false
                },*/
                headerFilter: {
                    visible: false,
                    texts: {
                        cancel: $translate.instant('Cancel'),
                        ok: $translate.instant('Confirm'),
                        emptyValue: $translate.instant('Empty'),
                        selectAllText: $translate.instant('SelectAll'),
                    }
                }
            };

        };

        // 加载机构
        var loadEquity = function (orgId) {

            //清空组织机构，重新获取，达到刷新效果
            $scope.editEquityModel = {
                TypeLevel: 1
            };

            $scope.isShowBasic = false;
            $scope.equityControlForm.$setPristine();

            if (!orgId) {
                orgId = $scope.selectCompany.id;
            }
            $scope.isAdd = false;
            $scope.orgHasAccountMapping = false;

            orgService.getSingleOrg(orgId).success(function (orgData) {
                orgData.updateTime = $filter('date')(orgData.updateTime, 'yyyy-MM-dd');
                $scope.selectCompany = orgData;
                $scope.editOrgModel = orgData;
            });

            refreshEquity(orgId);


            /*equityService.getEquityList(orgId).success(function (equityData) {

                $scope.EquityList = equityData;

            });*/

            $(selectedModel).modal('show');
        };

        var refreshEquity = function (orgId){
            equityService.getEquityList(orgId).success(function (equityData) {
                $scope.EquityList = equityData;
                if(equityData){
                    $scope.equityId = equityData[0].id;
                }
                // $scope.equityInfoGridOptions.bindingOptions.dataSource.reload();
                $scope.totalCount = $scope.EquityList.length;
                $scope.equityListInstance.refresh();
            });
        };

        $scope.removeDisabled = function () {
            var businessUnitList = $scope.businessUnitList;
            $scope.businessUnitList = _.without(businessUnitList, _.findWhere(businessUnitList, {
                id: 'newadd'
            }));
        };

        // 基础数据初始化
        var init = function () {
            loadEquityInfoDatagrid();
            initDatePicker();
        };

        // 验证开始时间
        $scope.checkStartDate = function (row) {

            if (row.startDate && !window.PWC.checkMonth(row.startDate)) {
                row.startDateError = $scope.resources.DateMonthFormatError;
                return;
            } else {
                row.startDateError = null;
            }

            if (!row.enterpriseAccountSetSelectID && !row.startDate && !row.endDate) {
                row.startDateError = null;
                return;
            }

            // if (!row.startDate) {
            //     row.startDateError = $scope.resources.EffectiveDateRequired;
            // } else {
            //     row.startDateError = null;
            // }

            if (row.startDate && row.endDate) {

                if (!validateDate(row.startDate, row.endDate)) {
                    row.startDateError = $scope.resources.EffectiveDateAreaProblem;
                } else {
                    row.startDateError = null;
                }
            }
        };

        // 验证结束时间
        $scope.checkEndDate = function (row) {


            // if (!row.endDate) {
            //     row.endDateError = $scope.resources.ExpiredDateRequired;
            // } else {
            //     row.endDateError = null;
            // }

            if (row.endDate && !window.PWC.checkMonth(row.endDate)) {
                row.endDateError = $scope.resources.DateMonthFormatError;
                return;
            } else {
                row.endDateError = null;
            }

            if (!row.enterpriseAccountSetSelectID && !row.startDate && !row.endDate) {
                row.endDateError = null;
                return;
            }


            if (row.startDate && row.endDate) {

                if (!validateDate(row.startDate, row.endDate)) {
                    row.startDateError = $scope.resources.EffectiveDateAreaProblem;
                } else {
                    row.startDateError = null;
                }
            }
        };

        // 设置时间控件
        var setDatepickerRow = function (rowData) {
            $("#" + rowData.fromID).datepicker({
                minViewMode: 1,
                autoclose: true,
                language: "zh-CN",
                format: "yyyy-mm"
            });

            $("#" + rowData.toID).datepicker({
                minViewMode: 1,
                autoclose: true,
                language: "zh-CN",
                format: "yyyy-mm"
            });

            $("#" + rowData.fromID).on('changeDate', function () {

                if ($("#" + rowData.fromID).val === '') {

                } else {
                    $("#" + rowData.toID).datepicker('setStartDate', $("#" + rowData.fromID).val());
                }
            });

            // 默认的错误信息先设置为空
            rowData.startDateError = null;
            rowData.endDateError = null;
        };

        // 说明
        $scope.resources = {
            OrganizationName: $translate.instant('OrganizationName'),
            OrganizationMsgNameRequired: $translate.instant('OrganizationMsgNameRequired'),
            OrganizationParent: $translate.instant('OrganizationParent'),
            OrganizationLevelType: $translate.instant('OrganizationLevelType'),
            OrganizationMsgLevelTypeRequired: $translate.instant('OrganizationMsgLevelTypeRequired'),
            OrganizationClientCode: $translate.instant('OrganizationClientCode'),
            OrganizationMsgClientCodeRequired: $translate.instant('OrganizationMsgClientCodeRequired'),
            OrganizationCode: $translate.instant('OrganizationCode'),
            OrganizationMsgCodeRequired: $translate.instant('OrganizationMsgCodeRequired'),
            OrganizationMsgCodeMaxLength: $translate.instant('OrganizationMsgCodeMaxLength'),
            OrganizationMsgCodePattern: $translate.instant('OrganizationMsgCodePattern'),
            OrganizationMsgCodeUnique: $translate.instant('OrganizationMsgCodeUnique'),
            OrganizationTaxPayerNumber: $translate.instant('OrganizationTaxPayerNumber'),
            OrganizationMsgTaxPayerNumberUnique: $translate.instant('OrganizationMsgTaxPayerNumberUnique'),
            OrganizationMsgAreaRequired: $translate.instant('OrganizationMsgAreaRequired'),
            OrganizationMsgProvinceRequired: $translate.instant('OrganizationMsgProvinceRequired'),
            OrganizationMsgCityRequired: $translate.instant('OrganizationMsgCityRequired'),
            OrganizationMsgEnterpriseAccountSetRequired: $translate.instant('OrganizationMsgEnterpriseAccountSetRequired'),
            EffectiveDateRequired: $translate.instant('EffectiveDateRequired'),
            ExpiredDateRequired: $translate.instant('ExpiredDateRequired'),
            EffectiveDateAreaProblem: $translate.instant('EffectiveDateAreaProblem'),
            OrganizationMsgTemplateRequired: $translate.instant('OrganizationMsgTemplateRequired'),
            OrganizationMsgProjectIndustryRequired: $translate.instant('OrganizationMsgProjectIndustryRequired'),
            DateMonthFormatError: $translate.instant('DateMonthFormatError')
        };

        $scope.$watch('operateType', function (newValue, oldValue) {
                if (newValue) {
                    if (newValue == constant.Operation.Add) {
                        // add
                        // newOrg();
                    } else if (newValue == constant.Operation.Edit) {
                        if ($scope.selectedOrganization) {
                            loadEquity($scope.selectedOrganization.id);
                        }
                    }
                }
            }
        );

        $scope.$watch('forceUpdate', function (newValue, oldValue) {
            if (newValue) {
                $scope.forceUpdate = false;
                initParams();
                init();
            }
        });

        $(".addOrgControlPop").on("hidden.bs.modal", function () {
            $('.modal-backdrop').remove();
            $(".addOrgControlPop").hide();
            $scope.operateType = null;
        });

        $scope.closeModal = function () {
            $scope.operateType = null;
        };

        // 初始化参数信息
        var initParams = function () {
            $scope.editEquityModel = {};
            $scope.selectCompany = {};
        };

        // 验证是否为时间段
        var validateDate = function (from, to) {
            var fromDate = new Date(from + '-01');
            var toDate = new Date(to + '-01');
            toDate.setMonth(toDate.getMonth() + 1);
            toDate.setDate(toDate.getDate() - 1);

            if (fromDate <= toDate) {
                return true;
            } else {
                return false;
            }
        };

        var initDatePicker = function () {
            var ele = $(".changeDatepicker");
            ele.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                viewMode: $scope.viewMode,
                minViewMode: $scope.viewMode,
                autoclose: true, //选中之后自动隐藏日期选择框
                clearBtn: true, //清除按钮
                todayBtn: false, //今日按钮
                format: 'yyyy-mm-dd' //日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            });
            ele.datepicker("setDate", new Date().formatDateTime('yyyy-mm-dd'));
        };

        (function initialize() {
            $log.debug('editEquityChangeModalController.ctor()...');
            $scope.maxdropLength = 20;
            $scope.maxTitleLength = 10;
            initParams();
            init();
        })();


    }
]);
