﻿commonModule.controller('editInvoiceModalController', ['$log', '$scope', '$translate', '$uibModal', '$document', 'SweetAlert', 'enums',
    '$timeout', '$document', '$compile', 'vatOutputInvoiceManageService', 'userService', 'loginContext', 'cardValidationService', '$state','$q',
    function ($log, $scope, $translate, $uibModal, $document, SweetAlert, enums, $timeout, $document, $compile, vatOutputInvoiceManageService,
        userService, loginContext, cardValidationService, $state,$q) {

        var thisService = {

            // 最大金额
            MaxPrice: 10000000.00,
            debug: false,

            // 从数据库中获取的修改理由
            OutputInvoiceUpdateReasonList: null,

            // 选中BD列表
            selectEntityList_ID: 'selectEntityList_ID',

            // 手动添加发票
            select_ADD_EntityList_ID: 'select_ADD_EntityList_ID',

            isChanged: false,

            // debug 用的 理由 与 OutputInvoiceUpdateReasonList 结构相同
            reasonList: [
                { id: '0062b0da-08a5-44e7-8dfd-5b880e20e8cc', englishName: 'Autopilot Hardware', chineseName: '辅助驾驶金额未加，手动调价' },
                { id: '1062b0da-08a5-44e7-8dfd-5b880e20e8cc', englishName: 'High Amperage Charger Upgrade', chineseName: '高功率车载充电器金额未加，手动调价' },
                { englishName: 'Insurance Subsidy', chineseName: '保险优惠未扣，手动调价' },
                { englishName: 'Trade-in Value Uplift', chineseName: '置换激励未扣，手动调价' },
                { englishName: 'Referral Credit', chineseName: '老车主推荐激励未扣，手动调价' }
            ],

            // 测试编辑数据
            testEditModel: null,
            OwnerOrgModel: {},

            // 主函数
            main: function () {

                $scope.isReadOnly = true;

                // 只能查看，不能修改
                $scope.isQueryOnly = false;
                $scope.editModel = {};

                thisService.getUserOwnerOrganization();
                $scope.updateStatus = thisService.updateStatus;

                thisService.watchCollection();

                thisService.test();

                thisService.bindEvent();
            },

            // 绑定事件
            bindEvent: function () {
                $scope.changeSubtotalforFinalPayment = thisService.changeSubtotalforFinalPayment;
            },

            // 限制输入两位小数
            limitTwoDigital: function (value) {
                //先把非数字的都替换掉，除了数字和.
                value = value.replace(/[^\d.]/g, "");
                //必须保证第一个为数字而不是.
                value = value.replace(/^\./g, "");
                //保证只有出现一个.而没有多个.
                value = value.replace(/\.{2,}/g, ".");
                //保证.只出现一次，而不能出现两次以上
                value = value.replace(".", "$#$").replace(/\./g, "").replace("$#$", ".");
                //保证.只后面只能出现两位有效数字
                value = value.replace(/([0-9]+\.[0-9]{2})[0-9]*/, "$1");

                return value;
            },

            // 购房名称及身份证号码，组织机构代码
            getBuyerInfo: function (data) {

                var str = '';

                if (!data) {
                    return str;
                }

                // if (data.registrationLocalName) {
                //     str = data.registrationLocalName;
                // }

                if (data.driverLicense) {
                    str += data.driverLicense;
                }

                if (data.organizationCode) {
                    str += data.organizationCode;
                }

                return str;

            },

            // 设置价格
            setPrice: function (data) {
                // 不含税价
                if (data.vatRateorLevyRate && data.subtotalforFinalPayment) {

                    // var rateStr = data.vatRateorLevyRate.replace('%', '');
                    // var rate = parseInt(rateStr) / 100;

                    // var notExcludeTaxPrice = data.subtotalforFinalPayment / (1 + rate);

                    // var price = Math.floor(notExcludeTaxPrice * 100) / 100;

                    // // 为了精确度的问题
                    // data.vatTax = (data.subtotalforFinalPayment * 10000 - price * 10000) / 10000;

                    // data.excludeTaxPrice = price;

                    vatOutputInvoiceManageService.computeBDPrice(data).success(function (ret) {
                        data.vatTax = ret.vatTax;
                        data.excludeTaxPrice = ret.excludeTaxPrice
                    });
                }
            },

            // 测试辅助方法
            test: function () {
                if (thisService.debug) {

                    // 测试编辑数据
                    thisService.testEditModel = {
                        registrationLocalName: 'tom li',
                        companyVATIDTaxID: '234826348762384',
                        governmentClassification: '小轿车',
                        brandandModelNumber: '拓速乐纯电动轿车 S60R5',
                        producingPlace: '美国',
                        certificateNumber: '',
                        importCertificateNumber: 'H34234234234',
                        ciqNumber: 'A234234234',
                        motorNumber: 'T937459834',
                        vin: '5Y837438743743',
                        subtotalforFinalPaymentCH: '陆拾伍万',
                        subtotalforFinalPayment: '650000.00',
                        invoiceCode: '',
                        invoiceNumber: '',
                        salesUnitName: '特斯拉汽车销售服务（xx）有限公司',
                        salesUnitPhoneNumber: '020-37253253',
                        salesTaxPayerNumber: '977277237575276354',
                        salesAccount: '23123123123',
                        salesAddress: 'XXX市~~~',
                        salesBankName: '花旗银行',
                        vatRateorLevyRate: '',
                        taxableSubtotal: 650000.00,
                        mainTaxAuthoritiesCode: 'XXX市 9274387293874',
                        excludeTaxPrice: 650000.00,
                        taxPaymentCertificateNumber: '123123213',

                        // 吨位
                        tonnage: null,

                        // 限乘人数
                        capacity: 5,

                        // 生产企业名称
                        manufacturer: 'tesla'
                    };
                }
            },

            // watch 数据
            watchCollection: function () {
                $scope.$watch('operateType', function (newValue, oldValue) {
                    if (newValue) {

                        if (newValue === constant.Operation.Add) {
                            thisService.addInvoiceModalDialog();
                        } else if (newValue === constant.Operation.Edit) {

                            //$scope.isReadOnly = true;
                            thisService.open();
                        } else if (newValue === constant.Operation.Query) {
                            // thisService.showInvoiceDialog();
                            $scope.isQueryOnly = true;
                            thisService.open();
                        }
                    }
                });


                //$scope.$watch('editModel.subtotalforFinalPayment', function (newValue, oldValue) {
                //    if (newValue) {
                //        thisService.changeSubtotalforFinalPayment();
                //    }
                //});
            },

            // 设置勾选
            setCheck: function (data) {

                if (data.historyReasonList && data.historyReasonList.length > 0) {
                    data.historyReasonList = angular.copy(data.historyReasonList);
                    if (data.reasonIDList && data.reasonIDList.length > 0) {
                        var checkedList = _.filter(data.historyReasonList, function (row) {
                            return data.reasonIDList.indexOf(row.id) > -1;
                        });

                        if (checkedList && checkedList.length > 0) {
                            checkedList.forEach(function (row) {
                                row.checked = true;
                            });
                        }
                    }
                }

                return data;
            },

            // 编辑发票修改
            editCheckInvoice: function (model) {
                if (!model.reasonList || model.reasonList.length === 0) {
                    return $translate.instant('ReasonRequire');
                }

                if (!model.subtotalforFinalPayment) {
                    return $translate.instant('SubtotalforFinalPaymentRequire');
                }

                return null;
            },

            // 首次设置价格
            firstSetPrice: function (data) {
                if (data.vatTax === null || data.excludeTaxPrice === null) {
                    data = this.setPrice(data);
                }

                return data;
            },

            addControlsInit: function () {

                var selectedTaxControlId = null;
                if (thisService.OwnerOrgModel && thisService.OwnerOrgModel.taxControlDiskList && thisService.OwnerOrgModel.taxControlDiskList.length === 1) {
                    $scope.editModel.taxControlDisk = thisService.OwnerOrgModel.taxControlDiskList[0];
                    selectedTaxControlId = thisService.OwnerOrgModel.taxControlDiskList[0].id;
                }



                $scope.textBoxOption = {
                    registrationLocalNameOpt: {
                        bindingOptions: {
                            value: 'editModel.registrationLocalName',
                        },
                        maxLength: 100,
                        placeholder: $translate.instant('RegistrationLocalNamePlaceholder')
                    },
                    buyerCodeOpt: {
                        bindingOptions: {
                            value: 'editModel.buyerIDOrCode',
                        },
                        maxLength: 100,
                        placeholder: $translate.instant('BuyerCodePlaceholder')
                    },
                    companyVATIDTaxIDOpt: {
                        bindingOptions: {
                            value: 'editModel.companyVATIDTaxID',
                        },
                        maxLength: 50,
                        placeholder: $translate.instant('CompanyVATIDTaxIDPlaceholder')
                    },
                    governmentClassificationOpt: {
                        dataSource:constant.CarType,
                        bindingOptions: {
                            value: 'editModel.governmentClassification',
                        },
                    },
                    brandandModelNumberOpt: {
                        bindingOptions: {
                            value: 'editModel.brandandModelNumber',
                        },
                        maxLength: 50,
                        placeholder: $translate.instant('BrandandModelNumberPlaceholder')
                    },
                    producingPlaceOpt: {
                        bindingOptions: {
                            value: 'editModel.producingPlace',
                        },
                        maxLength: 20,
                        placeholder: $translate.instant('ProducingPlacePlaceholder')
                    },
                    certificateNumberOpt: {
                        bindingOptions: {
                            value: 'editModel.certificateNumber',
                        },
                        maxLength: 50,
                        placeholder: $translate.instant('CertificateNumberPlaceholder')
                    },
                    importCertificateNumberOpt: {
                        bindingOptions: {
                            value: 'editModel.importCertificateNumber',
                        },
                        maxLength: 50,
                        placeholder: $translate.instant('ImportCertificateNumberPlaceholder')
                    },
                    ciqNumberOpt: {
                        bindingOptions: {
                            value: 'editModel.ciqNumber',
                        },
                        maxLength: 50,
                        placeholder: $translate.instant('CiqNumberPlaceholder')
                    },
                    motorNumberOpt: {
                        bindingOptions: {
                            value: 'editModel.motorNumber',
                        },
                        maxLength: 50,
                        placeholder: $translate.instant('MotorNumberPlaceholder')
                    },
                    vinOpt: {
                        bindingOptions: {
                            value: 'editModel.vin',
                        },
                        maxLength: 50,
                        placeholder: $translate.instant('VinPlaceholder')
                    },
                    subtotalforFinalPaymentCHOpt: {
                        bindingOptions: {
                            value: 'editModel.subtotalforFinalPaymentCH',
                        },
                        readOnly: true
                    },
                    subtotalforFinalPaymentOpt: {
                        bindingOptions: {
                            value: 'editModel.subtotalforFinalPayment',
                        },
                        valueChangeEvent: "keyup",
                        maxLength: 20,
                        placeholder: $translate.instant('SubtotalforFinalPaymentPlaceholder'),
                        onValueChanged: function (e) {
                            $scope.editModel.subtotalforFinalPayment = e.value;
                            thisService.changeSubtotalforFinalPayment();
                        }
                    },
                    salesUnitNameOpt: {
                        bindingOptions: {
                            value: 'editModel.salesUnitName',
                        },
                        readOnly: true
                    },
                    salesUnitPhoneNumberOpt: {
                        bindingOptions: {
                            value: 'editModel.salesUnitPhoneNumber',
                        },
                        readOnly: true
                    },
                    salesTaxPayerNumberOpt: {
                        bindingOptions: {
                            value: 'editModel.salesTaxPayerNumber',
                        },
                        readOnly: true
                    },
                    salesAccountOpt: {
                        bindingOptions: {
                            value: 'editModel.salesAccount',
                        },
                        readOnly: true
                    },
                    salesAddressOpt: {
                        bindingOptions: {
                            value: 'editModel.salesAddress',
                        },
                        readOnly: true
                    },
                    salesBankNameOpt: {
                        bindingOptions: {
                            value: 'editModel.salesBankName',
                        },
                        readOnly: true
                    },
                    vatRateorLevyRateOpt: {
                        bindingOptions: {
                            value: 'editModel.vatRateorLevyRate',
                        },
                        height: 44,
                        readOnly: true
                    },
                    vatTaxOpt: {
                        bindingOptions: {
                            value: 'editModel.vatTax',
                        },
                        height: 44,
                        readOnly: true
                    },
                    excludeTaxPriceOpt: {
                        bindingOptions: {
                            value: 'editModel.excludeTaxPrice',
                        },
                        readOnly: true
                    },
                    tonnageOpt: {
                        bindingOptions: {
                            value: 'editModel.tonnage',
                        },
                        maxLength: 10,
                        placeholder: $translate.instant('TonnagePlaceholder')
                    },
                    capacityOpt: {
                        bindingOptions: {
                            value: 'editModel.capacity',
                        },
                        maxLength: 10,
                        valueChangeEvent: "keyup",
                        // placeholder:$translate.instant('CapacityPlaceholder'),
                        onValueChanged: function (e) {
                            $scope.editModel.capacity = e.value.replace(/[^\d]/g, "");
                        }
                    },
                    selectTaxControlDiskOptions: {
                        bindingOptions: {
                            dataSource: 'editModel.taxControlDiskList',
                            value: 'editModel.taxControlDisk.id',
                        },
                        //dataSource: thisService.OwnerOrgModel.taxControlDiskList,
                        onSelectionChanged: function (args) {
                            $scope.editModel.taxControlDisk = args.selectedItem;
                             
                        },
                        itemTemplate: function (itemData, itemIndex, itemElement) {
                            var span = $('<span title="' + itemData.name + '">').text(itemData.name);
                            itemElement.append(span);
                        },
                        noDataText: $translate.instant('NoDataText'),
                        valueExpr: 'id',
                        displayExpr: 'name'
                    },

                };

                $scope.validateOption = {
                    registrationLocalNameOpt: {
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('RegistrationLocalNameRequire')
                        }]
                    },
                    buyerCodeOpt: {
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('BuyerCodePlaceholder')
                        },
                         {
                             type: 'stringLength',
                             min: 18, max: 18,
                             message: $translate.instant('LengthNotEqual') + '&nbsp;18'
                         },
                        {
                            type: "pattern",
                            pattern: '^[a-zA-Z0-9]+$',
                            message: $translate.instant('NotLetterAndNumber')
                        },
                        //{
                        //    type: "custom",
                        //    validationCallback: function (options) {
                        //        //表示目前的值是组织机构代码
                        //        if ($scope.editModel.companyVATIDTaxID) {
                        //            return true;
                        //        }
                        //        //身份证号码
                        //        var data = options.value;
                        //        var r = cardValidationService.CardCheck(data);
                        //        options.rule.message = r.message;
                        //        return r.pass;
                        //    }
                        //}
                        ]
                    },
                    companyVATIDTaxIDOpt: {
                        validationRules: [
                        //    {
                        //    type: "required",
                        //    message: $translate.instant('CompanyVATIDTaxIDRequire')
                        //},
                        //{
                        //    type: 'stringLength',
                        //    min: 18, max: 18,
                        //    message: $translate.instant('LengthNotEqual') + '&nbsp;18'
                        //},
                        //{
                        //    type: "pattern",
                        //    pattern: '^[a-zA-Z0-9]+$',
                        //    message: $translate.instant('NotLetterAndNumber')
                        //},
                        {
                            type: "custom",
                            message: $translate.instant('OrgCompanyIDNotEqual'),
                            validationCallback: function (options) {
                                var data = options.value;
                                if (data !== null && data !== undefined && data !== '') {
                                    if (data !== $scope.editModel.buyerIDOrCode) {
                                        options.rule.message = $translate.instant('OrgCompanyIDNotEqual');
                                        return false;
                                    }

                                }
                                return true;
                            }
                        }]
                    },
                    governmentClassificationOpt: {
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('GovernmentClassificationRequire')
                        }]
                    },
                    brandandModelNumberOpt: {
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('BrandandModelNumberRequire')
                        }]
                    },
                    producingPlaceOpt: {
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('ProducingPlaceRequire')
                        }]
                    },
                    certificateNumberOpt: {
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('CertificateNumberRequire')
                        }]
                    },
                    importCertificateNumberOpt: {
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('ImportCertificateNumberRequire')
                        },
                         {
                             type: 'stringLength',
                             min: 12, max: 12,
                             message: $translate.instant('LengthNotEqual') + '&nbsp;12'
                         },
                        {
                            type: "pattern",
                            pattern: '^[a-zA-Z0-9]+$',
                            message: $translate.instant('NotLetterAndNumber')
                        }
                        ]
                    },
                    ciqNumberOpt: {
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('CiqNumberRequire')
                        },
                         {
                             type: 'stringLength',
                             min: 9, max: 9,
                             message: $translate.instant('LengthNotEqual') + '&nbsp;9'
                         },
                        {
                            type: "pattern",
                            pattern: '^[a-zA-Z0-9]+$',
                            message: $translate.instant('NotLetterAndNumber')
                        }]
                    },
                    motorNumberOpt: {
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('MotorNumberRequire')
                        }]
                    },
                    vinOpt: {
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('VinRequire')
                        },
                         {
                             type: 'stringLength',
                             min: 17, max: 17,
                             message: $translate.instant('LengthNotEqual') + '&nbsp;17'
                         },
                        {
                            type: "pattern",
                            pattern: '^[a-zA-Z0-9]+$',
                            message: $translate.instant('NotLetterAndNumber')
                        }]
                    },
                    subtotalforFinalPaymentOpt: {
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('SubtotalforFinalPaymentRequire')
                        }
                        ]
                    },
                    tonnageOpt: {
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('TonnageRequire')
                        }]
                    },
                    capacityOpt: {
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('CapacityRequire')
                        }]
                    },
                    selectTaxControlDiskOptions: {
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('TaxControlDiskRequire')
                        }]
                    }

                };

            },

            parseDbModel: function (model) {
                if (!model.vehicleModel) {
                    //model.vehicleModel = model.governmentClassification;
                }

                if (!model.cabinConfiguration) {
                    var temp = window.PWC.convertChineseSimple(model.capacity);
                    model.cabinConfiguration = temp + "座座椅布局";
                }

                return model;
            },

            // 打开弹出框
            open: function () {
                var editModel = {};


                thisService.isChanged = false;

                if (this.testEditModel) {
                    editModel = thisService.testEditModel;


                }

                $scope.showCancelRemark = false;
                if ($scope.invoiceModel) {
                    thisService.setPrice($scope.invoiceModel);

                    if ($scope.isReadOnly) {

                        if ($scope.invoiceModel.bdStatus === 5) {
                            $scope.showCancelRemark = true;
                        }

                        if ($scope.invoiceModel.bdStatus === 'Cancelled') {
                            $scope.showCancelRemark = true;
                        }
                    }
                    $scope.editModel = $scope.invoiceModel;
                    if (!$scope.editModel.buyerIDOrCode) {
                        $scope.editModel.buyerIDOrCode = thisService.getBuyerInfo($scope.invoiceModel);
                    }

                    if ($scope.editModel.bdIssuedDate) {
                        $scope.editModel.bdIssuedDate = new Date($scope.editModel.bdIssuedDate).formatDateTime('yyyy-MM-dd');
                    }

                } else {
                    $scope.editModel = editModel;
                }

                //editModel.historyReasonList = thisService.reasonList;
                if (thisService.OutputInvoiceUpdateReasonList && thisService.OutputInvoiceUpdateReasonList.length > 0) {
                    $scope.editModel.historyReasonList = _.filter(thisService.OutputInvoiceUpdateReasonList, function (row) {
                        return row.type === constant.OutputInvoiceReasonType.EditInvoiceReason;
                    });

                    $scope.editModel.historyReasonList = angular.copy($scope.editModel.historyReasonList);

                    thisService.firstSetPrice($scope.editModel);
                    // $scope.invoiceModel.checked
                } else {
                    vatOutputInvoiceManageService.getAllOutputInvoiceUpdateReasonList().success(function (data) {

                        thisService.OutputInvoiceUpdateReasonList = data;
                        $scope.editModel.historyReasonList = _.filter(thisService.OutputInvoiceUpdateReasonList, function (row) {
                            return row.type === constant.OutputInvoiceReasonType.EditInvoiceReason;
                        });

                        $scope.editModel.historyReasonList = angular.copy($scope.editModel.historyReasonList);

                        thisService.firstSetPrice($scope.editModel);
                    });
                }

                var modalInstance = $uibModal.open({
                    animation: true,
                    backdrop: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'editInvoiceModal.html',
                    windowClass: 'edit-invoice-modal-wrapper',
                    scope: $scope,
                    size: 'size',
                    resolve: {
                        editModel: $scope.editModel
                    }
                });

                modalInstance.result.then(function (data) {
                    // $scope.templateModel = data;
                    $scope.isUpdate = true;
                    $scope.isReadOnly = true;
                    $scope.isQueryOnly = false;

                    $scope.operateType = null;
                }, function () {
                    $scope.operateType = null;
                    $scope.isReadOnly = true;
                    $scope.isUpdate = false;
                    $scope.isQueryOnly = false;
                    // $scope.onClosed({ param: {} });
                    // 如果修改了，数据，点取消之后，数据应该同步
                    if (thisService.isChanged && $scope.onChanged) {
                        $scope.onChanged({ param: {} });
                    }

                    $log.info('Modal dismissed at: ' + new Date());
                });


                var saveData = function (model) {

                    vatOutputInvoiceManageService.addOutputInvoicePrinted(model, true).success(function (ret) {

                        if (ret.result) {
                            $scope.isUpdate = true;
                            $scope.operateType = null;
                            $scope.isReadOnly = true;
                            // SweetAlert.success($translate.instant('SaveSuccess'));
                            modalInstance.close(model);
                            $scope.onClosed({ param: model });
                        } else {
                            swal($translate.instant('SaveFail'), $translate.instant('SaveFail'), 'warning');
                        }

                    });
                };

                // 打印
                $scope.save = function () {

                    var model = $scope.editModel;

                    // 选中的理由
                    model.reasonList = _.filter(model.historyReasonList, function (row) {
                        return row.checked;
                    });

                    var checkResult = thisService.editCheckInvoice(model);

                    if (checkResult) {
                        swal($translate.instant('SaveFail'), checkResult, 'warning');
                        return;
                    }

                    model = thisService.parseDbModel(model);
                    saveData(model);
                };

                $scope.saveUpdate = function () {

                    var model = $scope.editModel;

                    // 选中的理由
                    model.reasonList = _.filter(model.historyReasonList, function (row) {
                        return row.checked;
                    });

                    var checkResult = thisService.editCheckInvoice(model);

                    if (checkResult) {
                        swal($translate.instant('SaveFail'), checkResult, 'warning');
                        return;
                    }

                    model.id = model.editInvoiceId;

                    model = thisService.parseDbModel(model);

                    vatOutputInvoiceManageService.updateOutputInvoiceEdit(model).success(function (ret) {
                        if (ret.result) {
                            SweetAlert.success($translate.instant('SaveSuccess'));
                            $scope.isReadOnly = true;

                            thisService.isChanged = true;

                            // 保持成功修改后添加历史记录
                            $scope.saveEditInvoiceHistory();

                        } else {
                            swal($translate.instant('SaveFail'), $translate.instant('SaveFail'), 'warning');
                        }
                    });
                };

                // 取消
                $scope.cancel = function () {
                    modalInstance.dismiss('cancel');
                };

                // 设置entity info
                var setEntityInfo = function (data) {
                    $scope.editModel.salesUnitName = data.name;
                    $scope.editModel.salesUnitPhoneNumber = data.phoneNumber;
                    $scope.editModel.salesTaxPayerNumber = data.taxPayerNumber;
                    $scope.editModel.salesAccount = data.bankAccountNumber;
                    $scope.editModel.salesAddress = data.manufactureAddress;
                    $scope.editModel.salesBankName = data.bankAccountName;
                    $scope.editModel.salesOrgID = data.id;
                    $scope.editModel.taxControlDisk = {};
                    if (data.taxControlDiskList && data.taxControlDiskList.length > 0) {
                        data.taxControlDiskList.forEach(function (row) {

                            row.name = row.taxControlDiskSerialNumber + row.taxControlDiskDescribe;
                        });

                        if (data.taxControlDiskList.length === 1) {
                            $scope.editModel.taxControlDisk = data.taxControlDiskList[0];
                        }
                    }

                    $scope.editModel.taxControlDiskList = data.taxControlDiskList;

                };

                if ($scope.editModel.salesUnitName) {
                    var obj = _.find($scope.editModel.sameVehicleroutinglocationList, function (row) {
                        return row.name === $scope.editModel.salesUnitName;
                    });

                    if (obj) {
                        $scope.editModel.salesOrgID = obj.id;
                    }
                }

                if ($scope.editModel.sameVehicleroutinglocationList && $scope.editModel.sameVehicleroutinglocationList.length > 0) {

                    $timeout(function () {

                        $('#' + thisService.selectEntityList_ID).dxSelectBox({
                            dataSource: $scope.editModel.sameVehicleroutinglocationList,
                            valueExpr: 'id',
                            value: $scope.invoiceModel.salesOrgID,
                            displayExpr: 'name',
                            onSelectionChanged: function (args) {
                                setEntityInfo(args.selectedItem);
                            }
                        });

                    }, 50);

                }

            },

            // 手动添加发票弹出框
            addInvoiceModalDialog: function () {
                thisService.addControlsInit();


                var editModel = {
                    registrationLocalName: '',
                    companyVATIDTaxID: '',
                    governmentClassification: '',
                    brandandModelNumber: '',
                    producingPlace: '美国',
                    certificateNumber: '无',
                    importCertificateNumber: '',
                    ciqNumber: '',
                    motorNumber: '',
                    vin: '',
                    subtotalforFinalPaymentCH: '',
                    subtotalforFinalPayment: '',
                    invoiceCode: '',
                    invoiceNumber: '',
                    salesUnitName: '',
                    salesUnitPhoneNumber: '',
                    salesTaxPayerNumber: '',
                    salesAccount: '',
                    salesAddress: '',
                    salesBankName: '',
                    vatRateorLevyRate: '17%',
                    taxableSubtotal: 0.00,
                    mainTaxAuthoritiesCode: '',
                    excludeTaxPrice: 0,
                    taxPaymentCertificateNumber: '',

                    // 吨位
                    tonnage: '无',

                    // 限乘人数
                    capacity: '',

                    // 生产企业名称
                    manufacturer: '拓速乐佛利蒙总装厂'
                };

                //editModel.historyReasonList = thisService.reasonList;

                // thisService.setPrice(editModel);

                $scope.editModel = editModel;
                $scope.editModel.buyerInfo = thisService.getBuyerInfo($scope.editModel);

                if (thisService.OutputInvoiceUpdateReasonList && thisService.OutputInvoiceUpdateReasonList.length > 0) {
                    var reasonListTemp = _.filter(thisService.OutputInvoiceUpdateReasonList, function (row) {
                        return row.type === constant.OutputInvoiceReasonType.ManualInvoiceReason;
                    });

                    $scope.editModel.historyReasonList = angular.copy(reasonListTemp);

                } else {
                    vatOutputInvoiceManageService.getAllOutputInvoiceUpdateReasonList().success(function (data) {

                        thisService.OutputInvoiceUpdateReasonList = data;
                        var reasonListTemp = _.filter(thisService.OutputInvoiceUpdateReasonList, function (row) {
                            return row.type === constant.OutputInvoiceReasonType.ManualInvoiceReason;
                        });

                        $scope.editModel.historyReasonList = angular.copy(reasonListTemp);
                    });
                }

                var modalInstance = $uibModal.open({
                    animation: true,
                    backdrop: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'addInvoiceModal.html',
                    windowClass: 'edit-invoice-modal-wrapper',
                    scope: $scope,
                    size: 'add',
                    resolve: {
                        editModel: editModel
                    }
                });

                modalInstance.result.then(function (data) {
                    // $scope.templateModel = data;
                    $scope.isUpdate = true;
                    $scope.isReadOnly = true;
                    // $scope.onClosed({ model: data });
                    $scope.operateType = null;
                }, function () {
                    $scope.operateType = null;
                    $scope.isReadOnly = true;
                    $scope.isUpdate = false;
                    $log.info('Modal dismissed at: ' + new Date());
                });


                var saveData = function (model) {

                    vatOutputInvoiceManageService.addOutputInvoicePrinted(model, true).success(function (ret) {

                        if (ret.result) {
                            $scope.isUpdate = true;
                            $scope.operateType = null;
                            SweetAlert.success($translate.instant('SaveSuccess'));
                            modalInstance.close(model);

                            $state.go('outputInvoiceManage.issuedInvoiceBdView');
                            //$scope.onClosed({ param: model });

                        } else {
                            swal($translate.instant('SaveFail'), $translate.instant('SaveFail'), 'warning');
                        }

                    });
                };


                $scope.checkReasonChanged = function () {

                    $scope.editModel.reasonList = _.filter($scope.editModel.historyReasonList, function (row) {
                        return row.id === $scope.editModel.selectReasonID;
                    });

                    if (!$scope.editModel.reasonList || $scope.editModel.reasonList.length === 0) {
                        $scope.editModel.historyReasonListError = $translate.instant('ManualReasonRequire');
                        return;
                    } else {
                        $scope.editModel.historyReasonListError = null;
                    }

                };

                // 保存
                $scope.save = function (params) {
                    var model = $scope.editModel;
                    // 选中的理由

                    $scope.checkReasonChanged();
                    var dxResult = DevExpress.validationEngine.validateGroup($('#addInvoiceModalForm').dxValidationGroup("instance")).isValid;
                    var specialValid = true;
                    //表示目前的值是组织机构代码
                    if (!$scope.editModel.companyVATIDTaxID) {
                        //身份证号码
                        // var data = options.value;
                        var r = cardValidationService.CardCheck($scope.editModel.buyerIDOrCode);
                        var IDCard = $("#buyer-code").dxTextBox('instance');
                        IDCard.option("isValid", r.pass);
                        IDCard.option("validationError", { message: r.message });
                        specialValid = r.pass;
                    }
                    else {
                        //表示不是身份证，需要验证2个是否相等
                        var company = $("#company-taxID").dxTextBox('instance');
                        if ($scope.editModel.companyVATIDTaxID !== $scope.editModel.buyerIDOrCode) {
                            company.option("isValid", false);
                            company.option("validationError", { message: $translate.instant('OrgCompanyIDNotEqual') });
                            specialValid = false;
                        }
                        else {
                            company.option("isValid", true);
                            company.option("validationError", { message: '' });
                        }
                    }

                    if (!dxResult || $scope.editModel.historyReasonListError !== null || !specialValid) {
                        return;
                    }

                   $scope.invoiceConfirmModel = {
                        type:1,
                        taxControlDiskID:$scope.editModel.taxControlDisk.id,
                   };
                   $scope.invoiceConfirmType = constant.Operation.Open;
                   model = thisService.parseDbModel(model);

                   $scope.invoiceConfirmFunction = function(param){
                      saveData(model);
                   };
                    
                };

                // 取消
                $scope.cancel = function () {
                    modalInstance.dismiss('cancel');
                };

                // 设置entity info
                var setEntityInfo = function (data) {
                    $scope.editModel.salesUnitName = data.name;
                    $scope.editModel.salesUnitPhoneNumber = data.phoneNumber;
                    $scope.editModel.salesTaxPayerNumber = data.taxPayerNumber;
                    $scope.editModel.salesAccount = data.bankAccountNumber;
                    $scope.editModel.salesAddress = data.manufactureAddress;
                    $scope.editModel.salesBankName = data.bankAccountName;
                    $scope.editModel.vehicleroutinglocation = data.vehicleroutinglocation;
                    $scope.editModel.salesOrgID = data.id;
                    $scope.editModel.taxControlDisk = {};

                    if (data.taxControlDiskList && data.taxControlDiskList.length > 0) {
                        data.taxControlDiskList.forEach(function (row) {

                            row.name = row.taxControlDiskSerialNumber + row.taxControlDiskDescribe;
                        });

                        if (data.taxControlDiskList.length === 1) {
                            $scope.editModel.taxControlDisk = data.taxControlDiskList[0];
                        }
                    }

                    $scope.editModel.taxControlDiskList = data.taxControlDiskList;
                };

                $timeout(function () {

                    setEntityInfo(thisService.OwnerOrgModel);
                    $scope.editModel.sameVehicleroutinglocationList = thisService.OwnerOrgModel.sameVehicleroutinglocationList;

                    if ($scope.editModel.sameVehicleroutinglocationList && $scope.editModel.sameVehicleroutinglocationList.length > 0) {
                        $('#' + thisService.select_ADD_EntityList_ID).dxSelectBox({
                            dataSource: $scope.editModel.sameVehicleroutinglocationList,
                            valueExpr: 'id',
                            value: $scope.editModel.salesOrgID,
                            displayExpr: 'name',
                            onSelectionChanged: function (args) {
                                setEntityInfo(args.selectedItem);
                            }
                        });
                    }

                }, 50);
            },

            // 验证输入的发票信息
            checkInputInvoice: function (data) {
                if (!data.registrationLocalName) {

                    data.registrationLocalNameHasError = true;
                    return $translate.instant('RegistrationLocalNameRequire');
                } else {
                    data.registrationLocalNameHasError = false;
                }

                if (!data.companyVATIDTaxID) {
                    data.companyVATIDTaxIDHasError = true;
                    return $translate.instant('CompanyVATIDTaxIDRequire');
                } else {
                    data.companyVATIDTaxIDHasError = false;
                }

                if (!data.governmentClassification) {
                    return $translate.instant('GovernmentClassificationRequire');
                }

                if (!data.brandandModelNumber) {
                    return $translate.instant('BrandandModelNumberRequire');
                }


                if (!data.producingPlace) {
                    return $translate.instant('ProducingPlaceRequire');
                }


                if (!data.certificateNumber) {
                    return $translate.instant('CertificateNumberRequire');
                }

                if (!data.importCertificateNumber) {
                    return $translate.instant('ImportCertificateNumberRequire');
                }

                if (!data.ciqNumber) {
                    return $translate.instant('CiqNumberRequire');
                }


                if (!data.motorNumber) {
                    return $translate.instant('MotorNumberRequire');
                }


                if (!data.vin) {
                    return $translate.instant('VinRequire');
                }

                if (!data.subtotalforFinalPayment) {
                    return $translate.instant('SubtotalforFinalPaymentRequire');
                }


                if (!data.tonnage) {
                    return $translate.instant('TonnageRequire');
                }


                if (!data.capacity) {
                    return $translate.instant('CapacityRequire');
                }

                return null;

            },

            // 查看发票
            showInvoiceDialog: function () {

                var editModel = {};

                if ($scope.invoiceModel) {
                    $scope.editModel = $scope.invoiceModel;
                    thisService.setPrice($scope.invoiceModel);
                    $scope.editModel.buyerInfo = thisService.getBuyerInfo($scope.invoiceModel);

                } else {
                    $scope.editModel = editModel;
                }

                var modalInstance = $uibModal.open({
                    animation: true,
                    backdrop: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'queryInvoiceModal.html',
                    windowClass: 'edit-invoice-modal-wrapper',
                    scope: $scope,
                    size: 'show',
                    resolve: {
                        editModel: editModel
                    }
                });

                modalInstance.result.then(function (data) {
                    // $scope.templateModel = data;
                    $scope.isUpdate = true;
                    $scope.isReadOnly = true;
                    // $scope.onClosed({ model: data });
                    $scope.operateType = null;
                }, function () {
                    $scope.operateType = null;
                    $scope.isReadOnly = true;
                    $scope.isUpdate = false;
                    $log.info('Modal dismissed at: ' + new Date());
                });

                // 取消
                $scope.cancel = function () {
                    modalInstance.dismiss('cancel');
                };
            },

            // 进入编辑状态
            updateStatus: function () {

                $scope.isReadOnly = false;
            },

            // 验证输入金额
            // 小写金额 自动转大写
            changeSubtotalforFinalPayment: function () {

                var value = $scope.editModel.subtotalforFinalPayment;

                value = thisService.limitTwoDigital(value);

                if (value != $scope.editModel.subtotalforFinalPayment) {
                    $scope.editModel.subtotalforFinalPayment = value;
                }

                if (value) {

                    var temp = parseFloat(value);
                    if (temp > thisService.MaxPrice) {
                        value = value.substr(0, value.length - 1);
                        $scope.editModel.subtotalforFinalPayment = value;
                    }
                }

                if (value) {
                    $scope.editModel.subtotalforFinalPaymentCH = window.PWC.convertChineseCurrency(value);
                } else {
                    $scope.editModel.subtotalforFinalPaymentCH = '';
                }

                thisService.setPrice($scope.editModel);
            },

            getUserOwnerOrganization: function () {
                userService.getUserOwnerOrganization().success(function (data) {
                    if (data) {
                        if (data.taxControlDiskList && data.taxControlDiskList.length > 0) {
                            data.taxControlDiskList.forEach(function (row) {

                                row.name = row.taxControlDiskSerialNumber + row.taxControlDiskDescribe;
                            });
                        }
                    }

                    thisService.OwnerOrgModel = data;
                });
            }
        };

        var historyService = {
            main: function () {
                //显示手工导入数据历史记录
                $scope.openEditInvoiceHistory = function (event) {
                    $('#history-pop-container').css({ 'top': 120 + 'px', 'left': -90 + 'px' }).show(500);
                };

                //关闭手工导入数据历史记录
                $scope.closeEditInvoiceHistory = function () {
                    var model = $scope.invoiceModel;
                    $('#history-pop-container').hide(500);
                };

                //toggle手工导入数据历史记录
                $scope.toggleEditInvoiceHistory = function () {
                    $('#history-pop-container').css({ 'top': 120 + 'px', 'left': -90 + 'px' }).toggle(500);
                };

                //获取手工导入数据历史记录
                var getEditInvoiceHistory = function () {
                    if ($scope.editModel && $scope.editModel.editInvoiceId) {
                        vatOutputInvoiceManageService.getOutputInvoiceEditHistory($scope.editModel.editInvoiceId).success(function (result) {
                            if (result && result.length > 0) {
                                _.each(result, function (item) {
                                    item.createTime = (new Date(item.createTime)).dateTimeToString('yyyyMMdd hh:mm');
                                    if (item.amount) {
                                        item.amount = item.amount.formatAmount(2);
                                    }
                                });
                                $scope.syncHistoryList = result;
                            } else {
                                $scope.syncHistoryList = [];
                            }
                        });
                    }
                };

                $scope.$watch('editModel.editInvoiceId', function () {
                    getEditInvoiceHistory();
                });

                $scope.$watch('editModel', function () {
                    if ($scope.editModel) {
                        $scope.manufacturerOrg = $scope.editModel.manufacturer;
                        $scope.salesUnitNameOrg = $scope.editModel.salesUnitName;
                    }
                });

                $scope.saveEditInvoiceHistory = function () {
                    //保存手工编辑发票的历史记录
                    var historyModel = {};
                    historyModel.outputInvoiceID = $scope.editModel.editInvoiceId;
                    historyModel.amount = $scope.editModel.subtotalforFinalPayment;
                    historyModel.createBy = loginContext.userName;
                    _.each($scope.editModel.historyReasonList, function (item) {
                        if (item.checked) {

                            if (historyModel.englishReasons) {
                                historyModel.reasonIDs += ',' + item.id;
                                historyModel.englishReasons += '|' + item.englishName;
                                historyModel.chineseReasons += '|' + item.chineseName;
                            } else {
                                historyModel.reasonIDs = item.id;
                                historyModel.englishReasons = item.englishName;
                                historyModel.chineseReasons = item.chineseName;
                            }

                            historyModel.manufacturer = '';
                            historyModel.issuingEntity = '';
                            if ($scope.manufacturerOrg != $scope.editModel.manufacturer) {
                                historyModel.manufacturer = $scope.editModel.manufacturer;
                            }
                            if ($scope.salesUnitNameOrg != $scope.editModel.salesUnitName) {
                                historyModel.issuingEntity = $scope.editModel.salesUnitName;
                            }
                        }
                    });
                    //添加手工修改数据的历史记录
                    vatOutputInvoiceManageService.addOutputInvoiceEditHistory(historyModel).success(function () {
                        $scope.manufacturerOrg = $scope.editModel.manufacturer;
                        $scope.salesUnitNameOrg = $scope.editModel.salesUnitName;
                        getEditInvoiceHistory();
                    });
                };
            }
        };

        (function () {
            thisService.main();
            historyService.main();
        })();

    }
]);