﻿commonModule.controller('importATController', ['$scope', '$log', '$translate', '$timeout', '$q', '$interval'
    , 'apiInterceptor', 'Upload', 'vatImportService', 'SweetAlert', 'uiGridConstants', '$uibModal'
    , 'vatSessionService', 'enums', 'vatOperationLogService'
    , 'projectService', 'vatCommonService','orgService','templateService',
    function ($scope, $log, $translate, $timeout, $q, $interval
        , apiInterceptor, Upload, vatImportService, SweetAlert, uiGridConstants, $uibModal
        , vatSessionService, enums, vatOperationLogService
        , projectService, vatCommonService , orgService,templateService) {
        'use strict';

        var successCount = 0;
        var uploadUrl = apiInterceptor.vatWebApiHostUrl + '/FileUpload/NewFile';
        var resumable = true;
        var comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年" + vatSessionService.month + "月";
        var servicePeriods = [];
        $scope.period = $scope.periodId;
        $scope.moduleid = enums.vatModuleEnum.Import_TrialBalance;
        $scope.chunkSize = 100000;
        $scope.success = false;      
        $scope.showErrorTable = false;
        $scope.showInitTable = false;
        $scope.showImportTable = false;
        $scope.isSelectPeriod = true;
        $scope.isShowImportTotalBtn = true;
        $scope.projectID = vatSessionService.project.id;
        $scope.startRowNum = 2;
        $scope.validationType = 0;
        $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
        $scope.sheetInfo = { selectedSheetName: '', selectedSheetIndex: 0 };
        $scope.balanceInputList = [];
        $scope.toInputList = [];
        $scope.importEnum = { Import: 0, CoverImport: 1, AddImport: 2 }; //导入方式
        $scope.selectedPeriod = null;
        $scope.showTotalSecondRow = false;
        $scope.maxTitleLength = constant.maxButtonTitleLength;

        $scope.companyList = [];
        $scope.checkedCompanyList = [];
        $scope.checkedCompanyCodeList = [];
        $scope.checkedCompanyTypeList = "";

        $scope.importATExcelFile = apiInterceptor.webApiHostUrl + '/DataImport/ATExcelFile';

        var date = new Date();
        var year = date.getFullYear();
        var month = date.getMonth();
        $scope.selectedDate = new Date(vatSessionService.year, vatSessionService.month - 1, 1);
        $scope.startDate = new Date(year - 20, 1, 1);
        $scope.endDate = new Date(year + 20, 1, 1);
        $scope.viewMode = 1;
        $scope.dateFormat = $translate.instant('dateFormat4YearMonth');

        $scope.importExcelFile = null;
        $scope.UploadPeriodTime = null;



        //写日志
        var logDto = {
            ID: '',
            OperationName: '',
            ModuleID: $scope.moduleid,
            OperationObject: $translate.instant('redLetterInformationTable'),
            OperationType: '',
            OperationContent: '',
            OriginalState: '',
            UpdateState: '',
            CreatorID: vatSessionService.logUser.ID,
            Comment: comment,
            IP: '',
            Period: $scope.period,
        };

        //初始化ack-pagination
        $scope.pagingOptions = {
            pageIndex: 1, //当前页码
            totalItems: 0, //总数据
            totalPages: 10, //总页数
            maxSize: 5, //分页数字的限制。
            pageSize: constant.page.pageSizeArrary[3], //每页多少条数据,100条
            pageSizeString: constant.page.pageSizeArrary[3].toString(),
            firstPage: $translate.instant('PagingFirstPage'),
            previousPage: $translate.instant('PagingPreviousPage'),
            nextPage: $translate.instant('PagingNextPage'),
            lastPage: $translate.instant('PagingLastPage'),
        };

        //初始化查询参数
        $scope.queryParams = {
            pageInfo: {
                totalCount: 0,
                pageIndex: 0,
                pageSize: 0,
                totalPage: 0,
            },
            periodId: $scope.period,
            serviceTypeId: $scope.serviceTypeId,
            projectId: $scope.projectID
        };


        $scope.totalData = {
            totalNumber: 0,
            begDebitTotal: 0,
            begCreditTotal: 0,
            endDebitTotal: 0,
            endCreditTotal: 0,
            begBalTotal: 0,
            endBalTotal: 0,
            debitTotal: 0,
            creditTotal: 0,
        };

        //分页获取数据
        $scope.eventService = {
            refreshInvoiceDataGrid: function () {
                $log.debug("refreshInvoiceDataGrid");
            }
        };

        //转换没有选中的列值
        var undefinedStringToNull = function (i, stringName) {
            var data = $scope.sheetData.dataList[i][$.inArray($translate.instant(stringName), $scope.selectedMappingList)];
            if (_.isUndefined(data)) {
                return null;
            }
            else {
                if (PWC.isNullOrEmpty(data)) {
                    return "";
                }
                else {
                    return data;
                }
            }
        }


        //转换没有选中的列值
        var undefinedNumToNull = function (i, stringName) {
            var data = $scope.sheetData.dataList[i][$.inArray($translate.instant(stringName), $scope.selectedMappingList)];
            if (_.isUndefined(data)) {
                return null;
            }
            else {
                if (PWC.isNullOrEmpty(data)) {
                    return 0;
                }
                else {
                    return data;
                }
            }
        }


        //验证每行数据类型
        var valueTypeValidation = function (balanceinputlist) {
        return true; //todo:[validation] to skip data validation (neo)
            var AccountCodeOverLengthMsg = '';
            var AccountCodeNullMsg = '';
            var PeriodMsg = '';
            var BegDebitBalMsg = '';
            var BegCreditBalMsg = '';
            var DebitBalMsg = '';
            var CreditBalMsg = '';
            var EndDebitBalMsg = '';
            var EndCreditBalMsg = '';
            var BegBalMsg = '';
            var EndBalMsg = '';
            var NumlengthMsg = '';

            var AccountCodeOverLengthCount = 0;
            var AccountCodeNullCount = 0;
            var PeriodCount = 0;
            var BegDebitBalCount = 0;
            var BegCreditBalCount = 0;
            var DebitBalCount = 0;
            var CreditBalCount = 0;
            var EndDebitBalCount = 0;
            var EndCreditBalCount = 0;
            var BegBalCount = 0;
            var EndBalCount = 0;
            var NumLengthCount = 0;
            //验证前，将错误数据清空
            $scope.errorMsgMap = [];
            for (var i = 0; i < balanceinputlist.length; i++) {
                var m = balanceinputlist[i];

                if (PWC.isNullOrEmpty(m.AcctCode)) {
                    AccountCodeNullMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('AccountCodeNullMag') + '<br />';
                    AccountCodeNullCount++;
                }
                if (m.AcctCode !== null && m.AcctCode.length > 50) {
                    AccountCodeOverLengthMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('AccountCodeOverLengthMag') + '<br />';
                    AccountCodeOverLengthCount++;
                }
                if (m.MonthId !== null) {
                    if (!PWC.isInteger(m.MonthId)) {
                        PeriodMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('PeriodErrorMag') + '<br />';
                        PeriodCount++;
                    }
                    else if (PWC.isInteger(m.MonthId) && (parseInt(m.MonthId) < 1 || parseInt(m.MonthId) > 12)) {
                        NumlengthMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('PeriodId') + $translate.instant('PeriodOverLengthMsg') + '<br />';
                        NumLengthCount++;
                    }
                }

                if (m.BegDebitBal !== null) {
                    if (isNaN(parseFloat(m.BegDebitBal))) {
                        BegDebitBalMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('BegDebitBalMsg') + '<br />';
                        BegDebitBalCount++;
                    }
                    //else if (parseFloat(m.BegDebitBal) < constant.startNum || parseFloat(m.BegDebitBal) > constant.endNum) {
                    //    NumlengthMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('BegDebitBal') + $translate.instant('NumOverLengthMsg') + '<br />';
                    //    NumLengthCount++;
                    //}
                    else {
                        m.BegDebitBal = PWC.round(m.BegDebitBal, 2);
                    }


                }
                if (m.BegCreditBal !== null) {
                    if (isNaN(parseFloat(m.BegCreditBal))) {
                        BegCreditBalMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('BegCreditBalMsg') + '<br />';
                        BegCreditBalCount++;
                    }
                    //else if (parseFloat(m.BegCreditBal) < constant.startNum || parseFloat(m.BegCreditBal) > constant.endNum) {
                    //    NumlengthMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('BegCreditBal') + $translate.instant('NumOverLengthMsg') + '<br />';
                    //    NumLengthCount++;
                    //}
                    else {
                        m.BegCreditBal = PWC.round(m.BegCreditBal, 2);
                    }
                }
                if (m.DebitBal !== null) {
                    if (isNaN(parseFloat(m.DebitBal))) {
                        DebitBalMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('DebitBalMsg') + '<br />';
                        DebitBalCount++;
                    }
                    //else if (parseFloat(m.DebitBal) < constant.startNum || parseFloat(m.DebitBal) > constant.endNum) {
                    //    NumlengthMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('DebitBal') + $translate.instant('NumOverLengthMsg') + '<br />';
                    //    NumLengthCount++;
                    //}
                    else {
                        m.DebitBal = PWC.round(m.DebitBal, 2);
                    }
                }
                if (m.CreditBal !== null) {
                    if (isNaN(parseFloat(m.CreditBal))) {
                        CreditBalMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('CreditBalMsg') + '<br />';
                        CreditBalCount++;
                    }
                    //else if (parseFloat(m.CreditBal) < constant.startNum || parseFloat(m.CreditBal) > constant.endNum) {
                    //    NumlengthMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('CreditBal') + $translate.instant('NumOverLengthMsg') + '<br />';
                    //    NumLengthCount++;
                    //}
                    else {
                        m.CreditBal = PWC.round(m.CreditBal, 2);
                    }
                }
                if (m.EndDebitBal !== null) {
                    if (isNaN(parseFloat(m.EndDebitBal))) {
                        EndDebitBalMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('EndDebitBalMsg') + '<br />';
                        EndDebitBalCount++;
                    }
                    //else if (parseFloat(m.EndDebitBal) < constant.startNum || parseFloat(m.EndDebitBal) > constant.endNum) {
                    //    NumlengthMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('EndDebitBal') + $translate.instant('NumOverLengthMsg') + '<br />';
                    //    NumLengthCount++;
                    //}
                    else {
                        m.EndDebitBal = PWC.round(m.EndDebitBal, 2);
                    }
                }
                if (m.EndCreditBal !== null) {
                    if (isNaN(parseFloat(m.EndCreditBal))) {
                        EndCreditBalMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('EndCreditBalMsg') + '<br />';
                        EndCreditBalCount++;
                    }
                    //else if (parseFloat(m.EndCreditBal) < constant.startNum || parseFloat(m.EndCreditBal) > constant.endNum) {
                    //    NumlengthMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('EndCreditBal') + $translate.instant('NumOverLengthMsg') + '<br />';
                    //    NumLengthCount++;
                    //}
                    else {
                        m.EndCreditBal = PWC.round(m.EndCreditBal, 2);
                    }
                }
                if (m.BegBal !== null) {
                    if (isNaN(parseFloat(m.BegBal))) {
                        BegBalMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('BegBalMsg') + '<br />';
                        BegBalCount++;
                    }
                    //else if (parseFloat(m.BegBal) < constant.startNum || parseFloat(m.BegBal) > constant.endNum) {
                    //    NumlengthMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('BegBal') + $translate.instant('NumOverLengthMsg') + '<br />';
                    //    NumLengthCount++;
                    //}
                    else {
                        m.BegBal = PWC.round(m.BegBal, 2);
                    }
                }
                if (m.EndBal !== null) {
                    if (isNaN(parseFloat(m.EndBal))) {
                        EndBalMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('EndBalMsg') + '<br />';
                        EndBalCount++;
                    }
                    //else if (parseFloat(m.EndBal) < constant.startNum || parseFloat(m.EndBal) > constant.endNum) {
                    //    NumlengthMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('EndBal') + $translate.instant('NumOverLengthMsg') + '<br />';
                    //    NumLengthCount++;
                    //}
                    else {
                        m.EndBal = PWC.round(m.EndBal, 2);
                    }
                }
            }


            if (AccountCodeNullMsg) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('AccountCodeNullType'),
                        'errorCount': AccountCodeNullCount,
                        'errorContent': AccountCodeNullMsg
                    });
            }
            if (AccountCodeOverLengthMsg) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('AccountCodeOverLengthType'),
                        'errorCount': AccountCodeOverLengthCount,
                        'errorContent': AccountCodeOverLengthMsg
                    });
            }
            if (NumLengthCount > 0) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('NumOutRangeErrorType'),
                        'errorCount': NumLengthCount,
                        'errorContent': NumlengthMsg
                    });
            }
            if (PeriodMsg) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('PeriodErrorType'),
                        'errorCount': PeriodCount,
                        'errorContent': PeriodMsg
                    });
            }
            if (BegDebitBalMsg) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('BegDebitBalType'),
                        'errorCount': BegDebitBalCount,
                        'errorContent': BegDebitBalMsg
                    });
            }
            if (BegCreditBalMsg) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('BegCreditBalType'),
                        'errorCount': BegCreditBalCount,
                        'errorContent': BegCreditBalMsg
                    });
            }
            if (CreditBalMsg) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('CreditBalType'),
                        'errorCount': CreditBalCount,
                        'errorContent': CreditBalMsg
                    });
            }
            if (DebitBalMsg) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('DebitBalType'),
                        'errorCount': DebitBalCount,
                        'errorContent': DebitBalMsg
                    });
            }
            if (EndDebitBalMsg) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('EndDebitBalType'),
                        'errorCount': EndDebitBalCount,
                        'errorContent': EndDebitBalMsg
                    });
            }
            if (EndCreditBalMsg) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('EndCreditBalType'),
                        'errorCount': EndCreditBalCount,
                        'errorContent': EndCreditBalMsg
                    });
            }
            if (BegBalMsg) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('BegBalType'),
                        'errorCount': BegBalCount,
                        'errorContent': BegBalMsg
                    });
            }
            if (EndBalMsg) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('EndBalType'),
                        'errorCount': EndBalCount,
                        'errorContent': EndBalMsg
                    });
            }
            if ($scope.errorMsgMap.length > 0) {
                $('#errorListModal').modal('show');
                return false;
            }
            return true;
        };

        //验证是否选中了正确的列名
        var validationColumnMapping = function () {
            $scope.errorMsgMap = [];
            //0.判断选择的开始导入行是否大于实际数据行
            if (PWC.isNullOrEmpty($scope.startRowNum)) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('StartRowError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('StartRowNull')
                    });
            }
            if (parseInt($scope.startRowNum) > $scope.sheetData.dataList.length) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('StartRowError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('StartRowNumberCheckMsg')
                    });
            }
            //1.科目代码必选
            if ($scope.selectedMappingList.indexOf($translate.instant('AccountCode')) === -1) {
                //errorMsg += $translate.instant('NoAccountCode') + '\n';
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('SelectColumnError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('NoAccountCode')
                    });
            }
            //借方期初，贷方期初同时必选
            if (($scope.selectedMappingList.indexOf($translate.instant('BegDebitBal')) === -1 &&
                $scope.selectedMappingList.indexOf($translate.instant('BegCreditBal')) !== -1)
                || ($scope.selectedMappingList.indexOf($translate.instant('BegDebitBal')) !== -1 &&
                    $scope.selectedMappingList.indexOf($translate.instant('BegCreditBal')) === -1)) {

                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('SelectColumnError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('Condition1')
                    });
            }
            //借方发生额，贷方发生额同时必选
            if (($scope.selectedMappingList.indexOf($translate.instant('DebitBal')) === -1 &&
                $scope.selectedMappingList.indexOf($translate.instant('CreditBal')) !== -1)
                || ($scope.selectedMappingList.indexOf($translate.instant('DebitBal')) !== -1 &&
                    $scope.selectedMappingList.indexOf($translate.instant('CreditBal')) === -1)) {

                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('SelectColumnError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('Condition6')
                    });
            }
            //借方期末，贷方期末同时必选
            if (($scope.selectedMappingList.indexOf($translate.instant('EndDebitBal')) === -1 &&
                $scope.selectedMappingList.indexOf($translate.instant('EndCreditBal')) !== -1)
                || ($scope.selectedMappingList.indexOf($translate.instant('EndDebitBal')) !== -1 &&
                    $scope.selectedMappingList.indexOf($translate.instant('EndCreditBal')) === -1)) {

                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('SelectColumnError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('Condition7')
                    });
            }
            //2.期初余额必选或者(借方期初，贷方期初)必选
            if (!($scope.selectedMappingList.indexOf($translate.instant('BegBal')) !== -1 ||
                $scope.selectedMappingList.indexOf($translate.instant('BegDebitBal')) !== -1 &&
                $scope.selectedMappingList.indexOf($translate.instant('BegCreditBal')) !== -1)) {

                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('SelectColumnError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('Condition2')
                    });
            }
            //3.（借方发生额，贷方发生额）或者（借方期末，贷方期末）或者 期末余额 必选
            if (!($scope.selectedMappingList.indexOf($translate.instant('DebitBal')) !== -1
                && $scope.selectedMappingList.indexOf($translate.instant('CreditBal')) !== -1
                || $scope.selectedMappingList.indexOf($translate.instant('EndDebitBal')) !== -1
                && $scope.selectedMappingList.indexOf($translate.instant('EndCreditBal')) !== -1
                || $scope.selectedMappingList.indexOf($translate.instant('EndBal')) !== -1)
            ) {

                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('SelectColumnError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('Condition3')
                    });
            }
            //4.期初余额与借方期初，贷方期初不能同时选
            if ($scope.selectedMappingList.indexOf($translate.instant('BegBal')) !== -1 &&
                $scope.selectedMappingList.indexOf($translate.instant('BegDebitBal')) !== -1 &&
                $scope.selectedMappingList.indexOf($translate.instant('BegCreditBal')) !== -1) {

                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('SelectColumnError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('Condition4')
                    });
            }
            //5.期末余额与借方期末，贷方期末不能同时选
            if ($scope.selectedMappingList.indexOf($translate.instant('EndBal')) !== -1 &&
                $scope.selectedMappingList.indexOf($translate.instant('EndDebitBal')) !== -1 &&
                $scope.selectedMappingList.indexOf($translate.instant('EndCreditBal')) !== -1) {

                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('SelectColumnError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('Condition5')
                    });
            }

            //6. CIT时期间必须
            if ($scope.serviceTypeId === constant.serviceType.CIT
                && $scope.selectedMappingList.indexOf($translate.instant('PeriodId')) === -1) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('SelectColumnError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('PeriodColumnRequired')
                    });
            }

            if ($scope.errorMsgMap.length > 0) {
                $('#errorListModal').modal('show');
                return false;
            }
            return true;
        }


        //验证数据
        var validationTbData = function () {
            var defer = $q.defer();
            $scope.balanceInputList = [];
            for (var i = $scope.startRowNum - 1; i < $scope.sheetData.dataList.length; i++) {
                var balanceDto = {
                    'SeqNum': i + 1,
                    'BalanceId': PWC.newGuid(),
                    'PeriodId': undefinedStringToNull(i, 'PeriodId'),
                    'AcctCode': undefinedStringToNull(i, 'AccountCode'),
                    'CustomerCode': undefinedStringToNull(i, 'CustomerCode'),
                    'MonthId': undefinedStringToNull(i, 'PeriodId'),
                    'BegDebitBal': undefinedNumToNull(i, 'BegDebitBal'),
                    'BegCreditBal': undefinedNumToNull(i, 'BegCreditBal'),
                    'DebitBal': undefinedNumToNull(i, 'DebitBal'),
                    'CreditBal': undefinedNumToNull(i, 'CreditBal'),
                    'EndDebitBal': undefinedNumToNull(i, 'EndDebitBal'),
                    'EndCreditBal': undefinedNumToNull(i, 'EndCreditBal'),
                    'BegBal': undefinedNumToNull(i, 'BegBal'),
                    'EndBal': undefinedNumToNull(i, 'EndBal'),
                };
                $scope.balanceInputList.push(balanceDto);
            }

            if ($scope.serviceTypeId === constant.serviceType.CIT+"") {
                $scope.isSelectPeriod = $scope.balanceInputList[0].MonthId !== null ? true : false;
                var isOk = valueTypeValidation($scope.balanceInputList);
                defer.resolve(isOk);
                return defer.promise;

            }
            else if ($scope.serviceTypeId === constant.serviceType.VAT+"") {
                if ($scope.balanceInputList[0].MonthId === null) {//没有选中月份,默认导入所有期间
                    $scope.isSelectPeriod = false;
                    swal({
                        title: "warning!",
                        text: $translate.instant('NoPeriod'),
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        confirmButtonText: $translate.instant('Yes'),
                        cancelButtonText: $translate.instant('No'),
                        closeOnConfirm: true,
                        closeOnCancel: true
                    },
                        function (isConfirm) {
                            $timeout(function () {
                                if (isConfirm) {
                                    var isok = valueTypeValidation($scope.balanceInputList);
                                    defer.resolve(isok);
                                }
                                else {
                                    defer.resolve(false);
                                }
                            }, 300);
                        });

                    return defer.promise;
                }
                else {
                    $scope.isSelectPeriod = true;
                    var isSame = true;
                    $scope.balanceInputList.forEach(function (m) {
                        if (m.MonthId !== m.PeriodId.toString()) {
                            isSame = false;
                        }
                    });
                    if (isSame === false) { //是否只导入当前月份数据
                        swal({
                            title: "warning!",
                            text: $translate.instant('PeriodDifferenceTip'),
                            type: "warning",
                            showCancelButton: true,
                            confirmButtonColor: "#DD6B55",
                            confirmButtonText: $translate.instant('Yes'),
                            cancelButtonText: $translate.instant('No'),
                            closeOnConfirm: true,
                            closeOnCancel: true
                        },
                            function (isConfirm) {
                                $timeout(function () {
                                    if (isConfirm) {
                                        var isOk = valueTypeValidation($scope.balanceInputList);
                                        defer.resolve(isOk);
                                    }
                                    else {
                                        defer.resolve(false);
                                    }
                                }, 300);
                            });
                        return defer.promise;
                    }
                    else {
                        var isOk = valueTypeValidation($scope.balanceInputList);
                        defer.resolve(isOk);
                        return defer.promise;
                    }
                }
            }



        };


        //根据PeriodId过滤数据
        var filterImportData = function (m) {
            var filterData = false;
            if ($scope.serviceTypeId === constant.serviceType.VAT+"") {
                filterData = m.MonthId === m.PeriodId
                    && m.PeriodId === $scope.period.toString();

            } else if ($scope.serviceTypeId === constant.serviceType.CIT+"") {
                filterData = m.MonthId === m.PeriodId;
            }

            return filterData;
        };

        var downloadTemplate = function () {
            templateService.downloadTemplate(constant.importFileType.adjustmentTable).success(function (data, status, headers) {
                var octetStreamMime = 'application/octet-stream';
                var contentType = headers('content-type') || octetStreamMime;
                if (window.navigator.msSaveBlob) {
                    var blob = new Blob([data], {
                        type: contentType
                    });
                    navigator.msSaveBlob(blob, "AdjustmentTable");
                } else {
                    var urlCreator = window.URL || window.webkitURL || window.mozURL || window.msURL;
                    if (urlCreator) {
                        var a = document.createElement('a');
                        var blob = new Blob([data], {
                            type: contentType
                        });
                        var url = urlCreator.createObjectURL(blob);
                        a.href = url;
                        a.target = '_blank';
                        a.download = "AdjustmentTable.xlsx";
                        document.body.appendChild(a);
                        a.click();
                    }
                }
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        };

            //导入事件
        var doUploadAT = function (importType) {
            var impExl = $scope.importExcelFile;
            var deferred = $q.defer();
            var token = $('input[name="__RequestVerificationToken"]').val();

            if (!impExl) {
                SweetAlert.warning($translate.instant('PleaseSelectFileFirst'));
                return;
            }

            //列名对应验证
            /*if (validationColumnMapping()) {
                //数据类型验证
                validationTbData().then(function (isSuccess) {
                    if (isSuccess) {

                });
            }*/
            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = $scope.fileName;
            if (importType === $scope.importEnum.Import) {
                logDto.OperationName = $translate.instant('ImportProfitLoss');
                logDto.OperationType = enums.vatLogOperationTypeEnum.Import;
            } else if (importType === $scope.importEnum.CoverImport) {
                logDto.OperationName = $translate.instant('CoverImportProfitLoss');
                logDto.OperationType = enums.vatLogOperationTypeEnum.CoverImport;
            } else if (importType === $scope.importEnum.AddImport) {
                logDto.OperationName = $translate.instant('AddImportProfitLoss');
                logDto.OperationType = enums.vatLogOperationTypeEnum.AddImport;
            }

            var period = $scope.UploadPeriodTime;
            var orgIds = JSON.stringify($scope.checkedCompanyCodeList);
            // var orgIds = $scope.checkedCompanyList;

            Upload.upload({
                url: $scope.importATExcelFile,
                data: {
                    orgIds : orgIds,
                    periodDate : period,
                    importType : importType
                },
                file: impExl,
                headers: {
                    'Access-Control-Allow-Origin': '*',
                    Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken(),
                    __RequestVerificationToken: token,
                    withCredentials: true
                },
                __RequestVerificationToken: token,
                withCredentials: true
            }).then(function(resp) {
                var ret = resp.data;
                $('#busy-indicator-container').hide();
                deferred.resolve();
                if (ret.result) {
                    logDto.UpdateState = $translate.instant('ImportSuccess');
                    vatOperationLogService.addOperationLog(logDto);
                    SweetAlert.success($translate.instant('ImportSuccess'));
                } else {
                    if (ret.resultMsg && ret.resultMsg.length > 0) {
                        SweetAlert.warning($translate.instant(ret.resultMsg));
                    }else{
                        SweetAlert.error($translate.instant('ImportFailed'));
                    }
                    logDto.UpdateState = $translate.instant('ImportFail');
                    vatOperationLogService.addOperationLog(logDto);
                }
                getImportATStatus();

            }, function(resp) {
                deferred.resolve();
                if (resp.statusText === 'HttpRequestValidationException') {
                    SweetAlert.warning($translate.instant('HttpRequestValidationException'));
                } else {
                    SweetAlert.warning('SaveFail');
                }
                logDto.UpdateState = $translate.instant('ImportFail');
                vatOperationLogService.addOperationLog(logDto);
                SweetAlert.error($translate.instant('ImportFail'));
                console.log('Error status: ' + resp.status);
            }, function(evt) {
                deferred.resolve();
                var progressPercentage = parseInt(100.0 * evt.loaded / evt.total);
                $log.debug('progress: ' + progressPercentage + '% ' + evt.config.data.file.name);
            });
        };

        var getGridHeight = function () {
            if ($scope.isLoadComplete) {
                return { height: ($('.balance-ouput-grid-wrapper').height()) + "px" };
            }
            else {
                return { height: 0 + "px" };
            }
        };

        var loadImportATStatusInfoDatagrid = function () {

            $scope.importATStatusGridOptions = {
                bindingOptions: {
                    dataSource: 'ImportATStatusGridSource'
                },
                showBorders: true,
                columns: [{
                    dataField: "id",
                    visible: false,
                    allowHeaderFiltering: false,
                    caption: $translate.instant('id')
                }, {
                    dataField: "taxpayerIdNum",
                    width: '15%',
                    allowHeaderFiltering: false,
                    caption: $translate.instant('TaxpayerIdNum')
                }, {
                    dataField: "companyCode",
                    allowHeaderFiltering: false,
                    caption: $translate.instant('CompanyCode'),
                    width: '15%'
                }, {
                    dataField: "companyName",
                    allowHeaderFiltering: false,
                    width: '27%',
                    caption: $translate.instant('CompanyName')
                }, {
                    dataField: "periodYear",
                    allowHeaderFiltering: false,
                    width: '5%',
                    caption: $translate.instant('YearPeriod')
                }, {
                    dataField: "periodMonth",
                    allowHeaderFiltering: false,
                    width: '10%',
                    caption: $translate.instant('TMSPeriod')
                }, {
                    dataField: "periodMonth",
                    allowHeaderFiltering: false,
                    width: '5%',
                    caption: $translate.instant('Period')
                }, {
                    dataField: "recordSize",
                    allowHeaderFiltering: false,
                    width: '8%',
                    caption: $translate.instant('RecordSize')
                }, {
                    dataField: "errorMsg",
                    allowHeaderFiltering: false,
                    width: '15%',
                    caption: $translate.instant('Status')
                }
                ],
                onContentReady: function (e) {
                    $scope.ATStatusInstance = e.component;
                    var totalCount = e.component.totalCount();
                    if (totalCount > 0) {
                        $scope.totalCount = totalCount;
                    }
                },
                loadPanel: {
                    enabled: false
                },
                selection: {
                    mode: "single"
                },
                grouping: {
                    autoExpandAll: false
                },
                allowColumnResizing: true,
                columnAutoWidth: true,
                showRowLines: true,
                showColumnLines: true,
                rowAlternationEnabled: true,  //单双行颜色
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                headerFilter: {
                    visible: false,
                    texts: {
                        cancel: $translate.instant('Cancel'),
                        ok: $translate.instant('Confirm'),
                        emptyValue: $translate.instant('Empty'),
                        selectAllText: $translate.instant('SelectAll')
                    }
                }
            };
            getImportATStatus();
        };

        var getImportATStatus = function () {
            vatImportService.displayImportLog($scope.pagingOptions,constant.importFileType.adjustmentTable).success(function (data) {
                if (data && data.list) {
                    $scope.ImportATStatusGridSource = data.list;
                    $scope.pagingOptions.totalItems = data.pageInfo.totalCount;
                }else {
                    SweetAlert.error($translate.instant('SystemError'));
                }
            });
        };

        //加载文档后操作
        var initImportFile = function (fileName) {
            var arr = fileName.name.split('.');
            if (arr[arr.length - 1] !== 'xls' && arr[arr.length - 1] !== 'xlsx') {
                SweetAlert.warning($translate.instant('ImportFileInvalidType'));
                return;
            }
            $scope.fileName = fileName.name;
            //初始化数据
            $scope.selectedMappingList = [];
            $scope.ImportErrorTab = false;
            $scope.ImportErrorTag = false;
        }


        //日志
        var showOperateLogPop = function () {
            $scope.isShowLog = true;
        };

        // 检查用户机构权限
        var checkUserOrganizationPermissionList = function () {

            var list = [];

            var userManageTemp = constant.vatPermission.dataImport.balanceSheet;
            list.push(userManageTemp.importCode);
            $scope.hasImportPermission = false;
            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasImportPermission = data[userManageTemp.importCode];
            });
        };


        //控制明细信息中删除权限
        var getUserPermission = function () {
            var list = [];
            var code = constant.vatPermission.dataImport.balanceSheet.importCode;
            list.push(code);

            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasEditPermission = data[code];
            });
        };


        var setButtonWrapStyle = function () {
            if ($scope.fileName) {
                return { width: "100%" };
            }
        };

        var setGridStyle = function () {
            if ($scope.showTotalSecondRow) {
                return { 'margin-top': '60px' }
            }
            else {
                return { 'margin-top': '55px' }
            }
        };

        var initDatePicker = function () {
            var ele1 = $("#periodDatepicker");
            ele1.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                viewMode: $scope.viewMode,
                minViewMode: $scope.viewMode,
                autoclose: true, //选中之后自动隐藏日期选择框
                clearBtn: true, //清除按钮
                todayBtn: false, //今日按钮
                format: $scope.dateFormat //日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            });
            ele1.datepicker("setDate", $scope.selectedDate);
        };

        var initCompanyList = function () {
            orgService.getOrgListByUserId().success(function (data) {
                if (data) {
                    $scope.companyList = data;
                }
            });
        };

        $scope.selectOne = function () {
            $scope.checkedCompanyList = [];
            angular.forEach($scope.companyList , function (i) {
                var index = $scope.checkedCompanyList.indexOf(i.id);
                if(i.checked && index === -1) {
                    $scope.checkedCompanyList.push(i);
                } else if (!i.checked && index !== -1){
                    $scope.checkedCompanyList.splice(index, 1);
                }
            });

            $scope.selectedAll = $scope.companyList.length === $scope.checkedCompanyList.length;

            $scope.checkedCompanyTypeList = "";
            $scope.checkedCompanyCodeList = [];
            angular.forEach($scope.checkedCompanyList,function (i) {
                $scope.checkedCompanyTypeList += i.name+";";
                $scope.checkedCompanyCodeList.push(i.id);
            });
            console.log($scope.checkedCompanyList);
        };

        $scope.selectAll = function () {
            if($scope.selectedAll) {
                $scope.selectedOne = true;
                $scope.checkedCompanyList = [];
                angular.forEach($scope.companyList, function (i, index) {
                    $scope.checkedCompanyList.push(i);
                    i.checked = true;
                })
            }else {
                $scope.selectedOne = false;
                $scope.checkedCompanyList = [];
                angular.forEach($scope.companyList, function (i, index) {
                    i.checked = false;
                })
            }
            $scope.checkedCompanyTypeList = "";
            $scope.checkedCompanyCodeList = [];
            angular.forEach($scope.checkedCompanyList,function (i) {
                $scope.checkedCompanyTypeList += i.name;
                $scope.checkedCompanyCodeList.push(i.id);
            });
            console.log($scope.checkedCompanyList);
        };

        //刷新页面
        $scope.refreshConfigGrid = function () {
            getImportATStatus();
        };

        var initParam = function () {
            $scope.doUploadAT = doUploadAT;
            $scope.downloadTemplate = downloadTemplate;
            $scope.setButtonWrapStyle = setButtonWrapStyle;
            $scope.getGridHeight = getGridHeight;
            $scope.showOperateLogPop = showOperateLogPop;
            $scope.setGridStyle = setGridStyle;
        };

        //开始
        (function initialize() {
            $log.debug('ImportTBController.ctor()...');
            checkUserOrganizationPermissionList();

            initParam();
            getUserPermission();
            initCompanyList();

            loadImportATStatusInfoDatagrid();
            initDatePicker();

            $scope.$watch('importExcelFile', function (newValue, oldValue) {
                if (newValue !== null && newValue !== oldValue) {
                    initImportFile(newValue);
                }
            });

            $timeout(function () {
                $scope.isLoadComplete = true;
            }, 500);
        })();
    }
]);