commonModule.controller('modelAnalysisReportIssueFilterController', ['$scope', '$translate', '$uibModal', 'modelConfigurationService', 'vatPreviewService', '$compile', '$q', 'dxDataGridService',
    function ($scope, $translate, $uibModal, modelConfigurationService, vatPreviewService, $compile, $q, dxDataGridService) {
        'use strict';

        $scope.trans = {
            OTNoDataText: $translate.instant('NoDataText')
        };

        var ENTRY_COLUMNS = [
            {
                alignment: "left",
                dataField: "period",
                caption: $translate.instant('AccountVoucher_DataGrid_ColPeriod'),
                //sortIndex: 0,
                //sortOrder: 'asc',
                width: 65
            },
            {
                alignment: "center",
                dataField: "date",
                dataType: "date",
                format: "yyyy-MM-dd",
                caption: $translate.instant('AccountVoucher_DataGrid_ColDate'),
                //sortIndex: 1,
                //sortOrder: 'asc',
                width: 95
            },
            {
                dataField: "group",
                caption: $translate.instant('AccountVoucher_DataGrid_ColGroup'),
                //sortIndex: 2,
                //sortOrder: 'asc',
                width: 180
            },
            {
                dataField: "vid",
                caption: $translate.instant('AccountVoucher_DataGrid_ColVID'),
                //sortIndex: 3,
                //sortOrder: 'asc',
                width: "20%"
            },
            {
                dataField: "summary",
                caption: $translate.instant('AccountVoucher_DataGrid_ColSummary'),
                width: "30%"
            },
            {
                dataField: "acctCodeAndNameShow",
                caption: $translate.instant('AccountVoucher_DataGrid_ColAcctCodeAndNameShow'),
                width: "20%"
            },
            {
                dataField: "stdCodeAndNameShow",
                caption: $translate.instant('AccountVoucher_DataGrid_ColStdCodeAndNameShow'),
                width: "30%"
            },
            {
                dataField: "debit",
                caption: $translate.instant('AccountVoucher_DataGrid_ColDebit'),
                alignment: "right",
                width: 120
            },
            {
                dataField: "credit",
                caption: $translate.instant('AccountVoucher_DataGrid_ColCredit'),
                alignment: "right",
                width: 120
            }
            //{
            //    dataField: "isFiltered",
            //    caption: "过滤",
            //    alignment: "right",
            //    width: 50
            //}
        ];

        var SINGULAR_VOUCHER_COLUMNS = [
            {
                alignment: "left",
                dataField: "summary",
                caption: $translate.instant('AccountVoucher_DataGrid_ColSummary'),
                width: "30%"
            }, {
                alignment: "left",
                dataField: "acctCodeAndNameShow",
                caption: $translate.instant('AccountVoucher_DataGrid_ColAcctCodeAndNameShow'),
                //sortIndex: 0,
                //sortOrder: 'asc',
                width: "35%"
            }, {
                alignment: "left",
                dataField: "stdCodeAndNameShow",
                caption: $translate.instant('AccountVoucher_DataGrid_ColStdCodeAndNameShow'),
                //sortIndex: 1,
                //sortOrder: 'asc',
                width: "35%"
            }, {
                alignment: "right",
                dataField: "debit",
                caption: $translate.instant('AccountVoucher_DataGrid_ColDebit'),
                width: 170
            }, {
                alignment: "right",
                dataField: "credit",
                caption: $translate.instant('AccountVoucher_DataGrid_ColCredit'),
                width: 170
            }];

        var VOUCHER_COLUMNS = [
            {
                dataField: "period",
                caption: $translate.instant('AccountVoucher_DataGrid_ColPeriod'),
                //sortIndex: 0,
                //sortOrder: 'asc',
                width: 130
            }, {
                alignment: "center",
                dataField: "date",
                dataType: "date",
                caption: $translate.instant('AccountVoucher_DataGrid_ColDate'),
                format: "yyyy-MM-dd",
                //sortIndex: 1,
                //sortOrder: 'asc',
                width: 100
            }, {
                dataField: "group",
                caption: $translate.instant('AccountVoucher_DataGrid_ColGroup'),
                //sortIndex: 2,
                //sortOrder: 'asc',
                width: "50%"
            }, {
                dataField: "vid",
                caption: $translate.instant('AccountVoucher_DataGrid_ColVID'),
                //sortIndex: 3,
                //sortOrder: 'asc',
                width: "50%"
            }, {
                dataField: "debitSum",
                caption: $translate.instant('AccountVoucher_DataGrid_ColDebitSum'),
                alignment: "right",
                width: 170
            }, {
                dataField: "creditSum",
                caption: $translate.instant('AccountVoucher_DataGrid_ColCreditSum'),
                alignment: "right",
                width: 170
            }];

        var VOUCHER_DETAIL_COLUMNS = [
            {
                dataField: "summary",
                caption: $translate.instant('AccountVoucher_DataGrid_ColSummary'),
                width: "50%"
            }, {
                dataField: "acctCodeAndNameShow",
                caption: $translate.instant('AccountVoucher_DataGrid_ColAcctCodeAndNameShow'),
                //sortIndex: 1,
                //sortOrder: 'asc',
                width: "25%"
            }, {
                dataField: "stdCodeAndNameShow",
                caption: $translate.instant('AccountVoucher_DataGrid_ColStdCodeAndNameShow'),
                //sortIndex: 0,
                //sortOrder: 'asc',
                width: "25%"
            }, {
                dataField: "debit",
                caption: $translate.instant('AccountVoucher_DataGrid_ColDebit'),
                alignment: "right",
                width: 170
            }, {
                dataField: "credit",
                caption: $translate.instant('AccountVoucher_DataGrid_ColCredit'),
                alignment: "right",
                width: 170
            }];

        var DEFAULT_PAGE_SIZE = 100;

        //加载分录数据
        var loadEntryData = function () {
            var viewModel = $scope.entry;
            var pagingInfo = {
                pageIndex: viewModel.pagingOptions.pageIndex,
                pageSize: viewModel.pagingOptions.pageSize
            };

            //TODO:前台 modelType 与数据中 Model 的 Type 是否一致,此时数据库中存在 Type != 1 & 2 的情况
            var apiFunc = modelConfigurationService.getEntriesModelResultDetail;
            apiFunc($scope.modelId, $scope.serviceTypeId, $scope.modelType, $scope.periodFrom, $scope.periodTo, pagingInfo, $scope.filterIssue, false).then(function (response) {
                var data = response.data;

                viewModel.debitSum = _.reduce(data, function (sum, x) {
                    return sum + ($.isNumeric(x.debit) ? parseFloat(x.debit) : 0);
                }, 0);
                viewModel.debitSum = PWC.round(viewModel.debitSum);

                viewModel.creditSum = _.reduce(data, function (sum, x) {
                    return sum + ($.isNumeric(x.credit) ? parseFloat(x.credit) : 0);
                }, 0);
                viewModel.creditSum = PWC.round(viewModel.creditSum);

                viewModel.entryCount = data.length;
                viewModel.voucherCount = _.keys(_.groupBy(data, function (item) {
                    return item.period + "_" + item.group + "_" + item.vid;
                })).length;

                $.each(data, function (i, row) {
                    row.debit = PWC.round(row.debit, 2);
                    row.credit = PWC.round(row.credit, 2);
                });

                fillSummaryFields(viewModel);

                viewModel.isLoaded = true;

                selectFilteredItems(viewModel.dataGridInstance);

                viewModel.dataSource = data;
            });
        };

        //加载凭证列表数据
        var loadVoucherData = function () {
            var viewModel = $scope.voucher;
            var pagingInfo = {
                pageIndex: viewModel.pagingOptions.pageIndex,
                pageSize: viewModel.pagingOptions.pageSize
            };

            var apiFunc = modelConfigurationService.getEntriesModelResultDetailByVoucher;
            apiFunc($scope.modelId, $scope.serviceTypeId, $scope.modelType, $scope.periodFrom, $scope.periodTo, pagingInfo, $scope.filterIssue).then(function (response) {
                var data = response.data;

                viewModel.debitSum = PWC.round(data.debitSum, 2);
                viewModel.creditSum = PWC.round(data.creditSum, 2);
                viewModel.voucherCount = data.vidCount;
                viewModel.entryCount = data.itemIDCount;

                data.voucherMainList.forEach(function (row) {
                    row.debitSum = PWC.round(row.debitSum, 2);
                    row.creditSum = PWC.round(row.creditSum, 2);
                });

                fillSummaryFields(viewModel);

                viewModel.isLoaded = true;

                selectFilteredItems(viewModel.dataGridInstance);

                viewModel.dataSource = data.voucherMainList;
            });
        };

        //加载单凭证数据(弹出框 & 凭证列表明细表)
        var loadSingularVoucherDetailData = function (period, voucherNum, group) {
            var apiFunc = modelConfigurationService.getEntriesByVoucher;
            return apiFunc($scope.modelId, $scope.serviceTypeId, $scope.modelType, $scope.periodFrom, $scope.periodTo, period, voucherNum, group, $scope.filterIssue).then(function (response) {
                var data = response.data;

                $.each(data, function (i, item) {
                    item.debit = PWC.round(item.debit, 2);
                    item.credit = PWC.round(item.credit, 2);
                });

                return data
            });
        };

        //创建凭证明细 dataGrid 控件(模板)
        var voucherDetailTemplate = function (container, options) {
            var gridOption = $.extend(true, {}, dxDataGridService.BASIC_GRID_OPTIONS, {
                columns: VOUCHER_DETAIL_COLUMNS,
                dataSource: new DevExpress.data.CustomStore({
                    load: function (loadOptions) {
                        return loadSingularVoucherDetailData(options.data.period, options.data.vid, options.data.group);
                    }
                }),
                onRowPrepared: function (e) {
                    if ($scope.filterIssue && e.rowType == 'data' && e.data && e.data.isDoubt === 1)
                        e.rowElement.addClass('entriesHighLight');
                }
            });

            $("<div>").dxDataGrid(gridOption).appendTo(container);
        };

        var fillSummaryFields = function (viewModel) {
            $scope.entryCount = viewModel.entryCount;
            $scope.voucherCount = viewModel.voucherCount;
            $scope.debitSum = viewModel.debitSum;
            $scope.creditSum = viewModel.creditSum;
        };

        var selectFilteredItems = function (gridInstance) {
            if (!$scope.isFilter)
                return;

            var dataSource = gridInstance.getDataSource();

            gridInstance.clearSelection();
            var selectedItems = _.filter(dataSource.store(), function (item) {
                return item.isFiltered === 1
            });
            if (selectedItems && selectedItems.length > 0) {
                gridInstance.selectRows(selectedItems);
            }
        };

        var checkRequestAccessible = function () {
            return !!$scope.modelId
                && !!$scope.modelType
                && !!$scope.periodFrom
                && !!$scope.periodTo
                && !!$scope.serviceTypeId
                && ($scope.displayMode === 1 || $scope.displayMode === 2);
        };

        //根据当前 "参数" 重新加载数据
        var reloadViewModelData = function () {
            var reModel = $scope.displayMode === 1 ? $scope.voucher : $scope.entry;

            //在数据源重新加载数据后,在 load 里面 fillSummaryFields
            if (!reModel.isLoaded) {
                reModel.pagingOptions.pageIndex = 1;
                if (!(!!$scope.modelId && !!$scope.modelType && !!$scope.periodFrom && !!$scope.periodTo && !!$scope.serviceTypeId && ($scope.displayMode === 1 || $scope.displayMode === 2)))
                    return;

                reModel.getItemsTotalCount();
                $scope.displayMode === 1 ? loadVoucherData() : loadEntryData();
            }
            else {
                fillSummaryFields(reModel);
            }
        };

        $scope.$watchGroup(["modelId", "modelType", "periodFrom", "periodTo", "serviceTypeId"], function (newValue, oldValue) {
            $scope.entry.isLoaded = false;
            $scope.voucher.isLoaded = false;

            reloadViewModelData();
        });

        $scope.$watch("displayMode", function (newValue, oldValue) {
            reloadViewModelData();
        });

        $scope.exportSupported = !!$scope.exportSupported;
        $scope.displayMode = $scope.displayMode || 2;
        $scope.entryCount = 0;
        $scope.voucherCount = 0;
        $scope.debitSum = 0;
        $scope.creditSum = 0;

        /*
        * 为了使切换 "分录" 与 "凭证" 不引起数据重加载,需要注意:
        *   1.summary 数据必须针对 "分录" 与 "凭证" 进行缓存,使切换显示方式时,不用进行远程网络请求
        *   2.分页控件也需要独立设置,切换或进行分页显示时可以"记忆"该模式下的分页信息
        *   3.仅当"分析结果"焦点行发生变化时刷新本模块数据
        *   4.刷新加载数据时仅加载当前显示模式的数据,当切换到的模式下没有数据时,进行数据请求,需要对两个显示方式分别设置 已加载数据的标志值,并在 3 的情景下,重设标志值
        * */

        //分录列表
        $scope.entry = {
            entryCount: 0,
            voucherCount: 0,
            debitSum: 0,
            creditSum: 0,
            dataGridInstance: null,
            dataSource: [],
            dxDataGridOptions: {
                bindingOptions: {
                    dataSource: "entry.dataSource"
                },
                columns: ENTRY_COLUMNS,
                onInitialized: function (e) {
                    $scope.entry.dataGridInstance = e.component;
                    dxDataGridService.fixContentOverflowWithMaxHeight(e.component);
                    dxDataGridService.registerRowDbClick(e.component);
                },
                onRowDbClick: function (e) {
                    $scope.singularVoucher.openEntriesCheckSingularVoucher(e.data.date, e.data.period, e.data.group, e.data.vid);
                },
                onRowPrepared: function (e) {
                    if (!$scope.filterIssue) {
                        if (e.rowType !== 'header' && e.data && e.data.isDoubt === 1)
                            e.rowElement.addClass('entriesHighLight');
                    }
                },
                onSelectionChanged: function (e) {
                    if (!$scope.filterIssue)
                        return;

                    var dataSource = $scope.entry.dxDataGridOptions.dataSource;
                    var selectedItems = [];
                    $.each(e.currentSelectedRowKeys, function (i, selectedItem) {
                        $.each(dataSource._array, function (j, item) {
                            if (item.period === selectedItem.period && item.group === selectedItem.group && item.vid === selectedItem.vid)
                                selectedItems.push(item);
                        });
                    });

                    $scope.entry.dataGridInstance.selectRows(selectedItems);
                }
            },
            isLoaded: false,
            pagingOptions: {
                pageIndex: 1,
                pageSize: DEFAULT_PAGE_SIZE,
                totalItems: 0
            },
            getItemsTotalCount: function () {
                var apiFunc = modelConfigurationService.getEntriesModelResultDetailCount;
                apiFunc($scope.modelId, $scope.serviceTypeId, $scope.modelType, $scope.periodFrom, $scope.periodTo, true).then(function (response) {
                    $scope.entry.pagingOptions.totalItems = response.data;
                });
            }
        };

        //凭证列表
        $scope.voucher = {
            entryCount: 0,
            voucherCount: 0,
            debitSum: 0,
            creditSum: 0,
            dataGridInstance: null,
            dataSource: [],
            dxDataGridOptions: {
                bindingOptions: {
                    dataSource: "voucher.dataSource"
                },
                columns: VOUCHER_COLUMNS,
                masterDetail: {
                    enabled: true,
                    template: voucherDetailTemplate
                },
                onCellPrepared: function (e) {
                    if (e.rowType === "header" && $(e.cellElement).hasClass("dx-command-expand")) {
                        var btn = $("<div class='dx-datagrid-group-closed'></div>");
                        btn.attr("ng-click", "voucher.toggleAllMasterRows($event)");
                        e.cellElement.html($compile(btn)($scope));
                    }
                },
                onInitialized: function (e) {
                    $scope.voucher.dataGridInstance = e.component;
                    dxDataGridService.fixContentOverflowWithMaxHeight(e.component);
                    dxDataGridService.registerRowDbClick(e.component);
                },
                onRowDbClick: function (e) {
                    $scope.singularVoucher.openEntriesCheckSingularVoucher(e.data.date, e.data.period, e.data.group, e.data.vid);
                }
            },
            isLoaded: false,
            pagingOptions: {
                pageIndex: 1,
                pageSize: DEFAULT_PAGE_SIZE,
                totalItems: 0
            },
            getItemsTotalCount: function () {
                var apiFunc = vatPreviewService.voucherSelectAdvancedCount;
                apiFunc('8', true, false, []).then(function (response) {
                    $scope.entry.pagingOptions.totalItems = response.data;
                });
            },
            toggleAllMasterRows: function ($event) {
                var expand = "dx-datagrid-group-closed";
                var collapse = "dx-datagrid-group-opened";
                if ($($event.target).hasClass(expand)) {
                    $scope.voucher.dataGridInstance.expandAll(-1);
                    $($event.target).removeClass(expand);
                    $($event.target).addClass(collapse);
                } else {
                    $scope.voucher.dataGridInstance.collapseAll(-1);
                    $($event.target).removeClass(collapse);
                    $($event.target).addClass(expand);
                }
            }
        };

        //单张凭证详细信息(弹出框)
        $scope.singularVoucher = {
            //凭证日期
            date: null,
            //期间
            period: null,
            //凭证类型
            group: null,
            //凭证号
            voucherNum: null,
            dataGridInstance: null,
            dataSource: [],
            dxDataGridOptions: {
                bindingOptions: {
                    dataSource: "singularVoucher.dataSource"
                },
                columns: SINGULAR_VOUCHER_COLUMNS,
                onInitialized: function (e) {
                    dxDataGridService.fixContentOverflowWithMaxHeight(e.component);
                }
            },
            openEntriesCheckSingularVoucher: function (date, period, group, voucherNum) {
                var singularVoucher = $scope.singularVoucher;
                singularVoucher.date = new Date(date).dateTimeToString("yyyyMMdd");
                singularVoucher.period = period;
                singularVoucher.group = group;
                singularVoucher.voucherNum = voucherNum;
                singularVoucher.modalOpened = false;

                loadSingularVoucherDetailData(period, voucherNum, group).then(function (data) {
                    $scope.singularVoucher.dataSource = data;
                });

                var modalInstance = $uibModal.open({
                    animation: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    backdrop: "static",
                    templateUrl: 'model-analysis-entries-check-singular-voucher.html',
                    scope: $scope,
                    windowClass: "model-analysis-entries-check-singular-voucher"
                });

                singularVoucher.close = function () {
                    modalInstance.dismiss('cancel');
                }
            }
        };

        $scope.exportCurrentPageToExcel = function () {
            console.log("//TODO:尚未实现 exportCurrentPageToExcel");
        };

        $scope.exportAllPageToExcel = function () {
            console.log("//TODO:尚未实现 exportAllPageToExcel");
        };

        (function initialize() {
            $.extend(true, $scope.entry.dxDataGridOptions, dxDataGridService.BASIC_GRID_OPTIONS);
            $.extend(true, $scope.voucher.dxDataGridOptions, dxDataGridService.BASIC_GRID_OPTIONS);
            $.extend(true, $scope.singularVoucher.dxDataGridOptions, dxDataGridService.BASIC_GRID_OPTIONS);
        })();

        //TODO:针对于"总账->明细账"的数据获取,"总账->明细账"的数据获取/count计算/分页/listQueryCondition 等信息获取未实现
        var drillDownDetailVoucherDataLoad = function (pageIndex) {
            var drillDownDetail = $scope.indexAnalysis.drillDownDetail;
            drillDownDetail.curVoucherItemPage = pageIndex;
            drillDownDetail.pagingInfo.pageIndex = pageIndex;
            if (drillDownDetail.displayMode === 1) {
                vatPreviewService.voucherSelectAdvancedByVoucher('8', false, drillDownDetail.pagingInfo, drillDownDetail.listQueryCondition).success(function (listData) {
                    listData.data.debitSum = PWC.round(listData.data.debitSum, 2);
                    listData.data.creditSum = PWC.round(listData.data.creditSum, 2);
                    listData.data.voucherMainList.forEach(function (v) {
                        v.debitSum = PWC.round(v.debitSum, 2);
                        v.creditSum = PWC.round(v.creditSum, 2);
                    });
                    drillDownDetail.dataList = listData.data.voucherMainList;
                    drillDownDetail.voucherCount = listData.data.vidCount;
                    drillDownDetail.entryCount = listData.data.itemIDCount;
                    drillDownDetail.debitSum = listData.data.debitSum;
                    drillDownDetail.creditSum = listData.data.creditSum;
                    //先加载Div
                    $timeout(function () {
                        initIndexDetailVoucherDataGrid();
                    }, 100);

                });
            } else {
                vatPreviewService.voucherSelectAdvancedByEntry('8', false, drillDownDetail.pagingInfo, drillDownDetail.listQueryCondition).success(function (listData) {
                    listData.data.debitSum = PWC.round(listData.data.debitSum, 2);
                    listData.data.creditSum = PWC.round(listData.data.creditSum, 2);
                    listData.data.voucherList.forEach(function (v) {
                        v.debit = PWC.round(v.debit, 2);
                        v.credit = PWC.round(v.credit, 2);
                    });
                    drillDownDetail.dataList = listData.data.voucherList;
                    drillDownDetail.voucherCount = listData.data.vidCount;
                    drillDownDetail.entryCount = listData.data.itemIDCount;
                    drillDownDetail.debitSum = listData.data.debitSum;
                    drillDownDetail.creditSum = listData.data.creditSum;
                    //先加载Div
                    $timeout(function () {
                        initIndexDetailVoucherDataGrid();
                    }, 100);
                });
            }
            computeVoucherItemPage(false);
        };
    }]);
