﻿commonModule.directive('orgAreaIndustry', ['$log', '$compile', '$timeout', '$interval',
    function ($log, $compile, $timeout, $interval) {
        'use strict';
        $log.debug('orgChart.ctor()...');

        return {
            restrict: 'AE',
            templateUrl: '/app/common/controls/org-area-industry/org-area-industry.html' + '?_=' + Math.random(),
            replace: true,
            scope: {
                orgId: '=',
                isRenderCompleted: '='
            },
            controller: 'OrgAreaIndustryController',
            link: function (scope, element) {
                scope.$watch('orgId', function (newValue, oldValue) {
                    if (newValue !== oldValue) {

                        //refresh ui grid with new data
                        scope.getOrgListForDashboard(newValue).then(function () {
                            scope.isRenderCompleted = true;
                        });
                    }

                    //点击弹出的面板，禁止冒泡事件
                    $("#orgAreaIndustryPopup").on("click", function (e) {
                        e.stopPropagation();
                    });
                     
                })
            }
        };
    }
]);