﻿commonModule.directive('orgChart', ['$log', '$compile', '$timeout', '$interval',
    function ($log, $compile, $timeout, $interval) {
        'use strict';
        $log.debug('orgChart.ctor()...');

        return {
            restrict: 'A',
            templateUrl: '/app/common/controls/org-chart/org-chart.html' + '?_=' + Math.random(),
            replace: true,
            scope: {
                selectedAreaCode: '=',
                selectedAreaName: '=',
                selectedAreaId: '=',
                componentSelectedArea: '=',
                isShowAll: '=',
                loadData: '&',
                onChange: '&onChange'
            },
            controller: 'OrgChartController',
            link: function (scope, element) {
                
                var nameAttr = $compile($('#node-name').html())(scope);
                var titleAttr = $compile($('#node-title').html())(scope);
                var topFirstAttr=$compile($('#topNode').html())(scope);

                var nameTemplate, titleTemplate,topTemplate;

                var myInterval = $interval(function () {
                    nameTemplate = nameAttr.html();
                    titleTemplate = titleAttr.html();
                    topTemplate = topFirstAttr.html();

                    if (nameTemplate !== undefined && titleTemplate !== undefined && topTemplate !== undefined) {

                        $interval.cancel(myInterval);

                        var datascource = {
                            'name': topTemplate,
                            // 'title': 'general manager',
                            'children': [
                              {
                                  'name': nameTemplate,
                                  'title': titleTemplate,
                                  'age': '12'

                              },
                              {
                                  'name': nameTemplate,
                                  'title': titleTemplate,
                                  'children': [
                                    {
                                        'name': nameTemplate,
                                        'title': titleTemplate
                                    },
                                    {
                                        'name': nameTemplate,
                                        'title': titleTemplate,
                                        'children': [
                                          {
                                              'name': nameTemplate,
                                              'title': titleTemplate
                                          },
                                          {
                                              'name': nameTemplate,
                                              'title': titleTemplate
                                          }
                                        ]
                                    }
                                  ]
                              },
                              {
                                  'name': nameTemplate,
                                  'title': titleTemplate
                              },
                              {
                                  'name': nameTemplate,
                                  'title': titleTemplate
                              }
                            ]
                        };

                        $('#subsidiary-chart').orgchart({
                            'data': datascource,
                            'nodeContent': 'title',
                            'pan': true,
                            'zoom': true,
                            "draggable": true
                        });
                    }
                }, 100)
            }
        };
    }
]);