﻿commonModule.
controller('OrgGeneralInfoController', ['$scope', 'orgService', '$log', 'uiGridTreeViewConstants', '$timeout', 'areaService', 'uiGridConstants', '$translate', '$interval', '$q', 'dimensionService',
    function ($scope, orgService, $log, uiGridTreeViewConstants, $timeout, areaService, uiGridConstants, $translate, $interval, $q, dimensionService) {
        'use strict';


        var getDimensionList = function () {
            dimensionService.getDimensionList().success(function (data) {
                if (data) {
                    $scope.customDimensionList = data;

                    $log.debug($scope.customDimensionList);

                    $scope.businessName = dimension.getBusinessUnitName();
                    $scope.areaName = dimension.getAreaName();
                }
            });
        };

        var dimension = {
            getBusinessUnitName: function () {
                var findResult = _.find($scope.customDimensionList, function (item) {
                    return item.id == constant.dimensionID.businessUnitID;
                });
                if (findResult) {
                    return findResult.name;
                }
                else {
                    return '';
                }
            },
            getAreaName: function () {
                var findResult = _.find($scope.customDimensionList, function (item) {
                    return item.id == constant.dimensionID.areaID;
                });
                if (findResult) {
                    return findResult.name;
                }
                else {
                    return '';
                }
            }
        };


        $scope.getGeneralInfo = function (orgId) {

            var deferred = $q.defer();
            var promise = deferred.promise;

            //var orgId = '81a3df63-b87d-4d7f-b3af-54169c13fa15';
            orgService.getGeneralInfo(orgId).success(function (data) {
                if (data) {
                    $scope.info = data;
                    $scope.info.id = orgId;
                    deferred.resolve(data);
                }
                else {
                    deferred.resolve(true);
                }
            });

            return deferred.promise;
        };

        (function initialize() {
            $log.debug('OrgGeneralInfoController.ctor()...');
            getDimensionList();


        })();
    }
]);