﻿commonModule.directive('outputInvoiceCancel', ['$log', '$uibModal', '$document', 'modalAdapterService',
    function ($log, $uibModal, $document, modalAdapterService) {
        'use strict';
        $log.debug('orgUserList.ctor()...');
        return {
            restrict: 'E',
            templateUrl: '/app/common/controls/output-invoice-cancel-modal/output-invoice-cancel-modal.html' + '?_=' + Math.random(),
            replace: true,
            scope: {
                parentElement:'@',
                cancelTitle: '=',
                callBack:'&',

            },
            controller: 'outputInvoiceCancelController',
            link: function ($scope, $element, attrs) {
                // ensure id attribute exists
                if (!attrs.id) {
                    console.error('modal must have an id');
                    return;
                }
                console.log($scope.cancelTitle);
                $scope.cancelDialog = {
                    confirm: function () {
                        if (_.isFunction($scope.callBack)) {
                            $scope.callBack();
                        }
                    },
                    //id: 'cancelGDModal.html',
                    id: attrs.id,
                    parentID:$scope.parentElement,
                    modalInstance: null,
                    open: function () {
                        var parentElem = $scope.parentElement ?
                                    angular.element($document[0].querySelector('.' + $scope.parentElement)) : undefined;
                        $scope.cancelDialog.modalInstance = $uibModal.open({
                            animation: false,
                            //backdrop: false,
                            ariaLabelledBy: 'modal-title',
                            ariaDescribedBy: 'modal-body',
                            templateUrl: 'cancelGDModal.html',
                            //windowClass: 'GD-Vechicle-detail',
                            scope: $scope,
                            appendTo: parentElem
                        });

                    },
                    cancel: function () {
                        $scope.cancelDialog.modalInstance.dismiss('cancel');
                       // $scope.cancelDialog.modalInstance = null;
                    }

                };
                modalAdapterService.add($scope.cancelDialog);
                // remove self from modal service when directive is destroyed
                $scope.$on('$destroy', function () {
                    modalAdapterService.remove(attrs.id, $scope.cancelDialog.parentID);
                    $element.remove();
                });
            }
        };
    }]);

