﻿// web service proxy for role
webservices.factory('assetListService', ['$http', 'apiConfig', function ($http, apiConfig) {
    'use strict';
    return {
        getAssetListData: function () {
            return $http.get('/asset/getAssetListData', apiConfig.create());
        },
        getAssetResultList: function (assetType,projectId, taxAccountCompare) {
            return $http.get('/asset/getAssetResultList?assetType=' + assetType + '&projectId=' + projectId + '&taxAccountCompare=' + taxAccountCompare, apiConfig.create());
        },
        getAssetResultListPage: function (citAssetsListDto) {
            debugger;
            return $http.post('/asset/getAssetResultListPage', citAssetsListDto, apiConfig.create());
        },
        getAssetGroupResultData: function (projectId) {
            return $http.get('/asset/getAssetGroupResultData?projectId=' + projectId, apiConfig.create());
        },
        getAssetGroupListData: function () {
            return $http.get('/asset/getAssetGroupListData', apiConfig.create());
        },
        getAssetDetailGroupListData: function () {
            return $http.get('/asset/getAssetDetailGroupListData', apiConfig.create());
        },
        saveAssetGroupInfo:function (assetGroupResults,saveGroupType,projectId) {
            return $http.post('/asset/saveAssetGroupInfo?saveGroupType=' + saveGroupType + '&projectId=' + projectId,assetGroupResults, apiConfig.create());
        },
        updateAssetResultList:function (assetsList,projectId) {
            return $http.post('/asset/updateAssetResultList?projectId=' + projectId,assetsList, apiConfig.create());
        },
        batchUpdateIsRetain:function (assetType,projectId, isRetain) {
            return $http.post('/asset/batchUpdateIsRetain?assetType=' + assetType + '&projectId=' + projectId + '&isRetain=' + isRetain, apiConfig.create());
        },
        getAllFixedAssetDetailGroup: function (assetGroupType,pageIndex,pageSize) {
            return $http.post('/asset/getFixedAssetDetailGroup',{"assetGroupType":assetGroupType,"pageIndex":pageIndex,"pageSize":pageSize}, apiConfig.create());
        }
    };
}]);