﻿// web service proxy for role
webservices.factory('businessUnitService', ['$http', 'apiConfig', function ($http, apiConfig) {
    'use strict';
    return {
        getBusinessUnitList: function () {
            return $http.get('/businessunit/getlist', apiConfig.create());
        },
        updateBusinessUnit: function (organizationStructure) {
            return $http.put('/businessunit', organizationStructure, apiConfig.create());
        },
        addBusinessUnit: function (organizationStructure) {
            return $http.post('/businessunit/add', organizationStructure, apiConfig.create());
        },
        deleteBusinessUnit: function (id) {
            return $http.post('/businessunit/delete', { id: id }, apiConfig.create());
        }
    };
}]);