﻿// registration web service proxy
webservices.factory('tempStorageService', ['$http', 'apiConfig', function ($http, apiConfig) {
    'use strict';
    return {
        ifTempStorageExist: function (userId, name) {
            return $http.get('/tempStorage/ifExist/' + userId + '/' + name, apiConfig.create());
        },
        getTempStorage: function (userId, name) {
            return $http.get('/tempStorage/storage/' + userId + '/' + name, apiConfig.create());
        },
        setTempStorage: function (userId, name, content) {
            return $http.put('/tempStorage/storage/' + userId + '/' + name, angular.toJson(content), apiConfig.create());
        },
        removeTempStorage: function (userId, name) {
            return $http.delete('/tempStorage/storage/' + userId + '/' + name, apiConfig.create());
        },
        clearTempStorage: function () {
            return $http.delete('/tempStorage/clear', apiConfig.create());
        }
    };
}]);