﻿citModule.controller('processLogController', ['$scope', '$log', '$translate', '$timeout', '$q', '$interval'
    , 'apiInterceptor', 'Upload', 'vatImportService', 'SweetAlert', 'uiGridConstants', '$uibModal'
    , 'vatSessionService', 'enums',
    function ($scope, $log, $translate, $timeout, $q, $interval
        , apiInterceptor, Upload, vatImportService, SweetAlert, uiGridConstants, $uibModal
        , vatSessionService, enums) {
        'use strict';

        $scope.pleaseSelect = $translate.instant('PleaseSelect');
        $scope.startDate = new Date(new Date().getFullYear() - 20, 1, 1);
        $scope.endDate = new Date(new Date().getFullYear() + 20, 1, 1);
        $scope.viewMode = 'days';

        $scope.period = $scope.periodId;
        $scope.moduleid = enums.vatModuleEnum.Import_TrialBalance;
        $scope.chunkSize = 100000;
        $scope.projectID = vatSessionService.project.id;
        $scope.startRowNum = 2;
        var date = new Date();
        var year = date.getFullYear();
        var month = date.getMonth()+1;
        var day = date.getDate();

        $scope.selectedDate = new Date(vatSessionService.year, vatSessionService.month - 1, 1);
        $scope.viewMode = 1;
        $scope.dateFormat = $translate.instant('dateFormat4YearMonth');

        //初始化ack-pagination
        $scope.pagingOptions = {
            pageIndex: 1, //当前页码
            totalItems: 0, //总数据
            totalPages: 10, //总页数
            maxSize: 5, //分页数字的限制。
            pageSize: constant.page.pageSizeArrary[3], //每页多少条数据,100条
            pageSizeString: constant.page.pageSizeArrary[3].toString(),
            firstPage: $translate.instant('PagingFirstPage'),
            previousPage: $translate.instant('PagingPreviousPage'),
            nextPage: $translate.instant('PagingNextPage'),
            lastPage: $translate.instant('PagingLastPage')
        };

        //初始化查询参数
        $scope.queryParams = {
            pageInfo: {
                pageIndex: 1, //当前页码
                totalItems: 0, //总数据
                totalPages: 10, //总页数
                maxSize: 5, //分页数字的限制。
                pageSize: constant.page.pageSizeArrary[3], //每页多少条数据,100条
                pageSizeString: constant.page.pageSizeArrary[3].toString(),
                firstPage: $translate.instant('PagingFirstPage'),
                previousPage: $translate.instant('PagingPreviousPage'),
                nextPage: $translate.instant('PagingNextPage'),
                lastPage: $translate.instant('PagingLastPage')
            },
            startDate: year+'/'+month+'/'+day,
            endDate : year+'/'+month+'/'+day
        };

        var loadProcessLogInfoDatagrid = function () {
            $scope.processLogGridOptions = {
                bindingOptions: {
                    dataSource: 'ProcessLogGridSource'
                },
                showBorders: true,
                columns: [{
                    dataField: "id",
                    visible: false,
                    allowHeaderFiltering: false,
                    caption: $translate.instant('id')
                }, {
                    dataField: "companyCode",
                    width: '15%',
                    allowHeaderFiltering: false,
                    caption: $translate.instant('CompanyCode')
                }, {
                    dataField: "companyName",
                    allowHeaderFiltering: false,
                    caption: $translate.instant('CompanyName'),
                    width: '14%'
                }, {
                    dataField: "tmsPeriod",
                    allowHeaderFiltering: false,
                    width: '8%',
                    caption: $translate.instant('TMSPeriod')
                }, {
                    dataField: "period",
                    allowHeaderFiltering: false,
                    width: '8%',
                    caption: $translate.instant('Period')
                }, {
                    dataField: "validateContent",
                    allowHeaderFiltering: false,
                    width: '15%',
                    caption: $translate.instant('ValidateContent')
                }, {
                    dataField: "validateResult",
                    allowHeaderFiltering: false,
                    width: '10%',
                    caption: $translate.instant('ValidateResult')
                }, {
                    dataField: "result",
                    allowHeaderFiltering: false,
                    width: '15%',
                    caption: $translate.instant('ResultMsg')
                }, {
                    dataField: "validateUser",
                    allowHeaderFiltering: false,
                    width: '10%',
                    caption: $translate.instant('Operater')
                }, {
                    dataField: "createTime",
                    allowHeaderFiltering: false,
                    dataType : "date",
                    width: '10%',
                    caption: $translate.instant('OperateTime')
                }
                ],
                onContentReady: function (e) {
                    $scope.accountingRateListInstance = e.component;
                    var totalCount = e.component.totalCount();
                    if (totalCount > 0) {
                        $scope.totalCount = totalCount;
                    }
                },
                loadPanel: {
                    enabled: false
                },
                selection: {
                    mode: "single"
                },
                grouping: {
                    autoExpandAll: false
                },
                allowColumnResizing: true,
                columnAutoWidth: true,
                showRowLines: true,
                showColumnLines: true,
                rowAlternationEnabled: true,  //单双行颜色
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                searchPanel: {
                    placeholder: $translate.instant('Search'),
                    width: 518,
                    visible: true
                },
                headerFilter: {
                    visible: false,
                    texts: {
                        cancel: $translate.instant('Cancel'),
                        ok: $translate.instant('Confirm'),
                        emptyValue: $translate.instant('Empty'),
                        selectAllText: $translate.instant('SelectAll')
                    }
                }
            };
            getProcessLog();
        };

        var getProcessLog = function () {
            vatImportService.displayProcessLog($scope.queryParams).success(function (data) {
                if (data && data.list) {
                    $scope.ProcessLogGridSource = data.list;
                    $scope.pagingOptions.totalItems = data.pageInfo.totalCount;
                }else {
                    SweetAlert.error($translate.instant('SystemError'));
                }
            });
        };

        var initPagingControl = function (totalItemsCount) {
            $scope.pagingOptions.totalItems = totalItemsCount;
        };

        // 检查用户机构权限
        var checkUserOrganizationPermissionList = function () {
            var list = [];
            var userManageTemp = constant.vatPermission.dataImport.balanceSheet;
            list.push(userManageTemp.importCode);
            $scope.hasImportPermission = false;
            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasImportPermission = data[userManageTemp.importCode];
            });
        };


        //控制明细信息中删除权限
        var getUserPermission = function () {
            var list = [];
            var code = constant.vatPermission.dataImport.balanceSheet.importCode;
            list.push(code);

            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasEditPermission = data[code];
            });
        };


        var setButtonWrapStyle = function () {
            if ($scope.fileName) {
                return { width: "100%" };
            }
        };

        var setGridStyle = function () {
            if ($scope.showTotalSecondRow) {
                return { 'margin-top': '60px' }
            }
            else {
                return { 'margin-top': '55px' }
            }
        };
        var initDatePicker = function () {
            var ele = $(".startDatepicker");
            ele.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                viewMode: $scope.viewMode,
                minViewMode: $scope.viewMode,
                autoclose: true, //选中之后自动隐藏日期选择框
                clearBtn: true, //清除按钮
                todayBtn: false, //今日按钮
                format: 'yyyy/mm/dd' //日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            });
            ele.datepicker("setDate", new Date().formatDateTime('yyyy/mm/dd'));
            var ele2 = $(".endDatepicker");
            ele2.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                viewMode: $scope.viewMode,
                minViewMode: $scope.viewMode,
                autoclose: true, //选中之后自动隐藏日期选择框
                clearBtn: true, //清除按钮
                todayBtn: false, //今日按钮
                format: 'yyyy/mm/dd' //日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            });
            ele2.datepicker("setDate", new Date().formatDateTime('yyyy/mm/dd'));
        };

        var initParam = function () {
            $scope.initPagingControl = initPagingControl;
            $scope.setButtonWrapStyle = setButtonWrapStyle;
            $scope.setGridStyle = setGridStyle;
            $scope.$watch('queryParams.startDate', function (newValue, oldValue) {
                getProcessLog();
            });
            $scope.$watch('queryParams.endDate', function (newValue, oldValue) {
                getProcessLog();
            });
        };

        //开始
        (function initialize() {
            $log.debug('ImportLogController.ctor()...');
            initParam();
            checkUserOrganizationPermissionList();
            getUserPermission();
            loadProcessLogInfoDatagrid();
            initDatePicker();
            $timeout(function () {
                $scope.isLoadComplete = true;
            }, 500);
        })();
    }
]);