﻿frameworkModule.directive('appOverview', ['$log', 'region', 'enums',
    function ($log, region, enums) {
        'use strict';

        $log.debug('appOverview.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/framework/app-overview/app-overview.html' + '?_=' + Math.random(),
            replace: true,
            scope: {
                servicetypeid : '='
            },
            controller: 'appOverviewController',
            link: function ($scope, $element, $attr) {
                var ele = $(".datepicker");
                ele.datepicker({
                    startDate: $scope.startDate,
                    endDate: $scope.endDate,
                    language: region,
                    viewMode: 1,
                    minViewMode: 1,
                    autoclose: true,//选中之后自动隐藏日期选择框
                    clearBtn: false,//清除按钮
                    todayBtn: false,//今日按钮
                    format: $scope.dateFormat//日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
                }).on('changeDate', function (e) {
                    $scope.changeDate(e);
                });
                ele.datepicker("setDate", $scope.selectedDate);
                $scope.elePicker = ele;


            
            }
        };
    }
]);