frameworkModule
    .controller('appTaxAnalysisController', ['$scope','$log', 'SweetAlert', '$translate', 'menuService', '$timeout', 'userService', 'loginContext', 'Upload', 'apiInterceptor','$state',
        function ($scope,$log, SweetAlert, $translate, menuService, $timeout, userService, loginContext, Upload, apiInterceptor,$state) {
            'use strict';

            $log.debug('appTaxAnalysisController.ctor()...');

            $scope.toggleMenu = function () {
                $rootScope.$broadcast(enums.adminEvent.layoutChanged);
            };

            userService.getUserPermission(loginContext.userName).success(function (data) {
                $timeout(function () {
                    menuService.getMenusForDisplay(4, loginContext.userId).success(function (menuData) {
                        $scope.menuData = menuData;
                    });
                }, 500);
            });

            $scope.loginUser = loginContext.userName;
            $scope.specialUser = $scope.loginUser.toLowerCase();

            $scope.convertTo2BitNumber = function (number) {
                var str = "" + number;
                var pad = "00";
                return pad.substring(0, pad.length - str.length) + str;
            };

            (function initialize() {
                $log.debug('appTaxAnalysisController.initialize()...');
            })();
        }
    ]);
