﻿vatDashboardModule.controller('OrganizationDashboardController', ['$scope', '$location', '$log', '$uibModal', '$compile', '$translate', '$timeout', '$q', '$interval',
    'apiInterceptor', 'SweetAlert', 'dashboardConfigSummaryService', '$stateParams', 'vatSessionService', 'modelConfigurationService',
    'canvasUtil','vatDashboardService',
    function ($scope, $location, $log, $uibModal, $compile, $translate, $timeout, $q, $interval, apiInterceptor, SweetAlert, dashboardConfigSummaryService, $stateParams,
        vatSessionService, modelConfigurationService, canvasUtil, vatDashboardService) {
        'use strict';
        // $log.debug('vatTaxDifferenceController.ctor()...');
        $scope.grid = {
            differenceOptions: {
                height:'600px',
                bindingOptions: {
                    dataSource: 'differenceList'
                },
                keyExpr: "id",
                noDataText: $translate.instant('AccountVoucher_DataGrid_NoDataText'),
                parentIdExpr: "head_ID",
                expandedRowKeys: [1],
                showBorders: false,
                showColumnLines: false,
                showRowLines:false,
                columnAutoWidth: true,
                autoExpandAll:true,
                columns: [
                    { dataField: 'typeName', caption: $translate.instant('IncomeType') },
                    { dataField: 'description', caption: "栏次" },
                    { dataField: 'amount', caption: "税务系统", format: { type: 'fixedPoint', precision: 2 } }
                ],
                selection: {
                    mode: "single"
                },
                onRowPrepared: function (info) {
                    if (info.rowType != 'header') {
                        if (info.data.head_ID === "0") {
                            info.rowElement.addClass('top-category');
                        }
                    }

                }
            },
            reasonOptions: {
                height: '600px',
                bindingOptions: {
                    dataSource: 'reasonList'
                },
                keyExpr: "id",
                parentIdExpr: "head_ID",
                expandedRowKeys: [1],
                showBorders: false,
                showColumnLines: false,
                showRowLines: false,
                columnAutoWidth: true,
                autoExpandAll: true,
                columns: [
                    { dataField: 'name', caption: "会计科目" },
                    { dataField: 'desc', caption: "明细字段" },
                    { dataField: 'amount', caption: $translate.instant('Amount'), format: { type: 'fixedPoint', precision: 2 } },
                    { dataField: 'desc', caption: $translate.instant('Description') },
                    { dataField: 'name', caption: $translate.instant('DifferenceReason') }
                ],
                onRowPrepared: function (info) {
                    if (info.rowType != 'header') {
                        if (info.data.head_ID==="0") {
                            info.rowElement.addClass('top-category');
                        }

                        if (info.data.id === 'total') {
                            info.rowElement.addClass('table-summary');
                        }
                    }

                }

            }
        };

        $scope.toggleAllMasterRows = function ($event) {
            var expand = "dx-datagrid-group-closed";
            var collapse = "dx-datagrid-group-opened";
            if ($($event.target).hasClass(expand)) {
                $scope.gridInstance.expandAll(-1);
                $($event.target).removeClass(expand);
                $($event.target).addClass(collapse);
            } else {
                $scope.gridInstance.collapseAll(-1);
                $($event.target).removeClass(collapse);
                $($event.target).addClass(expand);
            }
        };
        var initData = function () {
            $scope.differenceList = [];
            $scope.reasonList = [];
            // getService.getDifferenceList();
            // getService.getReasonList();
        };

        (function () {
            initData();
        })();
    }
]);