﻿vatModule.controller('ProductItemImportController', ['$scope', '$log', 'loginContext', '$translate', 'apiInterceptor', 'Upload', 'dataImportService', 'SweetAlert', 'vatImportService', '$timeout', '$q', 'enums', 'uiGridConstants', '$interval', 'vatSessionService', 'vatOperationLogService', 'projectService', 'vatCommonService', 'productService',
function ($scope, $log, loginContext, $translate, apiInterceptor, Upload, dataImportService, SweetAlert, vatImportService, $timeout, $q, enums, uiGridConstants, $interval, vatSessionService, vatOperationLogService, projectService, vatCommonService, productService) {
    'use strict';

    var uploadUrl = apiInterceptor.vatWebApiHostUrl + '/FileUpload/NewFile';
    var successCount = 0;
    $scope.chunkSize = 100000;
    var resumable = true;
    $scope.columnNum = 0;
    //从页面顶部的选择月份获取月份跟年份
    var curPeriod = vatSessionService.month;
    var curYear = vatSessionService.project.year;
    var projectID = vatSessionService.project.id;
    var projectId = vatSessionService.project.id;
    $scope.showImportTable = false;//是否显示导入table
    $scope.showInitTable = false;//是否显示初始数据ui-grid
    $scope.showErrorTable = false;//是否显示错误信息列表

    //写日志
    //导入方式
    $scope.importEnum = { Import: 0, CoverImport: 1, AddImport: 2 };
    var comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年" + vatSessionService.month + "月";
    $scope.period = vatSessionService.month;
    $scope.moduleid = enums.vatModuleEnum.Import_JournalEntry;
    var logDto = {
        ID: '',
        OperationName: '',
        ModuleID: $scope.moduleid,
        OperationObject: $translate.instant('JournalEntryTitle'),
        OperationType: '',
        OperationContent: '',
        OriginalState: '',
        UpdateState: '',
        CreatorID: vatSessionService.logUser.ID,
        Comment: comment,
        IP: '',
        Period: $scope.period,
    };

    var validationErrorType = {
        ColumnsMapErrorType: $translate.instant('ColumnsMapErrorType'),
        JournalEntryVIDEmptyErrorType: $translate.instant('JournalEntryVIDEmptyErrorType'),
        JournalEntryGroupEmptyErrorType: $translate.instant('JournalEntryGroupEmptyErrorType'),
        JournalEntryItemIDEmptyErrorType: $translate.instant('JournalEntryItemIDEmptyErrorType'),
        JournalEntryAcctCodeEmptyErrorType: $translate.instant('JournalEntryAcctCodeEmptyErrorType'),
        JournalEntryVoucherDateEmptyErrorType: $translate.instant('JournalEntryVoucherDateEmptyErrorType'),
        JournalEntryDateFormatErrorType: $translate.instant('JournalEntryDateFormatErrorType'),
        JournalEntryAmountErrorType: $translate.instant('JournalEntryAmountErrorType'),
        JournalEntryItemIDFormatErrorType: $translate.instant('JournalEntryItemIDFormatErrorType'),
        JournalEntryPeriodFormatErrorType: $translate.instant('JournalEntryPeriodFormatErrorType'),
        NumOutRangeErrorType: $translate.instant('NumOutRangeErrorType'),
        OutputStringLengthType: $translate.instant('OutputStringLengthType'),
        StartRowError: $translate.instant('StartRowError')
    };

    //初始化列数据
    var initColumns = function () {
        //初始化进项发票汇总表列名（包括请选择列）
        $scope.journalEntryColumns = [
            $translate.instant('PleaseSelectColumn'),
            $translate.instant('JournalPZRQ'),
            $translate.instant('JournalPZLX'),
            $translate.instant('JournalPZH'),
            $translate.instant('JournalFLH'),
            $translate.instant('JournalQJ'),
            $translate.instant('JournalKMDM'),
            $translate.instant('JournalZY'),
            $translate.instant('JournalJFJE'),
            $translate.instant('JournalDFJE'),
            $translate.instant('JournalKHDM')
        ];

        $scope.initJournalEntryColumnsIndex = _.range(1, $scope.journalEntryColumns.length);

        //序时账所有列
        $scope.journalEntryAllColumns = [
           $translate.instant('JournalPZRQ'),
           $translate.instant('JournalPZLX'),
           $translate.instant('JournalPZH'),
           $translate.instant('JournalFLH'),
           $translate.instant('JournalQJ'),
           $translate.instant('JournalKMDM'),
           $translate.instant('JournalZY'),
           $translate.instant('JournalJFJE'),
           $translate.instant('JournalDFJE'),
           $translate.instant('JournalKHDM')
        ];

        //必须进行map的列
        $scope.mustMappingTotalColumns = [
            $translate.instant('JournalPZRQ'),
            $translate.instant('JournalPZLX'),
            $translate.instant('JournalPZH'),
            $translate.instant('JournalFLH'),
            $translate.instant('JournalKMDM'),
            $translate.instant('JournalJFJE'),
            $translate.instant('JournalDFJE'),
            $translate.instant('JournalKHDM')
        ];
    };

    //从数据库中load数据，如果有，则页面导入按钮为覆盖导入或追加导入，否则为导入按钮
    var loadJournalEntryDataFromDB = function () {
        productService.getProductItemList().success(function (data) {
            if (data) {
                $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
                var index = 1;
                data.forEach(function (v) {
                    v.index = index++;
                });

                $scope.initJournalEntryList = data;
                $scope.gridOptionsJournalEntry.data = data;
                //当数据库中数据>=0时，就显示初始化数据ui-grid，
                //但是需要当数据库中数据大于0时才不显示导入按钮，而显示覆盖导入和追加导入按钮
                if (data.length >= 0) {
                    if (data.length > 0) {
                        $scope.isShowImportTotalBtn = false;
                    }
                    $scope.showInitTable = true;
                    $scope.showImportTable = false;
                }

                if (data && data.length > 0) {
                    $scope.gridOptionsJournalEntry.columnDefs = [
                        { name: '产品编号', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fSetCode}}<span></div>' },
                        { name: '产品名称', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fSetName}}<span></div>' },
                        { name: '科目代号', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctCode}}<span></div>' },
                        { name: '科目名称', width: '20%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctName}}<span></div>' },
                        { name: '科目类别', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctClass}}<span></div>' },
                        { name: '科目性质', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctAttr}}<span></div>' },
                        { name: '卖出金额汇总', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fcjje}}<span></div>' },
                        { name: '计税基数余额', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.bjsjzye}}<span></div>' },
                        { name: '应税状态', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fyszt}}<span></div>' }
                    ];
                }
                else {
                    $scope.gridOptionsJournalEntry.columnDefs = [
                       { name: '产品编号', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fSetCode}}<span></div>' },
                       { name: '产品名称', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fSetName}}<span></div>' },
                       { name: '科目代号', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctCode}}<span></div>' },
                       { name: '科目名称', width: '20%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctName}}<span></div>' },
                       { name: '科目类别', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctClass}}<span></div>' },
                       { name: '科目性质', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctAttr}}<span></div>' },
                       { name: '卖出金额汇总', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fcjje}}<span></div>' },
                       { name: '计税基数余额', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.bjsjzye}}<span></div>' },
                       { name: '应税状态', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fyszt}}<span></div>' }
                    ];
                }
            }
        });
    };

    //序时账选择列名事件
    //parentIndex：当前列号
    //index：下拉列表中选项的序号
    var mappingColumn = function (parentIndex, index, colName) {
        if (colName) {

            var oldColumn = $scope.selectedColumnMap[parentIndex];
            var newColumn = $scope.journalEntryColumns[index];

            //如果新的选择项与老的选择项一致，则不进行操作
            if (oldColumn === newColumn) {
                return;
            }
            else {
                $scope.selectedColumnMap[parentIndex] = colName;

                if (colName !== $translate.instant('PleaseSelectColumn')) {
                    //如果当前选择的不是"请选择列名",则将选项从数组中移除
                    $scope.journalEntryColumns.splice(index, 1);

                    if (oldColumn && oldColumn !== $translate.instant('PleaseSelectColumn')) {
                        //将老的选项追加到选项列表中
                        $scope.journalEntryColumns.push(oldColumn);
                    }
                }
                else {
                    //如果当前选中的是"请选择列名",则将该列原来的列名追加到选项列表中
                    if (oldColumn) {
                        $scope.journalEntryColumns.push(oldColumn);
                    }
                }
            }
        }
        //$log.debug($scope.selectedColumnMap);
    };

    //设置上传文件的文件名
    var updateJournalEntryFileName = function (newValue) {
        $scope.fileName = newValue.name;
    };

    var token = $('input[name="__RequestVerificationToken"]').val();
    //上传文件
    var doUploadJournalEntryFile = function (file) {
        if (file) {
            var arr = file.name.split('.');
            if (arr[arr.length - 1] !== 'xls' && arr[arr.length - 1] !== 'xlsx') {
                SweetAlert.warning($translate.instant('ImportFileInvalidType'));
                return;
            }
            $scope.initJournalEntryList = [];
            $scope.gridOptionsJournalEntry.data = [];
            successCount = 0;
            if (!file.$error) {
                var tempFileName = PWC.newGuid() + '.dat';
                Upload.upload({
                    url: uploadUrl,
                    data: {
                        filename: file.name,
                        tempFileName: tempFileName,
                        file: file
                    },
                    resumeChunkSize: resumable ? $scope.chunkSize : null,
                    headers: {
                        'Access-Control-Allow-Origin': '*',
                        Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken()
                    },
                    __RequestVerificationToken: token,
                    withCredentials: true
                }).then(uploadJournalEntrySuccess);
            }
        }
    };

    //上传成功后执行函数
    var uploadJournalEntrySuccess = function (resp) {
        console.log(resp);
        successCount++;
        if (successCount === 1) {
            $scope.tempFileName = resp.data;
            //初始化到excel文件的第一个sheet
            changeJournalEntrySheet(0);
        }
    };

    //初始化需要展示的sheet
    var changeJournalEntrySheet = function (selectedSheet) {
        var sheetIndex = _.findIndex($scope.sheetData.sheetNameList, function (num) {
            return num.name === selectedSheet.name;
        })
        $scope.sheetInfo.selectedSheetIndex = sheetIndex === -1 ? 0 : sheetIndex;
        refreshJournalEntryTable();
    };

    //重新load页面上的table
    var refreshJournalEntryTable = function () {
        //在切换显示页面导入数据时，直接设置初始化数据ui-grid表不可见，错误信息不可见
        //导入数据表格可见
        $scope.showImportTable = true;
        $scope.showErrorTable = false;
        $scope.showInitTable = false;

        if (_.isString($scope.tempFileName)) {
            $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
            $scope.columnNum = 0;
            $scope.selectedColumnMap = [];
            vatImportService.getFileContent($scope.tempFileName, $scope.sheetInfo.selectedSheetIndex, $scope.sheetInfo.topRowNumber).success(function (data) {

                //将导入文件的sheet赋值到数组
                $scope.sheetData = data;
                //加入index序号
                var index = 1;
                data.dataList.forEach(function (v) {
                    v.index = index++;
                });
                var sheetNameObjectArray = [];
                data.sheetNameList.forEach(function (v) {
                    sheetNameObjectArray.push({ 'name': v });
                });
                $scope.sheetData.sheetNameList = sheetNameObjectArray;

                $scope.columnNum = data.dataList[0] ? data.dataList[0].length : $scope.columnNum;
                $scope.firstDataRow = data.dataList[0];
                $scope.startRowList = _.range(data.lastRowIndex);
                $scope.sheetInfo.selectedSheetName = $scope.sheetData.sheetNameList[$scope.sheetInfo.selectedSheetIndex];
                initColumns();
                vatSessionService.dataChanged = true; //设置为true表示在切换页面前数据有变更, 需要提示

                if (data & data.result === false) {
                    SweetAlert.warning(data.resultMsg);
                    return;
                }
            });
        }
    };


    //对导入数据进行验证(前端)
    var FrontEndValidJournalEntryData = function (journalEntryList) {
        //2:验证关键字段不为空（凭证号，凭证类型，分录号，科目代码）
        //3:验证日期、金额格式、期间格式、分录号格式是否正确
        if (!KeyColumnsEmptyValid(journalEntryList)) {
            return;
        }

        //4:所有验证都通过后，筛选符合期间条件的数据进库
        FilterPeriodData(journalEntryList);

    };

    //1.判断是否有没有map的必须列和起始行输入格式是否正确
    var ColumnsMapCheck = function () {
        var result = true;
        var notMappedColumns = '';
        if ($scope.selectedColumnMap.length >= 0) {
            var count1 = 0;
            $scope.mustMappingTotalColumns.forEach(function (m) {
                if (m !== $translate.instant('PleaseSelectColumn')) {
                    if ($.inArray(m, $scope.selectedColumnMap) < 0) {
                        notMappedColumns += m + ',';
                        count1++;
                    }
                }
            });
            if (count1) {
                result = false;
                //加入到错误列表中
                $scope.errorMsgMap.push(
                    {
                        'errorType': validationErrorType.ColumnsMapErrorType,
                        'errorCount': count1,
                        'errorContent': $translate.instant('ColumnsMapErrorMsg').formatObj({ columns: notMappedColumns.substring(0, notMappedColumns.length - 1) })
                    });
            }
        }
        //2:判断起始行输入框输入内容是否合理
        var startNumberCheckMsg = '';
        var startRowNum = $('#StartRowNum').val();
        if (startRowNum === '') {
            result = false;
            $scope.errorMsgMap.push(
                    {
                        'errorType': validationErrorType.StartRowError,
                        'errorCount': 1,
                        'errorContent': $translate.instant('StartRowNull')
                    });
        }
        else if (parseInt(startRowNum) > $scope.sheetData.dataList.length) {
            result = false;
            $scope.errorMsgMap.push(
                    {
                        'errorType': validationErrorType.StartRowError,
                        'errorCount': 1,
                        'errorContent': $translate.instant('StartRowNumberCheckMsg')
                    });
        }
        return result;
    };

    //2.验证关键字段不为空（凭证号，凭证类型，分录号，科目代码）
    //3.验证日期、金额格式、期间格式、分录号格式是否正确
    var KeyColumnsEmptyValid = function (journalEntryList) {
        var result = true;
        //#region 定义错误信息

        //凭证号为空
        var VIDEmptyCheckMsg = '';
        var VIDEmptyCheckCount = 0;
        //凭证类型为空
        var GroupEmptyCheckMsg = '';
        var GroupEmptyCheckCount = 0;
        //分录号为空
        var ItemIDEmptyCheckMsg = '';
        var ItemIDEmptyCheckCount = 0;
        //科目代码为空
        var AcctCodeEmptyCheckMsg = '';
        var AcctCodeEmptyCheckCount = 0;
        //验证凭证日期为空
        var VoucherDateEmptyErrorMsg = '';
        var VoucherDateEmptyErrorCount = 0;

        //验证凭证日期格式错误
        var VourcharDateFormatErrorMsg = '';
        var VourcharDateFormatErrorCount = 0;

        //验证借方金额、贷方金额格式错误
        var AmountFormatErrorMsg = '';
        var AmountFormatErrorCount = 0;

        //验证期间是否是正整数
        var PeriodFormatErrorMsg = '';
        var PeriodFormatErrorCount = 0;

        //验证分录号是否为正整数
        var ItemIDFormatErrorMsg = '';
        var ItemIDFormatErrorCount = 0;

        //数据范围超出范围
        var numOutRangeCheckMsg = '';
        var numOutRangeCheckCount = 0;

        //字符长度过长验证
        var stringOverLengthCheckMsg = '';
        var stringOverLengthCheckCount = 0;

        //#endregion

        //#region 验证错误信息
        journalEntryList.forEach(function (m) {
            var curRowInfo = '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' +
                            $translate.instant('JournalPZH') + ':' + m.VID + ',' +
                            $translate.instant('JournalPZLX') + ':' + m.Group + ',' +
                            $translate.instant('JournalFLH') + '：' + m.ItemID + ';<br />';
            //凭证号为空
            if (PWC.isNullOrEmpty(m.VID)) {
                VIDEmptyCheckCount++;
                VIDEmptyCheckMsg += curRowInfo;
            }
            else {
                //如果凭证号超过50个字符
                if (m.VID.length > constant.validateLength.StringLength_50) {
                    stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('JournalPZH') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                    stringOverLengthCheckCount++;
                }
            }

            //凭证类型为空
            if (PWC.isNullOrEmpty(m.Group)) {
                GroupEmptyCheckCount++;
                GroupEmptyCheckMsg += curRowInfo;
            }
            else {
                //如果凭证类型超过50个字符
                if (m.Group.length > constant.validateLength.StringLength_50) {
                    stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('JournalPZLX') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                    stringOverLengthCheckCount++;
                }
            }

            //分录号为空
            if (PWC.isNullOrEmpty(m.ItemID)) {
                ItemIDEmptyCheckCount++;
                ItemIDEmptyCheckMsg += curRowInfo;
            }
            else {
                //如果分录号超过50个字符
                if (m.ItemID.length > constant.validateLength.StringLength_50) {
                    stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('JournalFLH') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                    stringOverLengthCheckCount++;
                }
            }

            //科目代码为空
            if (PWC.isNullOrEmpty(m.AcctCode)) {
                AcctCodeEmptyCheckCount++;
                AcctCodeEmptyCheckMsg += curRowInfo;
            }
            else {
                //如果科目代码超过50个字符
                if (m.AcctCode.length > constant.validateLength.StringLength_50) {
                    stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('JournalKMDM') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                    stringOverLengthCheckCount++;
                }
            }

            //凭证日期为空
            if (PWC.isNullOrEmpty(m.Date)) {
                VoucherDateEmptyErrorCount++;
                VoucherDateEmptyErrorMsg += curRowInfo;
            }
            else {
                //凭证日期格式错误
                if (!PWC.checkDate(m.Date)) {
                    VourcharDateFormatErrorMsg += curRowInfo;
                    VourcharDateFormatErrorCount++;
                }
            }

            //验证金额
            if (isNaN(parseFloat(m.Debit)) || isNaN(parseFloat(m.Credit))) {
                AmountFormatErrorMsg += curRowInfo;
                AmountFormatErrorCount++;
            }
            else {
                //如果在规定的数值范围外，则提示错误
                if (parseFloat(m.Debit) < constant.startNum || parseFloat(m.Debit) > constant.endNum) {
                    numOutRangeCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('JournalJFJE') + $translate.instant('NumOverLengthMsg') + '<br />';
                    numOutRangeCheckCount++;
                }
                else {
                    m.Debit = PWC.round(m.Debit, 2);
                }
                //如果在规定的数值范围外，则提示错误
                if (parseFloat(m.Credit) < constant.startNum || parseFloat(m.Credit) > constant.endNum) {
                    numOutRangeCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('JournalDFJE') + $translate.instant('NumOverLengthMsg') + '<br />';
                    numOutRangeCheckCount++;
                }
                else {
                    m.Credit = PWC.round(m.Credit, 2);
                }
            }

            //验证期间为正整数
            if (!PWC.isNullOrEmpty(m.Period)) {
                if (!PWC.isPositiveInteger(m.Period)) {
                    PeriodFormatErrorMsg += curRowInfo;
                    PeriodFormatErrorCount++;
                }
                else {
                    if (m.Period < 1 || m.Period > 12) {
                        numOutRangeCheckCount++;
                        numOutRangeCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('JournalQJ') + $translate.instant('PeriodOverLengthMsg') + ';<br />';
                    }
                }
            }

            //验证客户代码不能超过50个字符
            if (!PWC.isNullOrEmpty(m.CustomerCode) && m.CustomerCode.length > constant.validateLength.StringLength_50) {
                stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('JournalKHDM') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                stringOverLengthCheckCount++;
            }

            //摘要不能超过200个字符
            if (!PWC.isNullOrEmpty(m.Summary) && m.Summary.length > constant.validateLength.StringLength_200) {
                stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('JournalZY') + $translate.instant('OutputStringLengthMsg_200') + ';<br />';
                stringOverLengthCheckCount++;
            }
        });
        //#endregion 

        //#region 添加错误信息到错误列表

        //push凭证号空信息到错误列表
        if (VIDEmptyCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.JournalEntryVIDEmptyErrorType,
                    'errorCount': VIDEmptyCheckCount,
                    'errorContent': VIDEmptyCheckMsg
                });
        }
        if (GroupEmptyCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.JournalEntryGroupEmptyErrorType,
                    'errorCount': GroupEmptyCheckCount,
                    'errorContent': GroupEmptyCheckMsg
                });
        }
        if (ItemIDEmptyCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.JournalEntryItemIDEmptyErrorType,
                    'errorCount': ItemIDEmptyCheckCount,
                    'errorContent': ItemIDEmptyCheckMsg
                });
        }
        if (AcctCodeEmptyCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.JournalEntryAcctCodeEmptyErrorType,
                    'errorCount': AcctCodeEmptyCheckCount,
                    'errorContent': AcctCodeEmptyCheckMsg
                });
        }
        if (VoucherDateEmptyErrorCount > 0) {
            result = false;
            $scope.errorMsgMap.push(
               {
                   'errorType': validationErrorType.JournalEntryVoucherDateEmptyErrorType,
                   'errorCount': VoucherDateEmptyErrorCount,
                   'errorContent': VoucherDateEmptyErrorMsg
               });
        }
        if (VourcharDateFormatErrorCount) {
            result = false;
            //凭证日期格式错误
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.JournalEntryDateFormatErrorType,
                    'errorCount': VourcharDateFormatErrorCount,
                    'errorContent': VourcharDateFormatErrorMsg
                });
        }
        //金额格式错误
        if (AmountFormatErrorCount) {
            result = false;
            $scope.errorMsgMap.push(
               {
                   'errorType': validationErrorType.JournalEntryAmountErrorType,
                   'errorCount': AmountFormatErrorCount,
                   'errorContent': AmountFormatErrorMsg
               });
        }
        //验证期间为正整数
        if (PeriodFormatErrorCount) {
            result = false;
            $scope.errorMsgMap.push(
               {
                   'errorType': validationErrorType.JournalEntryPeriodFormatErrorType,
                   'errorCount': PeriodFormatErrorCount,
                   'errorContent': PeriodFormatErrorMsg
               });
        }
        //push字符串过长的错误信息到错误列表
        if (stringOverLengthCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push({
                'errorType': validationErrorType.OutputStringLengthType,
                'errorCount': stringOverLengthCheckCount,
                'errorContent': stringOverLengthCheckMsg
            });
        }
        //push数值超过范围的错误信息到列表
        if (numOutRangeCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push({
                'errorType': validationErrorType.NumOutRangeErrorType,
                'errorCount': numOutRangeCheckCount,
                'errorContent': numOutRangeCheckMsg
            });
        }

        //#endregion
        return result;
    };


    //4:筛选符合期间条件的数据进库
    var FilterPeriodData = function (journalEntryList) {
        //存放筛选后的数据
        $scope.journalEntryListFilter = [];
        //如果对应了期间列,则只筛选符合当前期间的数据进行导入，否则整个数据进行导入
        if ($.inArray($translate.instant('JournalQJ'), $scope.selectedColumnMap) > -1) {
            $scope.MapPeriodFlag = true;//是否对应了期间列
            $scope.AllDataSamePeriodFlag = true;//默认设置所有数据期间都一样

            journalEntryList.forEach(function (item) {
                if (parseInt(item.Period) === curPeriod) {
                    //截断过长的内容
                    item.Group = item.Group.substring(0, constant.validateLength.StringLength_50);
                    item.VID = item.VID.substring(0, constant.validateLength.StringLength_256);
                    item.AcctCode = item.AcctCode.substring(0, constant.validateLength.StringLength_50);
                    $scope.journalEntryListFilter.push(item);
                }
                else {
                    $scope.AllDataSamePeriodFlag = false;//是否所有的数据期间都相同，如果有一个不相同，则设置标志为false
                }
            });
        }
        else {
            $scope.MapPeriodFlag = false;//是否对应了期间列
            journalEntryList.forEach(function (item) {
                //截断过长的内容
                item.Group = item.Group.substring(0, constant.validateLength.StringLength_50);
                item.VID = item.VID.substring(0, constant.validateLength.StringLength_256);
                item.AcctCode = item.AcctCode.substring(0, constant.validateLength.StringLength_50);
                $scope.journalEntryListFilter.push(item);
            });
            $scope.journalEntryListFilter = journalEntryList;
        }
    };


    //点击导入按钮时，进行导入操作
    var importJournalEntryData = function (importType) {
        if (vatSessionService.project.projectStatusList[curPeriod] >= constant.ProjectStatusEnum.Generated) {
            swal({
                title: "warning!",
                text: $translate.instant('IsConfirmToReImport').formatObj({ status: vatCommonService.getProjectStautsEnumDesc(vatSessionService.project.projectStatusList[curPeriod]) }),
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#DD6B55",
                confirmButtonText: $translate.instant('Yes'),
                cancelButtonText: $translate.instant('No'),
                closeOnConfirm: true,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    doImportJournalEntryData(importType);
                }
                else {
                    swal.close();
                }
            });
        }
        else {
            doImportJournalEntryData(importType);
        }
    };


    function doImportJournalEntryData(importType) {
        if (!$scope.fileName) {
            SweetAlert.warning($translate.instant('PleaseSelectFileFirst'));
            return;
        }

        var importType = importType;//0：第一次导入，1：覆盖导入，2：追加导入

        //设置数据导入时的起始行,默认设置从第一行开始
        var startRowNum = 1;
        if ($('#StartRowNum').val()) {
            startRowNum = $('#StartRowNum').val();
        }

        //验证前，将错误数据清空
        $scope.errorMsgMap = [];

        //1：判断是否有没有map的必须列和起始行输入格式是否正确
        if (!ColumnsMapCheck()) {
            $('#errorListModal').modal('show');
            return;
        }


        //将需要导入的数据组装到list中
        var inputJournalEntryList = [];

        for (var i = startRowNum - 1; i < $scope.sheetData.dataList.length; i++) {
            var journalEntryInfo = {
                'Index': $scope.sheetData.dataList[i].index,//行号
                'Period': $.inArray($translate.instant('JournalQJ'), $scope.selectedColumnMap) > -1 ?
                    $scope.sheetData.dataList[i][$.inArray($translate.instant('JournalQJ'), $scope.selectedColumnMap)] : curPeriod,//期间
                'Date': $scope.sheetData.dataList[i][$.inArray($translate.instant('JournalPZRQ'), $scope.selectedColumnMap)],//凭证日期
                'Group': $scope.sheetData.dataList[i][$.inArray($translate.instant('JournalPZLX'), $scope.selectedColumnMap)],//凭证类型
                'VID': $scope.sheetData.dataList[i][$.inArray($translate.instant('JournalPZH'), $scope.selectedColumnMap)],//凭证号
                'ItemID': $scope.sheetData.dataList[i][$.inArray($translate.instant('JournalFLH'), $scope.selectedColumnMap)],//分录号
                'AcctCode': $scope.sheetData.dataList[i][$.inArray($translate.instant('JournalKMDM'), $scope.selectedColumnMap)],//科目代码
                'Summary': $.inArray($translate.instant('JournalZY'), $scope.selectedColumnMap) > -1 ?
                    $scope.sheetData.dataList[i][$.inArray($translate.instant('JournalZY'), $scope.selectedColumnMap)] : null,//摘要
                'Debit': PWC.isNullOrEmpty($scope.sheetData.dataList[i][$.inArray($translate.instant('JournalJFJE'), $scope.selectedColumnMap)]) ?
                    0 : $scope.sheetData.dataList[i][$.inArray($translate.instant('JournalJFJE'), $scope.selectedColumnMap)],//如果金额为空，则设置为0
                'Credit': PWC.isNullOrEmpty($scope.sheetData.dataList[i][$.inArray($translate.instant('JournalDFJE'), $scope.selectedColumnMap)]) ?
                    0 : $scope.sheetData.dataList[i][$.inArray($translate.instant('JournalDFJE'), $scope.selectedColumnMap)],//如果金额为空，则设置为0
                'CustomerCode': $scope.sheetData.dataList[i][$.inArray($translate.instant('JournalKHDM'), $scope.selectedColumnMap)],//客户代码
                'ImportType': enums.vatImportType.journalEntry,//导入类型
                'MonthID': $.inArray($translate.instant('JournalQJ'), $scope.selectedColumnMap) > -1 ?
                    $scope.sheetData.dataList[i][$.inArray($translate.instant('JournalQJ'), $scope.selectedColumnMap)] : null//如果用户对应了期间字段，则保存用户对应的期间，否则保存为null
            };
            inputJournalEntryList.push(journalEntryInfo);
        }

        //前台数据验证
//        FrontEndValidJournalEntryData(inputJournalEntryList); todo : to be future open (neo)

        if ($scope.errorMsgMap.length > 0) {
            $('#errorListModal').modal('show');
            return;
        }
        else {
            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = $scope.fileName;
            if (importType === $scope.importEnum.Import) {
                logDto.OperationName = $translate.instant('ImportJournalEntry');
                logDto.OperationType = enums.vatLogOperationTypeEnum.Import;
            }
            else if (importType === $scope.importEnum.CoverImport) {
                logDto.OperationName = $translate.instant('CoverImportJournalEntry');
                logDto.OperationType = enums.vatLogOperationTypeEnum.CoverImport;
            }
            else if (importType === $scope.importEnum.AddImport) {
                logDto.OperationName = $translate.instant('AddImportJournalEntry');
                logDto.OperationType = enums.vatLogOperationTypeEnum.AddImport;
            }

            getImportType().then(function () {
                //如果状态为0，则提示需要先导入TB，不能导入
                if ($scope.importStatus === enums.vatDataImportStatus.UnImported) {
                    SweetAlert.warning($translate.instant('JournalEntryImportErrorNotImportTBData'));
                }
                    //如果状态为1，则表示可以导入
                else if ($scope.importStatus === enums.vatDataImportStatus.TbImported) {
                    //如果没有选择期间，则系统给出导入所有数据的提示，确认后数据进库，否则，取消导入操作
                    if (!$scope.MapPeriodFlag) {
                        swal({
                            title: "warning!",
                            text: $translate.instant('NoPeriod'),
                            type: "warning",
                            showCancelButton: true,
                            confirmButtonColor: "#DD6B55",
                            confirmButtonText: $translate.instant('Yes'),
                            cancelButtonText: $translate.instant('No'),
                            closeOnConfirm: true,
                            closeOnCancel: true
                        },
                            function (isConfirm) {
                                if (isConfirm) {

                                    //数据进库
                                    vatImportService.importJournalEntryData($scope.journalEntryListFilter, importType).success(function () {
                                        logDto.UpdateState = $translate.instant('ImportSuccess');
                                        vatOperationLogService.addOperationLog(logDto);
                                        vatCommonService.importSetProjectStatus(curPeriod
                                                                               , constant.DictionaryDictKey.WFImportJournalEntry
                                                                               , enums.FinishStatusEnum.Finished);
                                        vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isEntryImport, true);
                                        $log.debug("import entry importJournalEntryData: " + vatSessionService.project.importSubStatus.isEntryImport);
                                        SweetAlert.success($translate.instant('ImportSuccess'));
                                        loadJournalEntryDataFromDB();
                                        $scope.fileName = '';
                                        vatSessionService.dataChanged = false;//设置为false表示在切换页面前数据没有变更,不需要提示
                                    }).error(function () {
                                        logDto.UpdateState = $translate.instant('ImportFail');
                                        vatOperationLogService.addOperationLog(logDto);
                                    });
                                }
                            });
                    }
                    else {
                        //如果要导入的数据中期间不一样，给出提示信息,否则直接进库
                        if (!$scope.AllDataSamePeriodFlag) {
                            swal({
                                title: "warning!",
                                text: $translate.instant('PeriodDifferenceTip'),
                                type: "warning",
                                showCancelButton: true,
                                confirmButtonColor: "#DD6B55",
                                confirmButtonText: $translate.instant('Yes'),
                                cancelButtonText: $translate.instant('No'),
                                closeOnConfirm: true,
                                closeOnCancel: true
                            },
                            function (isConfirm) {
                                if (isConfirm) {
                                    //数据进库
                                    vatImportService.importJournalEntryData($scope.journalEntryListFilter, importType).success(function () {
                                        logDto.UpdateState = $translate.instant('ImportSuccess');
                                        vatOperationLogService.addOperationLog(logDto);
                                        vatCommonService.setProjectStatus(project.id, curPeriod, constant.ProjectStatusEnum.Imported
                                            , constant.DictionaryDictKey.WFImportJournalEntry, enums.FinishStatusEnum.Finished);
                                        vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isEntryImport, true);
                                        $log.debug("import entry importJournalEntryData: " + vatSessionService.project.importSubStatus.isEntryImport);
                                        SweetAlert.success($translate.instant('ImportSuccess'));
                                        loadJournalEntryDataFromDB();
                                        $scope.fileName = '';
                                        vatSessionService.dataChanged = false;//设置为false表示在切换页面前数据没有变更,不需要提示
                                    }).error(function () {
                                        logDto.UpdateState = $translate.instant('ImportFail');
                                        vatOperationLogService.addOperationLog(logDto);
                                    });
                                }
                            });
                        }
                        else {
                            //数据进库
                            vatImportService.importJournalEntryData($scope.journalEntryListFilter, importType).success(function () {
                                logDto.UpdateState = $translate.instant('ImportSuccess');
                                vatOperationLogService.addOperationLog(logDto);
                                vatCommonService.setProjectStatus(project.id, curPeriod, constant.ProjectStatusEnum.Imported
                                    , constant.DictionaryDictKey.WFImportJournalEntry, enums.FinishStatusEnum.Finished);
                                vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isEntryImport, true);
                                $log.debug("import entry importJournalEntryData: " + vatSessionService.project.importSubStatus.isEntryImport);
                                SweetAlert.success($translate.instant('ImportSuccess'));
                                loadJournalEntryDataFromDB();
                                $scope.fileName = '';
                                vatSessionService.dataChanged = false;//设置为false表示在切换页面前数据没有变更,不需要提示
                            }).error(function () {
                                logDto.UpdateState = $translate.instant('ImportFail');
                                vatOperationLogService.addOperationLog(logDto);
                            });
                        }
                    }
                }
                    //如果状态为2，则提示财务数据已导入，不能导入
                else if ($scope.importStatus === enums.vatDataImportStatus.ErpImported) {
                    SweetAlert.warning($translate.instant('JournalEntryImportErrorERPDataImportedAlready'));
                }
            });
        }
    }


    //获取验证信息
    //var getValidationList = function () {
    //    var deferred = $q.defer();

    //    vatImportService.getValidationDtoInfo(enums.validationType.JournalEntry, curPeriod).success(function (data) {
    //        if (data.length > 0) {
    //            var index = 1;
    //            data.forEach(function (v) {
    //                v.index = index++;
    //            });
    //            $scope.errorList = data;
    //            //$scope.gridOptionsErrorMsg.data = data;
    //        }
    //        else {
    //            $scope.errorList = [];
    //            //$scope.gridOptionsErrorMsg.data = [];
    //        }
    //        deferred.resolve();
    //    });

    //    return deferred.promise;
    //}

    var showErrTab = function () {
        $scope.ImportErrorTab = true;//默认显示顶部block
        $scope.ImportErrorTag = true;//默认隐藏下方的错误信息列表
        $scope.errorMsg = $translate.instant('ImportErrorMsg').formatObj({ "NumberOfError": $scope.errorList.length });

    };

    $scope.getGridHeight = function () {
        if ($scope.isLoadComplete) {
            return { height: ($('.journal-entry-grid-wrapper').height()) + "px" };
        }
        else {
            return { height: 0 + "px" };
        }
    };

    $scope.toggleErrorTab = function () {
        $scope.ImportErrorTag = !$scope.ImportErrorTag;

        // topIcon and content-resize gapBottom 15px
        if (!$scope.ImportErrorTag) {
            setErrorWrapCssDefault();
        } else {

            if (parseInt($('#content-resizer').css('bottom')) < 100) {
                $('#content-resizer').css('bottom', '150px');

                $('#topIcon').css({ bottom: '-381px' });

                $('.error-info-wrapper').css('height', '150px');
            }
        }
    };

    var setErrorWrapCssDefault = function () {
        $('#content-resizer').css('bottom', '5px');

        $('#topIcon').css({ bottom: '-551px' });

        $('.error-info-wrapper').css('height', '0px');
    };

    $scope.getErrorGridHeight = function () {
        if ($scope.isLoadComplete) {
            var y = $("#error-info-wrapper").height();

            // Enough space
            if (y > constant.UIGrid.gapHeight) {
                y = y - constant.UIGrid.gapHeight;
                return { height: y + "px" };
            } else {

                return { height: '0px' };
            }
        }

        return {};
    };

    //获取当前导入状态（0：未导入，1：TB已导入，2:财务数据已导入）
    //如果状态为0，则提示需要先导入TB，不能导入
    //如果状态为1，则表示可以导入
    //如果状态为2，则提示财务数据已导入，不能导入
    var getImportType = function () {
        var deferred = $q.defer();
        $scope.importStatus = 0;

        vatImportService.getImportType(projectID, curPeriod).success(function (result) {
            if (result) {
                $scope.importStatus = result;
            }
            deferred.resolve();
        });

        return deferred.promise;
    };


    //显示图标
    var errorLevelToString = function (errorLevel) {
        if (errorLevel === 0) {
            return '/app-resources/images/vat/error.png';
        }
        if (errorLevel === 1) {
            return '/app-resources/images/vat/warning.png';
        }
        if (errorLevel === 2) {
            return '/app-resources/images/vat/tips.png';
        }
        else {
            return '/app-resources/images/vat/tips.png';
        }
    };

    //显示分录明细
    var showJournalEntryModal = function (typeid, items) {
        var data = JSON.parse(items);
        $scope.devgridDataSource = data;
        //组装列
        var columns = [];
        columns.push({ caption: $translate.instant('JournalPZRQ'), dataField: "Date", dataType: "date", width: 100 });
        //如果期间不为null，则加入期间列
        if (data[0].Period != null) {
            columns.push({ caption: $translate.instant('JournalQJ'), dataField: "Period", width: 50 });
        }
        columns.push({ caption: $translate.instant('JournalPZLX'), dataField: "Group", width: 160 },
                     { caption: $translate.instant('JournalPZH'), dataField: "VID", width: 130 },
                     { caption: $translate.instant('JournalKMDM'), dataField: "AcctCode", width: 100 });
        //如果摘要不为null，则加入摘要列
        if (data[0].Summary != null) {
            columns.push({ caption: $translate.instant('JournalZY'), dataField: "Summary", width: 150 });
        }
        columns.push({ caption: $translate.instant('JournalJFJE'), dataField: "Debit", format: { type: 'fixedPoint', precision: 2 }, width: 100 },
                     { caption: $translate.instant('JournalDFJE'), dataField: "Credit", format: { type: 'fixedPoint', precision: 2 }, width: 100 },
                     { caption: $translate.instant('JournalKHDM'), dataField: "CustomerCode", width: 100 },
                     { caption: $translate.instant('JournalFLH'), dataField: "ItemID", width: 70 });


        //如果不是重复数据，就展示普通明细弹出框，否则就显示重复数据明细弹出框
        if (typeid !== 52) {
            $scope.gridJournalEntryItemGridOptions = {
                columns: columns,
                selection: {
                    mode: "single"
                },
                bindingOptions: {
                    "dataSource": "devgridDataSource"
                },
                scrolling: {
                    mode: "standard",
                    showScrollbar: "always"
                },
                hoverStateEnabled: true,
                paging: {
                    pageSize: 10
                }
            }
            $('#jounarEntryItemModal').modal('show');
        }
        else {
            $scope.deferStatus = true;
            $scope.filterCondition = ["IsDuplicate", "=", true];

            $scope.gridJournalEntryDuplicateItemGridOptions = {
                columns: columns,
                bindingOptions: {
                    "dataSource.store.data": "devgridDataSource",
                    "selection.deferred": "deferStatus",
                    "selectionFilter": "filterCondition"
                },
                dataSource: {
                    store: {
                        type: "array",
                        key: 'VoucherID'
                    }
                },
                selection: {
                    selectAllMode: "allPages",
                    showCheckBoxesMode: "always",
                    mode: "multiple"
                },
                scrolling: {
                    mode: "standard",
                    showScrollbar: "always"
                },
                hoverStateEnabled: true,
                paging: {
                    pageSize: 10
                }
            }

            $('#jounarEntryDuplicateItemModal').modal('show');
        }
    };


    //删除重复数据
    //var deleteDuplicateData = function () {
    //    var dataGrid = $('#gridJournalEntryDuplicateItemGrid').dxDataGrid("instance");

    //    var deleteList = [];
    //    dataGrid.getSelectedRowsData().done(function (rowData) {
    //        for (var i = 0; i < rowData.length; i++) {
    //            deleteList.push(rowData[i].AcctCode);
    //        }
    //    });



    //    dataGrid.getSelectedRowKeys().done(function (keys) {
    //        if (keys && keys.length === 0) {
    //            SweetAlert.warning($translate.instant('DeleteEmptyWarning'));
    //            return;
    //        }

    //        logDto.ID = PWC.newGuid();
    //        logDto.CreateTime = new Date();
    //        logDto.UpdateTime = new Date();
    //        logDto.OperationContent = deleteList.join(",");
    //        logDto.OperationName = $translate.instant('DeleteDuplicateData');
    //        logDto.OperationType = enums.vatLogOperationTypeEnum.DeleteDuplicate;

    //        vatImportService.deleteJournalEntryData(keys).success(function (data) {
    //            if (data && data.result) {
    //                //删除数据后重新校验
    //                vatImportService.validateJournalEntryData(curPeriod).success(function () {
    //                    logDto.UpdateState = $translate.instant('DeleteSuccess');
    //                    vatOperationLogService.addOperationLog(logDto);

    //                    loadJournalEntryDataFromDB();
    //                    $('#jounarEntryDuplicateItemModal').modal('hide');
    //                    SweetAlert.success($translate.instant('DeleteSuccess'));
    //                    //获取错误列表信息
    //                    getValidationList().then(function () {
    //                        if ($scope.errorList.length > 0) {
    //                            showErrTab();
    //                            $scope.toggleErrorTab();

    //                            //当有错误信息时，显示错误信息表
    //                            $scope.showErrorTable = true;
    //                        }
    //                        else {
    //                            $scope.ImportErrorTab = false;
    //                            $scope.ImportErrorTag = false;
    //                        }
    //                    });

    //                });
    //            }
    //        }).error(function () {
    //            logDto.UpdateState = $translate.instant('DeleteFailed');
    //            vatOperationLogService.addOperationLog(logDto);
    //            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
    //        });
    //    });


    //};

    //清空当期数据
    var clearJournalEntryData = function () {
        swal({
            title: "warning!",
            text: $translate.instant('JournalEntryClearTips'),
            type: "warning",
            showCancelButton: true,
            confirmButtonColor: "#DD6B55",
            confirmButtonText: $translate.instant('Yes'),
            cancelButtonText: $translate.instant('No'),
            closeOnConfirm: true,
            closeOnCancel: true
        }, function (isConfirm) {
            if (isConfirm) {
                logDto.ID = PWC.newGuid();
                logDto.CreateTime = new Date();
                logDto.UpdateTime = new Date();
                logDto.OperationContent = '';
                logDto.OperationName = $translate.instant('ClearTrialBalance');
                logDto.OperationType = enums.vatLogOperationTypeEnum.ClearData;

                vatImportService.clearJournalEntryData(curPeriod).success(function (data) {
                    if (data && data.result) {
                        logDto.UpdateState = $translate.instant('ClearSuccess');
                        vatOperationLogService.addOperationLog(logDto);
                        vatCommonService.clearProjectStatus(projectDbName, curPeriod
                                                           , constant.DictionaryDictKey.WFImportJournalEntry
                                                           , enums.FinishStatusEnum.NotFinished);
                        vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isEntryImport, false);
                        $log.debug("clear entry clearJournalEntryData: " + vatSessionService.project.importSubStatus.isEntryImport);
                        SweetAlert.success($translate.instant('ClearSuccess'));
                        loadJournalEntryDataFromDB();
                        $scope.isShowImportTotalBtn = true;
                    } else {
                        logDto.UpdateState = $translate.instant('ClearFailed');
                        vatOperationLogService.addOperationLog(logDto);

                        SweetAlert.warning($translate.instant('ClearFailed'));
                    }
                }).error(function () {
                    logDto.UpdateState = $translate.instant('ClearFailed');
                    vatOperationLogService.addOperationLog(logDto);

                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                });
            }
        });
    };

    //刷新数据，实质是重新校验数据
    //var refreshJournalEntryData = function () {
    //    logDto.ID = PWC.newGuid();
    //    logDto.CreateTime = new Date();
    //    logDto.UpdateTime = new Date();
    //    logDto.OperationContent = '';
    //    logDto.OperationName = $translate.instant('RefreshValidationData');
    //    logDto.OperationType = enums.vatLogOperationTypeEnum.Refresh;

    //    vatImportService.validateJournalEntryData(curPeriod).success(function () {
    //        logDto.UpdateState = $translate.instant('RefreshSuccess');
    //        vatOperationLogService.addOperationLog(logDto);

    //        loadJournalEntryDataFromDB();
    //        //获取错误列表信息
    //        getValidationList().then(function () {
    //            if ($scope.errorList.length > 0) {
    //                showErrTab();
    //                $scope.toggleErrorTab();

    //                //当有错误信息时，显示错误信息表
    //                $scope.showErrorTable = true;
    //            }
    //            else {
    //                $scope.ImportErrorTab = false;
    //                $scope.ImportErrorTag = false;
    //            }
    //        });

    //    }).error(function () {
    //        logDto.UpdateState = $translate.instant('RefreshTbFail');
    //        vatOperationLogService.addOperationLog(logDto);

    //        SweetAlert.error($translate.instant('PleaseContactAdministrator'));
    //    });;
    //};

    //日志
    var showOperateLogPop = function () {
        $scope.isShowLog = true;
    };


    (function initialize() {
        $log.debug('VatImportJournalEntryController.ctor()...');

        $scope.errorMsgMap = [];
        $scope.journalEntryFileName = '';
        $scope.selectedColumnMap = [];
        $scope.journalEntryColumns = [];
        $scope.initJournalEntryColumnsIndex = [];
        $scope.startRowList = [];
        $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
        $scope.sheetInfo = { selectedSheetName: '', selectedSheetIndex: 0, topRowNumber: 0 };
        $scope.isShowImportTotalBtn = true;

        //initColumns();

        loadJournalEntryDataFromDB();

        $scope.changeJournalEntrySheet = changeJournalEntrySheet;

        //$scope.mappingColumn = mappingColumn;

        ////$scope.importJournalEntryData = importJournalEntryData;

        //$scope.errorLevelToString = errorLevelToString;

        //$scope.showJournalEntryModal = showJournalEntryModal;

        //$scope.deleteDuplicateData = deleteDuplicateData;

        //$scope.clearJournalEntryData = clearJournalEntryData;

        //$scope.refreshJournalEntryData = refreshJournalEntryData;

        //$scope.showOperateLogPop = showOperateLogPop;


        $scope.gridOptionsJournalEntry = {
            enableColumnResizing: true,
            rowHeight: constant.UIGrid.rowHeight,
            enableSorting: false,
            enableColumnMenus: false,
            flatEntityAccess: true,
            onRegisterApi: function (gridApi) {
                $scope.gridApi = gridApi;

                $interval(function () {
                    $scope.gridApi.core.handleWindowResize();
                }, 500, 60 * 60 * 8);
            }
        };

        $scope.$watch('journalEntryFileName', function (newValue, oldValue) {
            if (newValue && newValue !== oldValue) {
                updateJournalEntryFileName(newValue);
                doUploadJournalEntryFile($scope.journalEntryFileName);
                $scope.ImportErrorTab = false;
                $scope.ImportErrorTag = false;
                $('#StartRowNum').val('2');
                //$scope.ImportFlag = true;
            }
        });

        $timeout(function () {
            $scope.isLoadComplete = true;
        }, 500);
    })();
}]);