﻿invoiceModule.controller('invoiceManageMainUploadPaperInvoiceController', ['$scope', '$log', '$document', '$uibModal', 'SweetAlert', '$translate', '$q', 'apiInterceptor', '$interval', 'region', '$timeout', 'InvoiceManageService',
        function ($scope, $log, $document, $uibModal, SweetAlert, $translate, $q, apiInterceptor, $interval, region, $timeout, InvoiceManageService) {
            'use strict';


            //分页的设置
            $scope.pagingOptions = {
                pageIndex: 1,  //当前页码
                totalItems: 100,  //总数据
                totalPages: 10,//总页数
                maxSize: 10, //分页数字的限制。
                pageSize: constant.page.pageSizeArrary[1],  //每页多少条数据 
                pageSizeString: constant.page.pageSizeArrary[1].toString(),
                firstPage: $translate.instant('PagingFirstPage'),
                previousPage: $translate.instant('PagingPreviousPage'),
                nextPage: $translate.instant('PagingNextPage'),
                lastPage: $translate.instant('PagingLastPage'),
            };

            $scope.searchFilterOptions = [];
            $scope.searchEntity = [];

            $scope.translated = {
                NoData: $translate.instant('NoDataText'),
                pleaseSelect: $translate.instant("ChoosePlaceholder"),
                pleaseInput: $translate.instant('InputPlaceholder'),
            };


            //内部处理
            var memoryService = {
                //发票来源列表构造
                populateInvoiceSourceTypList: function () {
                    $scope.searchFilterOptions.invoiceSourceList = memoryService.translateEnumValue(constant.inputInvoice.invoiceSourceTypeArray);
                },

                repaintInvoiceGrid: function () {
                    $scope.setInvoiceGridHeight();
                },
                //翻译查询的数据源
                translateEnumValue: function (data) {
                    if (!data || data.length == 0) return null;

                    data.forEach(function (item) {
                        item.value = $translate.instant(item.value);
                    });
                    return data;
                },
                //分页下拉
                populatePagingSelection: function () {
                    var pagingSelection = [];
                    var pageArray = constant.page.pageSizeArrary;
                    for (var i = 0 ; i < pageArray.length; i++) {
                        var selection = { id: pageArray[i], value: pageArray[i] };
                        pagingSelection.push(selection);
                    }
                    $scope.pagingOptions.pagingSelection = pagingSelection;
                },
            };


            
            //搜索框初始化
            var initControlsOptions = function () {

                var valueExpr = "id";
                var displayExpr = "value";

                var isShowClearButton = false;

                $scope.searchEntityOptions = {
                    selectinvoiceSourceTypeOptions: {
                        displayExpr: displayExpr,
                        valueExpr: valueExpr,
                        bindingOptions: {
                            value: 'searchEntity.invoiceSourceType',
                            dataSource: 'searchFilterOptions.invoiceSourceList'
                        },
                        onValueChanged: function (data) {
                            $scope.showPoOptions = false;
                            $scope.showStaffOptions = false;
                            if (data.value == constant.inputInvoice.invoiceSourceType.InvoiceNonRawMaterialPurchase.id)
                            {
                                $scope.showPoOptions = true;
                            }
                            else if (data.value == constant.inputInvoice.invoiceSourceType.InvoiceClaim.id) {
                                $scope.showStaffOptions = true;
                            }
                        },
                        placeholder: $scope.translated.pleaseSelect,
                        showClearButton: isShowClearButton,
                        noDataText: $scope.translated.NoData,
                    },
                    //全选
                    checkAllOptions: {
                        onValueChanged: function (e) {
                            var row = e.model.template;
                            if (row) {
                                row.isCheckAll = e.value;
                                row.currentInvoiceList.forEach(function (item) {
                                    item.isCheckAll = e.value;
                                });
                            }
                            console.log(e.element);
                        }
                    },
                    //员工编号
                    staffIdOPtions: {
                        bindingOptions: {
                            value: 'searchEntity.staffID',
                        },
                        placeholder: $scope.pleaseInput,
                        showClearButton: isShowClearButton,
                    },
                    //po number
                    PoNumberOptions: {
                        bindingOptions: {
                            value: 'searchEntity.poNumber',
                        },
                        placeholder: $scope.pleaseInput,
                        showClearButton: isShowClearButton,
                    }
                };
            };

            //完成上传
            $scope.uploadToServer = function () {
                $scope.uploadInvoiceList;
            };

              var initInvoiceList = function () {
                  $scope.uploadInvoiceList = [];

                for (var i = 0; i < 10; i++)
                {
                    var currentInvoiceList = [];

                    for (var j = 0 ; j < 10; j++) {
                        currentInvoiceList.push({ id: j, value: 'invoice' + j });
                    }

                    var invoice = {
                        id: i,
                        value: i + ' invoice',
                        isCheckAll: false,
                        currentInvoiceList: currentInvoiceList
                    }
                    $scope.uploadInvoiceList.push(invoice);

                }
            };
       

            (function initialize() {
                $log.debug('invoiceManageMainUploadPaperInvoice.ctor()...');
                initInvoiceList();
                initControlsOptions();
                memoryService.populateInvoiceSourceTypList();
            })();
        }
]);
