﻿invoiceModule.directive('outputInvoiceInfrastructure', ['$log', '$rootScope', '$timeout', 'enums',
    function ($log, $rootScope, $timeout, enums) {
        'use strict';

        $log.debug('invoiceInfrastructure.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/output-invoice/infrastructure/output-invoice-infrastructure.html' + '?_=' + Math.random(),
            replace: true,
            scope: {
                state: '='
            },
            controller: 'outputInvoiceInfrastructureController',
            link: function ($scope, $element, $attr) {

                Split(['#vat-report-nav-menu', '#vat-report-content'], {
                    sizes: [15, 85],
                    minSize: [10, 1330],
                    onDragEnd: function () {
                        $timeout(function () {
                            $rootScope.$broadcast(enums.vatEvent.layoutChanged, {});
                        }, 700);
                    }
                })


                $scope.isCollapsed = false;
            }
        };
    }
]);